>Table ~DIRECTORYID..PSTARCVFILE
>CREATE TABLE ~DIRECTORYID..PSTARCVFILE
>       (ARCHIVEID           INTEGER        NOT NULL,
>        ARCVFILENAME        VARCHAR(250)   NOT NULL,
>        INDXFILENAME        VARCHAR(250)   NOT NULL,
>        BRSXFILENAME        VARCHAR(250)   NOT NULL,
>        ADUPFILENAME        VARCHAR(250)   NOT NULL,
>        ARCVMEDIAFMT        CHAR(1)        NOT NULL,
>        INDXMEDIAFMT        CHAR(1)        NOT NULL,
>        BRSXMEDIAFMT        CHAR(1)        NOT NULL,
>        ARCVDUPMDFMT        CHAR(1)        NOT NULL,
>        DATETIMEOFARCHIVE   CHAR(19)       NOT NULL,
>        GROUPNAME           VARCHAR(8)     NOT NULL,
>        USERID              VARCHAR(30)    NOT NULL,
>        SERVNAME            VARCHAR(15)    NOT NULL,
>        DESCR               VARCHAR(128)   NOT NULL,
>        STATUS              CHAR(1)        NOT NULL,
>        OPTIONS             VARCHAR(254)   NOT NULL,
>        OPTIONS2            VARCHAR(254)   NOT NULL,
>        GUID                CHAR(38)       NOT NULL,
>       CONSTRAINT PSTARCVFILE_PK
>        PRIMARY KEY
>       (ARCHIVEID)) ORGANIZE BY ROW
>        ~TSARCFILE>
>Table ~DIRECTORYID..PSTARCVSEG
>CREATE TABLE ~DIRECTORYID..PSTARCVSEG
>       (ARCHIVEID           INTEGER        NOT NULL,
>        SEGMENTTYPE         CHAR(1)        NOT NULL,
>        SEGMENTID           INTEGER        NOT NULL,
>        ARCVMEDIAFMT        CHAR(1)        NOT NULL,
>        SEGFILENAME         VARCHAR(250)   NOT NULL,
>        SRVSHARENAME        VARCHAR(250)   NOT NULL,
>        OPTIONS             VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTARCVSEG_PK
>        PRIMARY KEY
>       (ARCHIVEID,
>        SEGMENTTYPE,
>        SEGMENTID)) ORGANIZE BY ROW
>        ~TSARCSEG>
>Table ~DIRECTORYID..PSTARCVTBL
>CREATE TABLE ~DIRECTORYID..PSTARCVTBL
>       (ARCHIVEID           INTEGER        NOT NULL,
>        TABLEDBALIAS        VARCHAR(12)    NOT NULL,
>        TABLECREATORID      VARCHAR(64)    NOT NULL,
>        TABLENAME           VARCHAR(64)    NOT NULL,
>        TABLEID             INTEGER        NOT NULL,
>        STARTTABLEFLAG      CHAR(1)        NOT NULL,
>        SEQNO               INTEGER        NOT NULL,
>        CHECKSUM            INTEGER        NOT NULL,
>        TABLEDATA1          VARCHAR(254)   NOT NULL,
>        TABLEDATA2          VARCHAR(254)   NOT NULL,
>        TABLEDATA3          VARCHAR(254)   NOT NULL,
>        TABLEDATA4          VARCHAR(254)   NOT NULL,
>        TABLEDATA5          VARCHAR(254)   NOT NULL,
>        TABLEDATA6          VARCHAR(254)   NOT NULL,
>        TABLEDATA7          VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTARCVTBL_PK
>        PRIMARY KEY
>       (ARCHIVEID,
>        TABLEID,
>        SEQNO)) ORGANIZE BY ROW
>        ~TSARCTABLE>
>Table ~DIRECTORYID..PSTAUDIT
>CREATE TABLE ~DIRECTORYID..PSTAUDIT
>       (DBALIAS           VARCHAR(12)          NOT NULL,
>        CREATORID         VARCHAR(64)          NOT NULL,
>        TABLENAME         VARCHAR(64)          NOT NULL,
>        TYPE              CHAR(1)              NOT NULL,
>        USERID            VARCHAR(30)          NOT NULL,
>        ACTION_DATETIME   TIMESTAMP   DEFAULT  NOT NULL,
>        SEQ_NUMBER        DECIMAL(15,0)        NOT NULL,
>        SUBSEQ_NUMBER     INTEGER              NOT NULL,
>        AUDIT_DATA        VARCHAR(1750)        NOT NULL,
>       CONSTRAINT PSTAUDIT_PK
>        PRIMARY KEY
>       (DBALIAS,
>        CREATORID,
>        TABLENAME,
>        SEQ_NUMBER,
>        SUBSEQ_NUMBER)) ORGANIZE BY ROW
>        ~TSAUDIT>
>Table ~DIRECTORYID..PSTDBA
>CREATE TABLE ~DIRECTORYID..PSTDBA
>       (DBALIAS_NAME      CHAR(12)       NOT NULL,
>        DBMS_TYPE         CHAR(1)        NOT NULL,
>        DESCRIPTION       VARCHAR(128)   NOT NULL,
>        CONNECT_STRING    VARCHAR(128)   NOT NULL,
>        QUALIFIER         CHAR(64)       NOT NULL,
>        DIRDB             CHAR(1)        NOT NULL,
>        MOD_USERID        VARCHAR(30)    NOT NULL,
>        MOD_DATETIME      CHAR(19)       NOT NULL,
>        OPTIONS1          VARCHAR(254)   NOT NULL,
>        OPTIONS2          VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTDBA_PK
>        PRIMARY KEY
>       (DBALIAS_NAME)) ORGANIZE BY ROW
>        ~TSDBALIAS>
>Table ~DIRECTORYID..PSTOBJ
>CREATE TABLE ~DIRECTORYID..PSTOBJ
>       (OBJ_ID            VARCHAR(8)     NOT NULL,
>        OBJ_NAME          VARCHAR(12)    NOT NULL,
>        OBJ_TYPE          CHAR(1)        NOT NULL,
>        DESCRIPTION       VARCHAR(40)    NOT NULL,
>        MOD_USERID        VARCHAR(30)    NOT NULL,
>        MOD_DATETIME      CHAR(19)       NOT NULL,
>        CHECK_SUM         SMALLINT       NOT NULL,
>        SEQNO             SMALLINT       NOT NULL,
>        DEFINITION1       VARCHAR(254)   NOT NULL,
>        DEFINITION2       VARCHAR(254)   NOT NULL,
>        DEFINITION3       VARCHAR(254)   NOT NULL,
>        DEFINITION4       VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTOBJ_PK
>        PRIMARY KEY
>       (OBJ_ID,
>        OBJ_NAME,
>        OBJ_TYPE,
>        SEQNO)) ORGANIZE BY ROW
>        ~TSOBJ>
>Table ~DIRECTORYID..PSTPK
>CREATE TABLE ~DIRECTORYID..PSTPK
>       (DBALIAS_NAME      VARCHAR(12)    NOT NULL,
>        CREATOR_ID        VARCHAR(64)    NOT NULL,
>        TABLE_NAME        VARCHAR(64)    NOT NULL,
>        DESCRIPTION       VARCHAR(40)    NOT NULL,
>        MOD_USERID        VARCHAR(30)    NOT NULL,
>        MOD_DATETIME      CHAR(19)       NOT NULL,
>        CHECK_SUM         SMALLINT       NOT NULL,
>        SEQNO             SMALLINT       NOT NULL,
>        STRUCT_ID         CHAR(4)        NOT NULL,
>        OPTIONS1          VARCHAR(254)   NOT NULL,
>        NUM_COL           SMALLINT       NOT NULL,
>        DEFINITION1       VARCHAR(254)   NOT NULL,
>        DEFINITION2       VARCHAR(254)   NOT NULL,
>        DEFINITION3       VARCHAR(254)   NOT NULL,
>        DEFINITION4       VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTPK_PK
>        PRIMARY KEY
>       (DBALIAS_NAME,
>        CREATOR_ID,
>        TABLE_NAME,
>        SEQNO)) ORGANIZE BY ROW
>        ~TSPK>
>Table ~DIRECTORYID..PSTPT
>CREATE TABLE ~DIRECTORYID..PSTPT
>       (CTRLDSN           VARCHAR(250)   NOT NULL,
>        DATADSN           VARCHAR(250)   NOT NULL,
>        STATE             SMALLINT       NOT NULL,
>        LASTTYPE          SMALLINT       NOT NULL,
>        LASTACTION        SMALLINT       NOT NULL,
>        USERID            VARCHAR(30)    NOT NULL,
>        TIME              INT            NOT NULL,
>        TABLENUM          SMALLINT       NOT NULL,
>        LUW               SMALLINT       NOT NULL,
>       CONSTRAINT PSTPT_PK
>        PRIMARY KEY
>       (CTRLDSN)) ORGANIZE BY ROW
>        ~TSPT>
>Table ~DIRECTORYID..PSTREL
>CREATE TABLE ~DIRECTORYID..PSTREL
>       (DEP_DBALIAS_NAME  VARCHAR(12)    NOT NULL,
>        DEP_CREATOR_ID    VARCHAR(64)    NOT NULL,
>        DEP_TABLE_NAME    VARCHAR(64)    NOT NULL,
>        REL_NAME          VARCHAR(64)    NOT NULL,
>        TYPE              CHAR(1)        NOT NULL,
>        PAR_DBALIAS_NAME  VARCHAR(12)    NOT NULL,
>        PAR_CREATOR_ID    VARCHAR(64)    NOT NULL,
>        PAR_TABLE_NAME    VARCHAR(64)    NOT NULL,
>        DESCRIPTION       VARCHAR(40)    DEFAULT NULL,
>        MOD_USERID        VARCHAR(30)    DEFAULT NULL,
>        MOD_DATETIME      CHAR(19)       DEFAULT NULL,
>        CHECK_SUM         SMALLINT,
>        SEQNO             SMALLINT       NOT NULL,
>        STRUCT_ID         CHAR(4),
>        OPTIONS1          VARCHAR(254)   DEFAULT NULL,
>        DEFINITION1       VARCHAR(254)   DEFAULT NULL,
>        DEFINITION2       VARCHAR(254)   DEFAULT NULL,
>        DEFINITION3       VARCHAR(254)   DEFAULT NULL,
>        DEFINITION4       VARCHAR(254)   DEFAULT NULL,
>       CONSTRAINT PSTREL_PK
>        PRIMARY KEY
>       (DEP_DBALIAS_NAME,
>        DEP_CREATOR_ID,
>        DEP_TABLE_NAME,
>        TYPE,
>        REL_NAME,
>        SEQNO)) ORGANIZE BY ROW
>        ~TSREL>
>Index ~DIRECTORYID..PSTREL_CID for table ~DIRECTORYID..PSTREL
>CREATE INDEX ~DIRECTORYID..PSTREL_CID
>        ON ~DIRECTORYID..PSTREL
>       (PAR_DBALIAS_NAME,
>        PAR_CREATOR_ID,
>        PAR_TABLE_NAME,
>        TYPE,
>        REL_NAME,
>        SEQNO)>
>Table ~DIRECTORYID..PSTSEC
>CREATE TABLE ~DIRECTORYID..PSTSEC
>       (SEC_NAME1        VARCHAR(30)    NOT NULL,
>        SEC_NAME2        VARCHAR(194)   NOT NULL,
>        SEC_NAME3        VARCHAR(30)    NOT NULL,
>        SEC_TYPE         CHAR(1)        NOT NULL,
>        DESCRIPTION      VARCHAR(40)    NOT NULL,
>        MOD_USERID       VARCHAR(30)    NOT NULL,
>        MOD_DATETIME     CHAR(19)       NOT NULL,
>        CHECK_SUM        INTEGER        NOT NULL,
>        SEQNO            INTEGER        NOT NULL,
>        OPTIONS1         VARCHAR(30)    NOT NULL,
>        OPTIONS2         VARCHAR(30)    NOT NULL,
>        DEFINITION1      VARCHAR(254)   NOT NULL,
>        DEFINITION2      VARCHAR(254)   NOT NULL,
>        DEFINITION3      VARCHAR(254)   NOT NULL,
>        DEFINITION4      VARCHAR(254)   NOT NULL,
>        DEFINITION5      VARCHAR(254)   NOT NULL,
>        DEFINITION6      VARCHAR(254)   NOT NULL,
>       CONSTRAINT PSTSEC_PK
>        PRIMARY KEY
>       (SEC_NAME1,
>        SEC_NAME2,
>        SEC_TYPE,
>        SEQNO)) ORGANIZE BY ROW
>        ~TSSEC>
