>DROP VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW
>DROP VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW>
>VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW
>CREATE VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW AS
>SELECT X.FILE_GUID, T.SERVER, T.FILE_NAME, T.DATA_BYTE_COUNT, T.ROWS_EXTRACTED, T.ENTITIES, T.CREATION_DATE, 
>T.CREATION_USER, T.SERVICE_NAME, T.ACCESS_DEFINITION, T.STORAGE_PROFILE,T.TOTAL_SIZE,T.UNCOMPRESSED_FILE_SIZE,
>T.COMPRESSION_RATIO,T.IS_SECURED,T.IS_ENCRYPTED ,T.IS_COMPRESSED,T.DESCRIPTION
>FROM ~DIRECTORYID..OPTIM_FILE_CATALOG X,  ~DIRECTORYID..OPTIM_TRANSACTION_CONTENT Y,
>XMLTABLE('$c/*:fileMeta' PASSING Y.XMLDATA AS "c"
>COLUMNS FILE_NAME VARGRAPHIC(500) path '*:archiveFile/@name', 
>             DATA_BYTE_COUNT VARCHAR(50) path '*:archiveFile/@dataByteCount',  
>             ROWS_EXTRACTED INTEGER path '*:archiveFile/@totalRecords', 
>             ENTITIES INTEGER path '*:archiveFile/@entityCount',  
>             CREATION_USER VARGRAPHIC(50) path '*:archiveFile/@createdBy',
>             CREATION_DATE TIMESTAMP path '*:archiveFile/@creationDate',
>             SERVICE_NAME VARGRAPHIC(128) path '*:archiveFile/@requestName', 
>             ACCESS_DEFINITION VARCHAR(128) path '*:accessDefinition/@name', 
>             STORAGE_PROFILE VARCHAR(50) path '*:ilg/@storageProfile', 
>             SERVER VARCHAR(255) path '*:archiveFile/@serverName',
>             TOTAL_SIZE INTEGER path '*:archiveFile/@totalSizeInBytes', 
>             UNCOMPRESSED_FILE_SIZE INTEGER path '*:archiveFile/@uncompressedFileSize',
>             COMPRESSION_RATIO INTEGER path '*:archiveFile/@compressionRatio',
>             IS_SECURED VARCHAR(5)  path '*:archiveFile/@secured',
>             IS_ENCRYPTED VARCHAR(5)  path '*:archiveFile/@encrypted',
>             IS_COMPRESSED VARCHAR(5) path '*:archiveFile/@compressed',
>             DESCRIPTION VARCHAR(255) path '*:archiveFile/@description') AS T
>WHERE X.FILE_GUID=Y.ID AND X.FILE_TYPE='V'>