>DROP VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW
>DROP VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW>
>VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW
>CREATE VIEW ~DIRECTORYID..OPTIM_DATA_CONSUMPTION_VIEW AS
>SELECT X.FILE_GUID, T.SERVER, T.FILE_NAME, T.DATA_BYTE_COUNT, T.ROWS_EXTRACTED, T.ENTITIES, T.CREATION_DATE, T.CREATION_USER, 
>T.SERVICE_NAME, T.ACCESS_DEFINITION, T.STORAGE_PROFILE,T.TOTAL_SIZE,T.UNCOMPRESSED_FILE_SIZE,
>T.COMPRESSION_RATIO,T.IS_SECURED,T.IS_ENCRYPTED ,T.IS_COMPRESSED,T.DESCRIPTION
>FROM ~DIRECTORYID..OPTIM_FILE_CATALOG X,  ~DIRECTORYID..OPTIM_TRANSACTION_CONTENT Y,
>     XMLTABLE(XMLNAMESPACES('http://www.ibm.com/optim/fileMeta/v11.3.0.0' AS "ns1"),
>     '/ns1:fileMeta' PASSING Y.XMLDATA
>     COLUMNS FILE_NAME NVARCHAR2(500) path 'ns1:archiveFile/@name', 
>             DATA_BYTE_COUNT VARCHAR(50) path 'ns1:archiveFile/@dataByteCount',  
>             ROWS_EXTRACTED NUMBER path 'ns1:archiveFile/@totalRecords', 
>             ENTITIES NUMBER path 'ns1:archiveFile/@entityCount',  
>             CREATION_USER NVARCHAR2(50) path 'ns1:archiveFile/@createdBy',
>             CREATION_DATE TIMESTAMP path 'ns1:archiveFile/@creationDate',  
>             SERVICE_NAME NVARCHAR2(128) path 'ns1:archiveFile/@requestName', 
>             ACCESS_DEFINITION NVARCHAR2(128) path 'ns1:accessDefinition/@name', 
>             STORAGE_PROFILE NVARCHAR2(50) path 'ns1:ilg/@storageProfile',
>             SERVER VARCHAR2(255) path 'ns1:archiveFile/@serverName',
>             TOTAL_SIZE NUMBER path 'ns1:archiveFile/@totalSizeInBytes', 
>             UNCOMPRESSED_FILE_SIZE NUMBER path 'ns1:archiveFile/@uncompressedFileSize',
>             COMPRESSION_RATIO NUMBER path 'ns1:archiveFile/@compressionRatio',
>             IS_SECURED VARCHAR2(5)  path 'ns1:archiveFile/@secured',
>             IS_ENCRYPTED VARCHAR2(5)  path 'ns1:archiveFile/@encrypted',
>             IS_COMPRESSED VARCHAR2(5) path 'ns1:archiveFile/@compressed',
>             FILE_GUID VARCHAR2(38) path 'ns1:archiveFile/@fileGUID',
>             DESCRIPTION VARCHAR2(255) path 'ns1:archiveFile/@description') AS T
>WHERE X.FILE_GUID=Y.ID AND X.FILE_TYPE='V'>