`TABLE ~DPID..OPTIM_JP_ADDRESSES
`CREATE TABLE ~DPID..OPTIM_JP_ADDRESSES
` ( SEQ INTEGER NOT NULL,
`     ZIPCODE CHAR(7)NOT NULL,
`   PREFECTURE VARCHAR(30),
`   CITY  VARCHAR(30) NOT NULL,
`   ADDRESS1  VARCHAR(36) NOT NULL,
`   ADDRESS2  VARCHAR(42),
`     PREFECTURE_RM VARCHAR(30),
`     CITY_RM  VARCHAR(60),
`     ADDRESS1_RM  VARCHAR(72),
`     ADDRESS2_RM  VARCHAR(42),
`   PREFECTURE_KF VARCHAR(24),
`   CITY_KF  VARCHAR(60),
`     ADDRESS1_KF  VARCHAR(72),
`     ADDRESS2_KF  VARCHAR(84),
`     PREFECTURE_KH VARCHAR(24),
`     CITY_KH  VARCHAR(90),
`   ADDRESS1_KH  VARCHAR(108),
`     ADDRESS2_KH  VARCHAR(84),
`   CONSTRAINT U_JP_ADDRESSES UNIQUE (ADDRESS1,CITY,ZIPCODE),
`     CONSTRAINT PK_JP_ADDRESSES PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_PERSON
`CREATE TABLE ~DPID..OPTIM_JP_PERSON
` ( SEQ INTEGER NOT NULL,
`     ID CHAR(6),
`     FIRSTNAME VARCHAR(30) NOT NULL,
`        LASTNAME VARCHAR(30) NOT NULL,
`     COMPANY VARCHAR(40),
`     RESIDENTID CHAR(11),
`     SEX CHAR(3) NOT NULL,
`     PHONE CHAR(30) NOT NULL ,
`     BIRTHDATE DATE  NOT NULL ,
`     EMAIL_ADDRES VARCHAR(50),
`     FIRSTNAME_RM VARCHAR(30),
`     FIRSTNAME_KF VARCHAR(30),
`     FIRSTNAME_KH VARCHAR(30),
`     LASTNAME_RM VARCHAR(30),
`     LASTNAME_KF VARCHAR(30),
`     LASTNAME_KH VARCHAR(30),
`   CONSTRAINT U_JP_PERSON UNIQUE (FIRSTNAME, LASTNAME, SEX, PHONE, BIRTHDATE),
`     CONSTRAINT PK_JP_PERSON PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_FIRSTNAME
`CREATE TABLE ~DPID..OPTIM_JP_FIRSTNAME
` ( SEQ INTEGER NOT NULL,
`   FIRSTNAME VARCHAR(30) NOT NULL,
`     FIRSTNAME_RM VARCHAR(30),
`     FIRSTNAME_KF VARCHAR(30),
`     FIRSTNAME_KH VARCHAR(30),
`   CONSTRAINT U_JP_FIRSTNAME UNIQUE (FIRSTNAME),
`     CONSTRAINT PK_JP_FIRSTNAME PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_FIRSTNAME_F
`CREATE TABLE ~DPID..OPTIM_JP_FIRSTNAME_F
` ( SEQ INTEGER NOT NULL,
`     FIRSTNAME VARCHAR(30) NOT NULL,
`     FIRSTNAME_RM VARCHAR(30),
`     FIRSTNAME_KF VARCHAR(30),
`     FIRSTNAME_KH VARCHAR(30),
`     CONSTRAINT U_JP_FIRSTNAME_F UNIQUE (FIRSTNAME),
`     CONSTRAINT PK_JP_FIRSTNAME_F PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_FIRSTNAME_M
`CREATE TABLE ~DPID..OPTIM_JP_FIRSTNAME_M
` ( SEQ INTEGER NOT NULL,
`     FIRSTNAME VARCHAR(30) NOT NULL,
`     FIRSTNAME_RM VARCHAR(30),
`     FIRSTNAME_KF VARCHAR(30),
`     FIRSTNAME_KH VARCHAR(30),
`     CONSTRAINT U_JP_FIRSTNAME_M UNIQUE (FIRSTNAME),
`     CONSTRAINT PK_JP_FIRSTNAME_M PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_LASTNAME
`CREATE TABLE ~DPID..OPTIM_JP_LASTNAME
` ( SEQ INTEGER NOT NULL,
`     LASTNAME VARCHAR(30) NOT NULL,
`     LASTNAME_RM VARCHAR(30),
`     LASTNAME_KF VARCHAR(30),
`     LASTNAME_KH VARCHAR(30),
`     CONSTRAINT U_JP_LASTNAME UNIQUE (LASTNAME),
`     CONSTRAINT PK_JP_LASTNAME PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`TABLE ~DPID..OPTIM_JP_DOMAIN_NAMES
`CREATE TABLE ~DPID..OPTIM_JP_DOMAIN_NAMES
` ( SEQ INTEGER NOT NULL,
`       DOMAIN_NAME VARCHAR(50),
`     CONSTRAINT PK_JP_DOMAIN_NAMES PRIMARY KEY (SEQ)) ORGANIZE BY ROW
`    ~DPTS`
`Grant privileges to TABLE ~DPID..OPTIM_JP_ADDRESSES
`GRANT ALL ON ~DPID..OPTIM_JP_ADDRESSES TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_FIRSTNAME_F
`GRANT ALL ON ~DPID..OPTIM_JP_FIRSTNAME_F  TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_FIRSTNAME_M
`GRANT ALL ON ~DPID..OPTIM_JP_FIRSTNAME_M TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_FIRSTNAME
`GRANT ALL ON ~DPID..OPTIM_JP_FIRSTNAME TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_LASTNAME
`GRANT ALL ON ~DPID..OPTIM_JP_LASTNAME TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_PERSON
`GRANT ALL ON ~DPID..OPTIM_JP_PERSON TO PUBLIC`
`Grant privileges to TABLE ~DPID..OPTIM_JP_DOMAIN_NAMES
`GRANT ALL ON ~DPID..OPTIM_JP_DOMAIN_NAMES TO PUBLIC`



