`Table ~SAMPLEID..OPTIM_SALES
`CREATE TABLE ~SAMPLEID..OPTIM_SALES
`       (SALESMAN_ID       CHAR(6)        NOT NULL,
`        FIRST_NAME        VARCHAR(15)    NOT NULL,
`        LAST_NAME         VARCHAR(15)    NOT NULL,
`        NATIONALITY       VARCHAR(30),
`        NATIONAL_ID       VARCHAR(30),
`        PHONE_NUMBER      VARCHAR(20)    NOT NULL,
`        AGE               SMALLINT        NOT NULL WITH DEFAULT,
`        SEX               CHAR(1)        NOT NULL WITH DEFAULT,
`        TERRITORY         VARCHAR(14)    NOT NULL,
`        EMAIL_ADDRESS     VARCHAR(70)    NOT NULL,
`        MANAGER_ID        VARCHAR(6)) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_SALES for table ~SAMPLEID..OPTIM_SALES
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_SALES
`        ON ~SAMPLEID..OPTIM_SALES
`       (SALESMAN_ID       ASC)`
`Primary key ~SAMPLEID..OPTIM_SALES
`ALTER TABLE ~SAMPLEID..OPTIM_SALES
`        PRIMARY KEY
`       (SALESMAN_ID)`
`Table ~SAMPLEID..OPTIM_CUSTOMERS
`CREATE TABLE ~SAMPLEID..OPTIM_CUSTOMERS
`       (CUST_ID           CHAR(5)        NOT NULL,
`        CUSTNAME          CHAR(20)       NOT NULL,
`        ADDRESS1          VARCHAR(100) NOT NULL,
`        ADDRESS2          VARCHAR(100),
`        LOCALITY          VARCHAR(56),
`        CITY              VARCHAR(60),
`        STATE             VARCHAR(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        EMAIL_ADDRESS     VARCHAR(70),
`        PHONE_NUMBER      VARCHAR(20),
`        YTD_SALES         DECIMAL(7, 2)  NOT NULL WITH DEFAULT,
`        SALESMAN_ID       CHAR(6),
`        NATIONALITY       VARCHAR(30),
`        NATIONAL_ID       VARCHAR(30),
`        CREDITCARD_NUMBER VARCHAR(19),
`        CREDITCARD_TYPE   VARCHAR(30),
`        CREDITCARD_EXP    CHAR(4),
`        CREDITCARD_CVV    VARCHAR(4),
`        DRIVER_LICENSE    VARCHAR(30),
`        CREDITCARD_HISTORY      CLOB) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_CUST for table ~SAMPLEID..OPTIM_CUSTOMERS
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_CUST
`        ON ~SAMPLEID..OPTIM_CUSTOMERS
`       (CUST_ID           ASC)`
`Primary key for table ~SAMPLEID..OPTIM_CUSTOMERS
`ALTER TABLE ~SAMPLEID..OPTIM_CUSTOMERS
`        PRIMARY KEY
`       (CUST_ID)`
`Relationship RSC between ~SAMPLEID..OPTIM_SALES and ~SAMPLEID..OPTIM_CUSTOMERS
`ALTER TABLE ~SAMPLEID..OPTIM_CUSTOMERS
`        FOREIGN KEY RSC
`        (SALESMAN_ID)
`        REFERENCES ~SAMPLEID..OPTIM_SALES
`        ON DELETE SET NULL`
`Table ~SAMPLEID..OPTIM_ORDERS
`CREATE TABLE ~SAMPLEID..OPTIM_ORDERS
`       (ORDER_ID          DECIMAL(10,0)  NOT NULL,
`        CUST_ID           CHAR(5)        NOT NULL,
`        ORDER_DATE        TIMESTAMP      NOT NULL WITH DEFAULT,
`        ORDER_TIME        TIMESTAMP      NOT NULL WITH DEFAULT,
`        FREIGHT_CHARGES   DECIMAL(4,2),
`        ORDER_SALESMAN    CHAR(6),
`        ORDER_POSTED_DATE TIMESTAMP      NOT NULL WITH DEFAULT,
`        ORDER_SHIP_DATE   CHAR(8)        DEFAULT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_ORDR for table ~SAMPLEID..OPTIM_ORDERS
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_ORDR
`        ON ~SAMPLEID..OPTIM_ORDERS
`       (ORDER_ID          ASC)`
`Primary key ~SAMPLEID..OPTIM_ORDERS
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS
`        PRIMARY KEY
`       (ORDER_ID)`
`Relationship RCO between ~SAMPLEID..OPTIM_CUSTOMERS and ~SAMPLEID..OPTIM_ORDERS
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS
`        FOREIGN KEY RCO
`       (CUST_ID)
`        REFERENCES ~SAMPLEID..OPTIM_CUSTOMERS
`        ON DELETE RESTRICT`
`Table ~SAMPLEID..OPTIM_ITEMS
`CREATE TABLE ~SAMPLEID..OPTIM_ITEMS
`       (ITEM_ID           CHAR(5)        NOT NULL,
`        ITEM_DESCRIPTION  VARCHAR(72)    NOT NULL,
`        CATEGORY          VARCHAR(14)    NOT NULL,
`        RATING            CHAR(4)        NOT NULL,
`        UNIT_PRICE        DECIMAL(5, 2)  NOT NULL,
`        ON_HAND_INVENTORY INTEGER        NOT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_ITEM for table ~SAMPLEID..OPTIM_ITEMS
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_ITEM
`        ON ~SAMPLEID..OPTIM_ITEMS
`       (ITEM_ID           ASC)`
`Primary key ~SAMPLEID..OPTIM_ITEMS
`ALTER TABLE ~SAMPLEID..OPTIM_ITEMS
`        PRIMARY KEY
`        (ITEM_ID)`
`Table ~SAMPLEID..OPTIM_DETAILS
`CREATE TABLE ~SAMPLEID..OPTIM_DETAILS
`       (ORDER_ID          DECIMAL(10, 0)  NOT NULL,
`        ITEM_ID           CHAR(5)         NOT NULL,
`        ITEM_QUANTITY     DECIMAL(10, 0)  NOT NULL,
`        DETAIL_UNIT_PRICE DECIMAL(5, 2)  NOT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_DETL for table ~SAMPLEID..OPTIM_DETAILS
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_DETL
`        ON ~SAMPLEID..OPTIM_DETAILS
`       (ORDER_ID          DESC,
`        ITEM_ID           ASC)`
`Primary key ~SAMPLEID..OPTIM_DETAILS
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS
`        PRIMARY KEY
`       (ORDER_ID,
`        ITEM_ID)`
`Relationship ROD between ~SAMPLEID..OPTIM_ORDERS and ~SAMPLEID..OPTIM_DETAILS
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS
`        FOREIGN KEY ROD
`        (ORDER_ID)
`        REFERENCES ~SAMPLEID..OPTIM_ORDERS
`        ON DELETE CASCADE`
`Relationship RID between ~SAMPLEID..OPTIM_ITEMS and ~SAMPLEID..OPTIM_DETAILS
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS
`        FOREIGN KEY RID
`       (ITEM_ID)
`        REFERENCES ~SAMPLEID..OPTIM_ITEMS
`        ON DELETE RESTRICT`
`Table ~SAMPLEID..OPTIM_SHIP_TO
`CREATE TABLE ~SAMPLEID..OPTIM_SHIP_TO
`       (CUST_ID           CHAR(5)        NOT NULL,
`        SHIP_ID           DECIMAL(10, 0) NOT NULL,
`        ADDRESS1          VARCHAR(100),
`        ADDRESS2          VARCHAR(100),
`        LOCALITY          VARCHAR(56),
`        CITY              VARCHAR(30),
`        STATE             VARCHAR(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        IN_CARE_OF        VARCHAR(31),
`        SHIPPING_CHANGE_DT TIMESTAMP   NOT NULL WITH DEFAULT) ORGANIZE BY ROW
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_FEMALE_RATES
`CREATE TABLE ~SAMPLEID..OPTIM_FEMALE_RATES
`        (AGE              SMALLINT,
`        RATE_PER_1000     DECIMAL(10, 0)) ORGANIZE BY ROW
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_MALE_RATES
`CREATE TABLE ~SAMPLEID..OPTIM_MALE_RATES
`       (AGE               SMALLINT,
`        RATE_PER_1000     DECIMAL(10, 0)) ORGANIZE BY ROW
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_STATE_LOOKUP
`CREATE TABLE ~SAMPLEID..OPTIM_STATE_LOOKUP
`       (DISTRICT          CHAR(2)        NOT NULL,
`        DIST_CODE         CHAR(3)        NOT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_SHIP_INSTR
`CREATE TABLE ~SAMPLEID..OPTIM_SHIP_INSTR
`       (SHIP_ID           DECIMAL(10, 0),
`        SHIP_INSTR_ID     INTEGER,
`        ORDER_SHIP_INSTR  VARCHAR(254),
`        SHIP_UPDATED      TIMESTAMP      NOT NULL WITH DEFAULT) ORGANIZE BY ROW
`        ~SAMPLETS`
`Index ~SAMPLEID..XPK_SHIPI for table ~SAMPLEID..OPTIM_SHIP_INSTR
`CREATE INDEX ~SAMPLEID..XPK_SHIPI
`        ON ~SAMPLEID..OPTIM_SHIP_INSTR
`        (SHIP_INSTR_ID    ASC)`
`Table ~SAMPLEID..OPTIM_CUSTOMERS2
`CREATE TABLE ~SAMPLEID..OPTIM_CUSTOMERS2
`       (CUST_ID           CHAR(5)        NOT NULL,
`        CUSTNAME          VARCHAR(60) NOT NULL,
`        ADDRESS1          VARCHAR(100),
`        ADDRESS2          VARCHAR(100),
`        LOCALITY          VARCHAR(56),
`        CITY              VARCHAR(30),
`        STATE             VARCHAR(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        EMAIL_ADDRESS     VARCHAR(70),
`        PHONE_NUMBER      VARCHAR(20),
`        YTD_SALES         DECIMAL(7, 2)  NOT NULL WITH DEFAULT,
`        SALESMAN_ID       CHAR(6),
`        NATIONALITY       VARCHAR(30),
`        NATIONAL_ID       VARCHAR(30),
`        CREDITCARD_NUMBER VARCHAR(19),
`        CREDITCARD_TYPE   VARCHAR(30),
`        CREDITCARD_EXP    CHAR(4),
`        CREDITCARD_CVV    VARCHAR(30),
`        DRIVER_LICENSE    VARCHAR(30),
`        CREDITCARD_HISTORY      CLOB) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_CUST2 for table ~SAMPLEID..OPTIM_CUSTOMERS2
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_CUST2
`        ON ~SAMPLEID..OPTIM_CUSTOMERS2
`       (CUST_ID           ASC)`
`Primary key for table ~SAMPLEID..OPTIM_CUSTOMERS2
`ALTER TABLE ~SAMPLEID..OPTIM_CUSTOMERS2
`        PRIMARY KEY
`       (CUST_ID)`
`Table ~SAMPLEID..OPTIM_ORDERS2
`CREATE TABLE ~SAMPLEID..OPTIM_ORDERS2
`       (ORDER_ID          DECIMAL(10, 0)  NOT NULL,
`        CUST_ID           CHAR(5)        NOT NULL,
`        ORDER_DATE        TIMESTAMP           NOT NULL WITH DEFAULT,
`        ORDER_TIME        TIMESTAMP           NOT NULL WITH DEFAULT,
`        FREIGHT_CHARGES   DECIMAL(4, 2),
`        ORDER_SALESMAN    CHAR(6),
`        ORDER_POSTED_DATE TIMESTAMP      NOT NULL WITH DEFAULT,
`        ORDER_SHIP_DATE   CHAR(8)        DEFAULT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_ORDR2 for table ~SAMPLEID..OPTIM_ORDERS2
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_ORDR2
`        ON ~SAMPLEID..OPTIM_ORDERS2
`       (ORDER_ID          ASC)`
`Primary key ~SAMPLEID..OPTIM_ORDERS2
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS2
`        PRIMARY KEY
`       (ORDER_ID)`
`Relationship RCO2 between ~SAMPLEID..OPTIM_CUSTOMERS2 and ~SAMPLEID..OPTIM_ORDERS2
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS2
`        FOREIGN KEY RCO2
`       (CUST_ID)
`        REFERENCES ~SAMPLEID..OPTIM_CUSTOMERS2
`        ON DELETE RESTRICT`
`Table ~SAMPLEID..OPTIM_ITEMS2
`CREATE TABLE ~SAMPLEID..OPTIM_ITEMS2
`       (ITEM_ID           CHAR(5)        NOT NULL,
`        ITEM_DESCRIPTION  VARCHAR(72)    NOT NULL,
`        CATEGORY          VARCHAR(14)    NOT NULL,
`        RATING            CHAR(4)        NOT NULL,
`        UNIT_PRICE        DECIMAL(5, 2)  NOT NULL,
`        ON_HAND_INVENTORY DECIMAL(10,0)       NOT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_ITEM2 for table ~SAMPLEID..OPTIM_ITEMS2
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_ITEM2
`        ON ~SAMPLEID..OPTIM_ITEMS2
`       (ITEM_ID           ASC)`
`Primary key ~SAMPLEID..OPTIM_ITEMS2
`ALTER TABLE ~SAMPLEID..OPTIM_ITEMS2
`        PRIMARY KEY
`        (ITEM_ID)`
`Table ~SAMPLEID..OPTIM_DETAILS2
`CREATE TABLE ~SAMPLEID..OPTIM_DETAILS2
`       (ORDER_ID          DECIMAL(10, 0)  NOT NULL,
`        ITEM_ID           CHAR(5)        NOT NULL,
`        ITEM_QUANTITY     DECIMAL(10, 0)       NOT NULL,
`        DETAIL_UNIT_PRICE DECIMAL(5, 2)  NOT NULL) ORGANIZE BY ROW
`        ~SAMPLETS`
`Unique index ~SAMPLEID..XPK_DETL2 for table ~SAMPLEID..OPTIM_DETAILS2
`CREATE UNIQUE INDEX ~SAMPLEID..XPK_DETL2
`        ON ~SAMPLEID..OPTIM_DETAILS2
`       (ORDER_ID          DESC,
`        ITEM_ID           ASC)`
`Primary key ~SAMPLEID..OPTIM_DETAILS2
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS2
`        PRIMARY KEY
`       (ORDER_ID,
`        ITEM_ID)`
`Relationship ROD2 between ~SAMPLEID..OPTIM_ORDERS2 and ~SAMPLEID..OPTIM_DETAILS2
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS2
`        FOREIGN KEY ROD2
`        (ORDER_ID)
`        REFERENCES ~SAMPLEID..OPTIM_ORDERS2
`        ON DELETE CASCADE`
`Relationship RID2 between ~SAMPLEID..OPTIM_ITEMS2 and ~SAMPLEID..OPTIM_DETAILS2
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS2
`        FOREIGN KEY RID2
`       (ITEM_ID)
`        REFERENCES ~SAMPLEID..OPTIM_ITEMS2
`        ON DELETE RESTRICT`
`Table ~SAMPLEID..OPTIM_PST_ACTIONS
`CREATE TABLE ~SAMPLEID..OPTIM_PST_ACTIONS
`       (ACTION_ID            DECIMAL(2,0)
`        CHECK ( ( ( ACTION_ID >= 0. ) AND ( ACTION_ID <= 16. ) ) ),
`        ACTION_TEXT          VARCHAR(30),
`        AFTER_ROW_STATUS     VARCHAR(2),
`        ARCHIVE_DESC         VARCHAR(40),
`        ARCHIVE_FILE_NAME    VARCHAR(80),
`        ARCHIVE_ID           DECIMAL(5,0),
`        CURRENT_DATETIME     TIMESTAMP,
`        GROUP_NAME           VARCHAR(8),
`        INDEX_FILE_NAME      VARCHAR(80),
`        MACHINE_NAME         VARCHAR(15),
`        SERVER_NAME          VARCHAR(15),
`        START_DATETIME       TIMESTAMP,
`        SOURCE_TBL_DBALIAS   VARCHAR(15),
`        DEST_TBL_DBALIAS     VARCHAR(15),
`        SOURCE_TBL_NAME      VARCHAR(40),
`        DEST_TBL_NAME        VARCHAR(40),
`        TBL_ROW_IN_ERROR     DECIMAL(9,0),
`        TBL_ROW_PROCESSED    DECIMAL(9,0),
`        ROWS_LEFT_T_B_PROC   DECIMAL(9,0),
`        TBL_ROW_EXTRACTED    DECIMAL(9,0),
`        SOURCE_TBL_SCHEMA    VARCHAR(20),
`        DEST_TBL_SCHEMA      VARCHAR(20),
`        TOT_ROW_IN_ERROR     DECIMAL(9,0),
`        TOT_ROW_PROCESSED    DECIMAL(9,0),
`        TOT_LEFT_T_B_PROC    DECIMAL(9,0),
`        TOT_PROC_STATUS      VARCHAR(15),
`        TOT_ROW_EXTRACTED    DECIMAL(9,0),
`        USER_ID              VARCHAR(8)) ORGANIZE BY ROW
`        DATA CAPTURE NONE
`        ~SAMPLETS`
`Grant privileges to table ~SAMPLEID..OPTIM_SALES
`GRANT ALL ON ~SAMPLEID..OPTIM_SALES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_CUSTOMERS
`GRANT ALL ON ~SAMPLEID..OPTIM_CUSTOMERS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ORDERS
`GRANT ALL ON ~SAMPLEID..OPTIM_ORDERS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ITEMS
`GRANT ALL ON ~SAMPLEID..OPTIM_ITEMS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_DETAILS
`GRANT ALL ON ~SAMPLEID..OPTIM_DETAILS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_SHIP_TO
`GRANT ALL ON ~SAMPLEID..OPTIM_SHIP_TO TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_FEMALE_RATES
`GRANT ALL ON ~SAMPLEID..OPTIM_FEMALE_RATES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_MALE_RATES
`GRANT ALL ON ~SAMPLEID..OPTIM_MALE_RATES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_STATE_LOOKUP
`GRANT ALL ON ~SAMPLEID..OPTIM_STATE_LOOKUP TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_SHIP_INSTR
`GRANT ALL ON ~SAMPLEID..OPTIM_SHIP_INSTR TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_CUSTOMERS2
`GRANT ALL ON ~SAMPLEID..OPTIM_CUSTOMERS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ORDERS2
`GRANT ALL ON ~SAMPLEID..OPTIM_ORDERS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ITEMS2
`GRANT ALL ON ~SAMPLEID..OPTIM_ITEMS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_DETAILS2
`GRANT ALL ON ~SAMPLEID..OPTIM_DETAILS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_PST_ACTIONS
`GRANT ALL ON ~SAMPLEID..OPTIM_PST_ACTIONS TO PUBLIC`
