`Table ~SAMPLEID..OPTIM_SALES
`CREATE TABLE ~SAMPLEID..OPTIM_SALES
`       (SALESMAN_ID       CHAR(6)        NOT NULL,
`        FIRST_NAME        VARCHAR2(15)    NOT NULL,
`        LAST_NAME         VARCHAR2(15)    NOT NULL,
`        NATIONALITY       VARCHAR2(30),
`        NATIONAL_ID       VARCHAR2(30),
`        PHONE_NUMBER      VARCHAR2(20)    NOT NULL,
`        AGE               NUMBER(4, 0)  DEFAULT 0 NOT NULL,
`        SEX               CHAR(1)        DEFAULT ' ' NOT NULL,
`        TERRITORY         VARCHAR2(14)    NOT NULL,
`        EMAIL_ADDRESS     VARCHAR2(70)    NOT NULL,
`        MANAGER_ID        VARCHAR2(6),
`        CONSTRAINT XPK_SALES PRIMARY KEY
`       (SALESMAN_ID))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_CUSTOMERS
`CREATE TABLE ~SAMPLEID..OPTIM_CUSTOMERS
`       (CUST_ID           CHAR(5)        NOT NULL,
`        CUSTNAME          NVARCHAR2(60)       NOT NULL,
`        ADDRESS1          NVARCHAR2(100) NOT NULL,
`        ADDRESS2          NVARCHAR2(100),
`        LOCALITY          NVARCHAR2(56),
`        CITY              NVARCHAR2(60),
`        STATE             NVARCHAR2(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR2(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        EMAIL_ADDRESS     VARCHAR2(70),
`        PHONE_NUMBER      VARCHAR2(20),
`        YTD_SALES         DECIMAL(7, 2) DEFAULT 0 NOT NULL ,
`        SALESMAN_ID       CHAR(6),
`        NATIONALITY       VARCHAR2(30),
`        NATIONAL_ID       VARCHAR2(30),
`        CREDITCARD_NUMBER VARCHAR2(19),
`        CREDITCARD_TYPE   VARCHAR2(30),
`        CREDITCARD_EXP    CHAR(4),      
`        CREDITCARD_CVV    VARCHAR2(4),
`        DRIVER_LICENSE    VARCHAR2(30),
`        CREDITCARD_HISTORY XMLTYPE,
`        CONSTRAINT XPK_CUST PRIMARY KEY 
`       (CUST_ID))
`        ~SAMPLETS`
`Relationship RSC between ~SAMPLEID..OPTIM_SALES and ~SAMPLEID..OPTIM_CUSTOMERS
`ALTER TABLE ~SAMPLEID..OPTIM_CUSTOMERS
`        ADD CONSTRAINT RSC
`        FOREIGN KEY
`        (SALESMAN_ID)
`        REFERENCES ~SAMPLEID..OPTIM_SALES`
`Table ~SAMPLEID..OPTIM_ORDERS
`CREATE TABLE ~SAMPLEID..OPTIM_ORDERS
`       (ORDER_ID          NUMBER(10, 0)  NOT NULL,
`        CUST_ID           CHAR(5)       NOT NULL,
`        ORDER_DATE        DATE          DEFAULT SYSDATE NOT NULL,
`        ORDER_TIME        TIMESTAMP     DEFAULT SYSTIMESTAMP NOT NULL,
`        FREIGHT_CHARGES   NUMBER(4, 2),
`        ORDER_SALESMAN    CHAR(6),
`        ORDER_POSTED_DATE DATE          DEFAULT SYSDATE NOT NULL,
`        ORDER_SHIP_DATE   CHAR(8)       DEFAULT NULL,
`        CONSTRAINT XPK_ORDR PRIMARY KEY
`       (ORDER_ID))
`        ~SAMPLETS`
`Relationship RCO between ~SAMPLEID..OPTIM_CUSTOMERS and ~SAMPLEID..OPTIM_ORDERS
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS
`        ADD CONSTRAINT RCO
`        FOREIGN KEY
`       (CUST_ID) 
`        REFERENCES ~SAMPLEID..OPTIM_CUSTOMERS`
`Table ~SAMPLEID..OPTIM_ITEMS
`CREATE TABLE ~SAMPLEID..OPTIM_ITEMS
`       (ITEM_ID           CHAR(5)        NOT NULL,
`        ITEM_DESCRIPTION  VARCHAR2(72)    NOT NULL,
`        CATEGORY          VARCHAR2(14)    NOT NULL,
`        RATING            CHAR(4)        NOT NULL,
`        UNIT_PRICE        NUMBER(5, 2)   NOT NULL,
`        ON_HAND_INVENTORY NUMBER(10, 0)  NOT NULL,
`        CONSTRAINT XPK_ITEM PRIMARY KEY
`       (ITEM_ID))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_DETAILS
`CREATE TABLE ~SAMPLEID..OPTIM_DETAILS
`       (ORDER_ID          NUMBER(10, 0)  NOT NULL,
`        ITEM_ID           CHAR(5)       NOT NULL,
`        ITEM_QUANTITY     NUMBER(10, 0)  NOT NULL,
`        DETAIL_UNIT_PRICE NUMBER(5, 2)  NOT NULL,
`        CONSTRAINT XPK_DETL PRIMARY KEY
`       (ORDER_ID, 
`        ITEM_ID ))
`        ~SAMPLETS`
`Relationship ROD between ~SAMPLEID..OPTIM_ORDERS and ~SAMPLEID..OPTIM_DETAILS
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS
`        ADD CONSTRAINT ROD
`        FOREIGN KEY
`        (ORDER_ID) 
`        REFERENCES ~SAMPLEID..OPTIM_ORDERS 
`        ON DELETE CASCADE`
`Relationship RID between ~SAMPLEID..OPTIM_ITEMS and ~SAMPLEID..OPTIM_DETAILS
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS
`        ADD CONSTRAINT RID
`        FOREIGN KEY
`       (ITEM_ID)
`        REFERENCES ~SAMPLEID..OPTIM_ITEMS`
`Table ~SAMPLEID..OPTIM_SHIP_TO
`CREATE TABLE ~SAMPLEID..OPTIM_SHIP_TO
`       (CUST_ID           CHAR(5)        NOT NULL,
`        SHIP_ID           DECIMAL(10, 0) NOT NULL,
`        ADDRESS1          NVARCHAR2(100),
`        ADDRESS2          NVARCHAR2(100),
`        LOCALITY          NVARCHAR2(56),
`        CITY              NVARCHAR2(30),
`        STATE             NVARCHAR2(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        IN_CARE_OF        VARCHAR2(30),
`        SHIPPING_CHANGE_DT DATE          DEFAULT SYSDATE NOT NULL)
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_FEMALE_RATES
`CREATE TABLE ~SAMPLEID..OPTIM_FEMALE_RATES
`        (AGE              NUMBER(4, 0),
`        RATE_PER_1000     NUMBER(10, 0))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_MALE_RATES
`CREATE TABLE ~SAMPLEID..OPTIM_MALE_RATES
`       (AGE               NUMBER(4, 0),
`        RATE_PER_1000     NUMBER(10, 0))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_STATE_LOOKUP
`CREATE TABLE ~SAMPLEID..OPTIM_STATE_LOOKUP
`       (DISTRICT          CHAR(2)        NOT NULL,
`        DIST_CODE         CHAR(3)        NOT NULL)
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_SHIP_INSTR
`CREATE TABLE ~SAMPLEID..OPTIM_SHIP_INSTR
`       (SHIP_ID           NUMBER(10, 0),
`        SHIP_INSTR_ID     NUMBER(10, 0),
`        ORDER_SHIP_INSTR  VARCHAR2(254),
`        SHIP_UPDATED      TIMESTAMP          DEFAULT SYSTIMESTAMP NOT NULL)
`        ~SAMPLETS`
`Index ~SAMPLEID..XPK_SHIPI for table ~SAMPLEID..OPTIM_SHIP_INSTR
`CREATE INDEX ~SAMPLEID..XPK_SHIPI
`        ON ~SAMPLEID..OPTIM_SHIP_INSTR
`        (SHIP_INSTR_ID)
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_CUSTOMERS2
`CREATE TABLE ~SAMPLEID..OPTIM_CUSTOMERS2
`       (CUST_ID           CHAR(5)        NOT NULL,
`        CUSTNAME          CHAR(20)       NOT NULL,
`        ADDRESS1          NVARCHAR2(100) NOT NULL,
`        ADDRESS2          NVARCHAR2(100),
`        LOCALITY          NVARCHAR2(56),
`        CITY              NVARCHAR2(60),
`        STATE             NVARCHAR2(30),
`        COUNTRY_CODE      CHAR(2),
`        POSTAL_CODE       VARCHAR2(15),
`        POSTAL_CODE_PLUS4 CHAR(4),
`        EMAIL_ADDRESS     VARCHAR2(70),
`        PHONE_NUMBER      VARCHAR2(20),
`        YTD_SALES         DECIMAL(7, 2) DEFAULT 0 NOT NULL ,
`        SALESMAN_ID       CHAR(6),
`        NATIONALITY       VARCHAR2(30),
`        NATIONAL_ID       VARCHAR2(30),
`        CREDITCARD_NUMBER VARCHAR2(19),
`        CREDITCARD_TYPE   VARCHAR2(30),
`        CREDITCARD_EXP    CHAR(4),      
`        CREDITCARD_CVV    VARCHAR2(4),
`        DRIVER_LICENSE    VARCHAR2(30),
`        CREDITCARD_HISTORY XMLTYPE,
`        CONSTRAINT XPK_CUST2 PRIMARY KEY 
`       (CUST_ID))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_ORDERS2
`CREATE TABLE ~SAMPLEID..OPTIM_ORDERS2
`       (ORDER_ID          NUMBER(10, 0)  NOT NULL,
`        CUST_ID           CHAR(5)       NOT NULL,
`        ORDER_DATE        DATE          DEFAULT SYSDATE NOT NULL,
`        ORDER_TIME        TIMESTAMP     DEFAULT SYSTIMESTAMP NOT NULL,
`        FREIGHT_CHARGES   NUMBER(4, 2),
`        ORDER_SALESMAN    CHAR(6),
`        ORDER_POSTED_DATE DATE          DEFAULT SYSDATE NOT NULL,
`        ORDER_SHIP_DATE   CHAR(8)       DEFAULT NULL,
`        CONSTRAINT XPK_ORDR2 PRIMARY KEY
`       (ORDER_ID))
`        ~SAMPLETS`
`Relationship RCO2 between ~SAMPLEID..OPTIM_CUSTOMERS2 and ~SAMPLEID..OPTIM_ORDERS2
`ALTER TABLE ~SAMPLEID..OPTIM_ORDERS2
`        ADD CONSTRAINT RCO2
`        FOREIGN KEY
`       (CUST_ID) 
`        REFERENCES ~SAMPLEID..OPTIM_CUSTOMERS2`
`Table ~SAMPLEID..OPTIM_ITEMS2
`CREATE TABLE ~SAMPLEID..OPTIM_ITEMS2
`       (ITEM_ID           CHAR(5)        NOT NULL,
`        ITEM_DESCRIPTION  VARCHAR2(72)    NOT NULL,
`        CATEGORY          VARCHAR2(14)    NOT NULL,
`        RATING            CHAR(4)        NOT NULL,
`        UNIT_PRICE        NUMBER(5, 2)   NOT NULL,
`        ON_HAND_INVENTORY NUMBER(10, 0)  NOT NULL,
`        CONSTRAINT XPK_ITEM2 PRIMARY KEY
`       (ITEM_ID))
`        ~SAMPLETS`
`Table ~SAMPLEID..OPTIM_DETAILS2
`CREATE TABLE ~SAMPLEID..OPTIM_DETAILS2
`       (ORDER_ID          NUMBER(10, 0)  NOT NULL,
`        ITEM_ID           CHAR(5)       NOT NULL,
`        ITEM_QUANTITY     NUMBER(10, 0)  NOT NULL,
`        DETAIL_UNIT_PRICE NUMBER(5, 2)  NOT NULL,
`        CONSTRAINT XPK_DETL2 PRIMARY KEY
`       (ORDER_ID, 
`        ITEM_ID ))
`        ~SAMPLETS`
`Relationship ROD2 between ~SAMPLEID..OPTIM_ORDERS2 and ~SAMPLEID..OPTIM_DETAILS2
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS2
`        ADD CONSTRAINT ROD2
`        FOREIGN KEY
`        (ORDER_ID) 
`        REFERENCES ~SAMPLEID..OPTIM_ORDERS2
`        ON DELETE CASCADE`
`Relationship RID2 between ~SAMPLEID..OPTIM_ITEMS2 and ~SAMPLEID..OPTIM_DETAILS2
`ALTER TABLE ~SAMPLEID..OPTIM_DETAILS2
`        ADD CONSTRAINT RID2
`        FOREIGN KEY
`       (ITEM_ID) 
`        REFERENCES ~SAMPLEID..OPTIM_ITEMS2`
`Table ~SAMPLEID..OPTIM_PST_ACTIONS
`CREATE TABLE ~SAMPLEID..OPTIM_PST_ACTIONS
`      ( ACTION_ID            NUMBER(2)
`        CHECK ( ( ( ACTION_ID >= 0. ) AND ( ACTION_ID <= 16. ) ) ),
`        ACTION_TEXT          VARCHAR2(30),
`        AFTER_ROW_STATUS     VARCHAR2(2),
`        ARCHIVE_DESC         VARCHAR2(40),
`        ARCHIVE_FILE_NAME    VARCHAR2(80),
`        ARCHIVE_ID           NUMBER(5),
`        CURRENT_DATETIME     DATE,
`        GROUP_NAME           VARCHAR2(8),
`        INDEX_FILE_NAME      VARCHAR2(80),
`        MACHINE_NAME         VARCHAR2(15),
`        SERVER_NAME          VARCHAR2(15),
`        START_DATETIME       DATE,
`        SOURCE_TBL_DBALIAS   VARCHAR2(15),
`        DEST_TBL_DBALIAS     VARCHAR2(15),
`        SOURCE_TBL_NAME      VARCHAR2(40),
`        DEST_TBL_NAME        VARCHAR2(40),
`        TBL_ROW_IN_ERROR     NUMBER(9),
`        TBL_ROW_PROCESSED    NUMBER(9),
`        ROWS_LEFT_T_B_PROC   NUMBER(9),
`        TBL_ROW_EXTRACTED    NUMBER(9),
`        SOURCE_TBL_SCHEMA    VARCHAR2(20),
`        DEST_TBL_SCHEMA      VARCHAR2(20),
`        TOT_ROW_IN_ERROR     NUMBER(9),
`        TOT_ROW_PROCESSED    NUMBER(9),
`        TOT_LEFT_T_B_PROC    NUMBER(9),
`        TOT_PROC_STATUS      VARCHAR2(15),
`        TOT_ROW_EXTRACTED    NUMBER(9),
`        USER_ID              VARCHAR2(8) ) 
`       ~SAMPLETS`
`Grant privileges to table ~SAMPLEID..OPTIM_SALES
`GRANT ALL ON ~SAMPLEID..OPTIM_SALES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_CUSTOMERS
`GRANT ALL ON ~SAMPLEID..OPTIM_CUSTOMERS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ORDERS
`GRANT ALL ON ~SAMPLEID..OPTIM_ORDERS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ITEMS
`GRANT ALL ON ~SAMPLEID..OPTIM_ITEMS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_DETAILS
`GRANT ALL ON ~SAMPLEID..OPTIM_DETAILS TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_SHIP_TO
`GRANT ALL ON ~SAMPLEID..OPTIM_SHIP_TO TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_FEMALE_RATES
`GRANT ALL ON ~SAMPLEID..OPTIM_FEMALE_RATES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_MALE_RATES
`GRANT ALL ON ~SAMPLEID..OPTIM_MALE_RATES TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_STATE_LOOKUP
`GRANT ALL ON ~SAMPLEID..OPTIM_STATE_LOOKUP TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_SHIP_INSTR
`GRANT ALL ON ~SAMPLEID..OPTIM_SHIP_INSTR TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_CUSTOMERS2
`GRANT ALL ON ~SAMPLEID..OPTIM_CUSTOMERS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ORDERS2
`GRANT ALL ON ~SAMPLEID..OPTIM_ORDERS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_ITEMS2
`GRANT ALL ON ~SAMPLEID..OPTIM_ITEMS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_DETAILS2
`GRANT ALL ON ~SAMPLEID..OPTIM_DETAILS2 TO PUBLIC`
`Grant privileges to table ~SAMPLEID..OPTIM_PST_ACTIONS
`GRANT ALL ON ~SAMPLEID..OPTIM_PST_ACTIONS TO PUBLIC`
