set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSCHECKHAMESPACE
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSCHECKHAMESPACE
       @CreatorName       sysname,
       @ObjectName        sysname,
       @QualifierName     sysname,
       @QualifierCreator  sysname,
       @ObjType           int
AS
BEGIN
   declare  @objectType    char(2)
   declare  @constraintId  int
   declare  @objId         int
   declare  @constrStatus  int
   declare  @trigId        int
   declare  @trigIns       int
   declare  @trigUpd       int
   declare  @trigDel       int
   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

if((@ObjType = 1) or  /*table*/
   (@ObjType = 2) or  /*view*/
   (@ObjType = 4) or  /*rule*/
   (@ObjType = 5) or  /*default*/
   (@ObjType =15) or  /*function*/
   (@ObjType =16))    /*procedure*/
  begin
     select o.type, '?', '?'
       from sysobjects o, sysusers u
      where (o.uid = u.uid)
        and (u.name = @CreatorName)
        and (o.name = @ObjectName)
  end
else if(@ObjType =12) /*trigger*/
  begin
     select @objectType = o.type, @objId = o.parent_obj, @trigId = o.id
       from sysobjects o, sysusers u
      where (o.uid = u.uid)
        and (u.name = @QualifierCreator)
        and (o.name = @QualifierName)
     if((@@rowcount > 0) and (@objectType = 'TR'))
       begin
        select @trigIns = ObjectProperty(@trigId, 'ExecIsInsertTrigger')
        select @trigUpd = ObjectProperty(@trigId, 'ExecIsUpdateTrigger')
        select @trigDel = ObjectProperty(@trigId, 'ExecIsDeleteTrigger')
        select ('T' +
               case
                   when (@trigIns=0)and(@trigUpd=0)and(@trigDel=0) then '0'
                   when (@trigIns=0)and(@trigUpd=0)and(@trigDel=1) then '1'
                   when (@trigIns=0)and(@trigUpd=1)and(@trigDel=0) then '2'
                   when (@trigIns=0)and(@trigUpd=1)and(@trigDel=1) then '3'
                   when (@trigIns=1)and(@trigUpd=0)and(@trigDel=0) then '4'
                   when (@trigIns=1)and(@trigUpd=0)and(@trigDel=1) then '5'
                   when (@trigIns=1)and(@trigUpd=1)and(@trigDel=0) then '6'
                   when (@trigIns=1)and(@trigUpd=1)and(@trigDel=1) then '7'
               end),
               o.name, u.name
          from sysobjects o, sysusers u
         where (o.uid = u.uid)
           and (o.id = @objId)
       end
     else if(@@rowcount > 0)
        select @objectType, '?', '?'
     else
        select '?', '?', '?'
        where  0=1 /*empty set*/
  end
else if(
   (@ObjType = 7) or  /*check*/
   (@ObjType = 9) or  /*PrimKey*/
   (@ObjType =10) or  /*relKey*/
   (@ObjType =11))    /*unique*/
  begin
     select @objectType = o.type,
            @constraintId = isnull(c.constid,0),
            @constrStatus = (isnull(c.status,0) &2)
       from sysobjects o, sysusers u, sysconstraints c
      where (o.uid = u.uid)
        and (u.name = @CreatorName)
        and (o.name = @QualifierName)
        and (o.id *= c.constid)

     if(@@rowcount > 0)
         begin
             if(@constraintId <> 0)
               begin
                   if((@constrStatus = 2)and(@objectType = 'K'))
                     select @objectType = 'Q '
                   select @objectType, tob.name, tu.name
                     from sysconstraints c, sysobjects tob, sysusers tu
                    where (@constraintId = c.constid)
                      and (c.id = tob.id)
                      and (tob.uid = tu.uid)
               end
             else
               select @objectType, '?', '?'
         end
      else
         select '?', '?', '?'
         where 1=2 /* return empty set */
  end
else if(@ObjType = 8) /*index*/
  begin
    select 'I ', @ObjectName, @CreatorName
    from sysindexes i, sysobjects o, sysusers u
    where (i.id = o.id)
      and (o.uid = u.uid)
      and (u.name = @CreatorName)
      and (o.name = @ObjectName)
      and (i.name = @QualifierName)
  end
else if(@ObjType = 6)  /*datatype*/
  begin
    select 'Y ', '?', '?'
    from systypes
    where name = @ObjectName
  end
else
  begin
    select '?', '?', '?'
  end

END
go


grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSCHECKHAMESPACE to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

