set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCTEXT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNCTEXT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROC
       @Owner sysname,
       @Name  sysname
 AS
     set nocount on
     select o.id,
            o.uid,
            (select sum(datalength(c.text))
               from syscomments c
              where c.id = o.id
                and c.texttype != 6),
             u.name,
             o.name
       from sysobjects o, sysusers u
      where OBJECTPROPERTY(o.id,'IsProcedure') = 1
        and o.name = @Name
        and u.uid = o.uid
        and u.name = @Owner
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCTEXT
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     varchar(255)    /* current package record         */

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end
/*--------------------------------------------------------------------*
 *  Temporary Table used to return Procedure Text                     *
 *--------------------------------------------------------------------*/
     create table #prctxt(seqid  smallint primary key,
                          pkgtext varchar(255))
/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of Procedure Text                  *
 *--------------------------------------------------------------------*/
    declare txt_cursor cursor for
     select datalength(s.text), s.text
     from syscomments s
     where s.id = @ObjNum
       and s.texttype != 6
     order by s.colid
     for read only
/*--------------------------------------------------------------------*
 *  Extract 1st Procedure Text record                                 *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     open txt_cursor
     fetch txt_cursor into @Sl, @Stext
/*--------------------------------------------------------------------*
 *  For each record in the set of Procedure Text                      *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 256 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #prctxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch txt_cursor into @Sl, @Stext
     end
     close txt_cursor
     deallocate txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #prctxt
go

/*--------------------------------------------------------------------*
 *  Return Function Info                                              *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNC
       @Owner sysname,
       @Name  sysname
 AS
     set nocount on
     select o.id,
            o.uid,
            (select sum(datalength(c.text))
               from syscomments c
              where c.id = o.id
                and c.texttype != 6),
             u.name,
             o.name
       from sysobjects o, sysusers u
     where (OBJECTPROPERTY(o.id,'IsInlineFunction') = 1 or
            OBJECTPROPERTY(o.id,'IsScalarFunction') = 1 or
            OBJECTPROPERTY(o.id,'IsTableFunction') = 1)
        and o.name = @Name
        and u.uid = o.uid
        and u.name = @Owner
go

/*--------------------------------------------------------------------*
 *  Return text of a Function                                         *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNCTEXT
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     varchar(255)    /* current package record         */

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end
/*--------------------------------------------------------------------*
 *  Temporary Table used to return Function Text                      *
 *--------------------------------------------------------------------*/
     create table #funtxt(seqid  smallint primary key,
                          pkgtext varchar(255))
/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of Function text                   *
 *--------------------------------------------------------------------*/
    declare txt_cursor cursor for
     select datalength(s.text), s.text
     from syscomments s
     where s.id = @ObjNum
       and s.texttype != 6
     order by s.colid
     for read only
/*--------------------------------------------------------------------*
 *  Extract 1st Function Text record                                  *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     open txt_cursor
     fetch txt_cursor into @Sl, @Stext
/*--------------------------------------------------------------------*
 *  For each record in the set of Function Text                       *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #funtxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch txt_cursor into @Sl, @Stext
     end
     close txt_cursor
     deallocate txt_cursor
/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #funtxt
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCLIST
       @ObjType1 smallint,
       @ObjType2 smallint,
       @Owner sysname,
       @Name  sysname
 AS
declare  @mode      smallint        /* Query Mode in effect           */
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  bas-ed on whether the input patterns have LIKE wildcards.          *
 *  Mode values are:                                                  *
 *       0 - Explicit Owner name and Explicit Procedure name          *
 *       1 - Generic Owner name and Explicit Procedure name           *
 *       2 - Explicit Owner name and Generic Procedure name           *
 *       3 - Generic Owner name and Generic Procedure name            *
 *--------------------------------------------------------------------*/
     select @mode = 0               /* Assume Explicit Own/Prc names  */

/*--------------------------------------------------------------------*
 *  Check Owner Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@Owner) > 0) or (charindex('_',@Owner) > 0))
       select @mode = 1

/*--------------------------------------------------------------------*
 *  Check Procedure Name for LIKE wildcard characters                 *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@Name) > 0) or (charindex('_',@Name) > 0))
       select @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
      select
            case
              when OBJECTPROPERTY(o.id,'IsProcedure') = 1  then 1
              when OBJECTPROPERTY(o.id,'IsInlineFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsScalarFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsTableFunction') = 1 then 2
            end,
             o.name, u.name
        from sysobjects o, sysusers u
       where(OBJECTPROPERTY(o.id,'IsProcedure') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsInlineFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsScalarFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsTableFunction') = @ObjType2)
         and o.name = @Name
         and u.name = @Owner
         and o.uid = u.uid
       order by u.name, o.name
      end

    if @mode = 1
      begin
      select
            case
              when OBJECTPROPERTY(o.id,'IsProcedure') = 1  then 1
              when OBJECTPROPERTY(o.id,'IsInlineFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsScalarFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsTableFunction') = 1 then 2
            end,
             o.name, u.name
        from sysobjects o, sysusers u
       where(OBJECTPROPERTY(o.id,'IsProcedure') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsInlineFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsScalarFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsTableFunction') = @ObjType2)
         and o.name like @Name
         and u.name = @Owner
         and o.uid = u.uid
       order by u.name, o.name
      end

    if @mode = 2
      begin
      select
            case
              when OBJECTPROPERTY(o.id,'IsProcedure') = 1  then 1
              when OBJECTPROPERTY(o.id,'IsInlineFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsScalarFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsTableFunction') = 1 then 2
            end,
             o.name, u.name
        from sysobjects o, sysusers u
       where(OBJECTPROPERTY(o.id,'IsProcedure') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsInlineFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsScalarFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsTableFunction') = @ObjType2)
         and o.name like @Name
         and u.name = @Owner
         and o.uid = u.uid
       order by u.name, o.name
      end

    if @mode = 3
      begin
      select
            case
              when OBJECTPROPERTY(o.id,'IsProcedure') = 1  then 1
              when OBJECTPROPERTY(o.id,'IsInlineFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsScalarFunction') = 1 then 2
              when OBJECTPROPERTY(o.id,'IsTableFunction') = 1 then 2
            end,
             o.name, u.name
        from sysobjects o, sysusers u
       where(OBJECTPROPERTY(o.id,'IsProcedure') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsInlineFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsScalarFunction') = @ObjType2 or
             OBJECTPROPERTY(o.id,'IsTableFunction') = @ObjType2)
         and o.name like @Name
         and u.name like @Owner
         and o.uid = u.uid
       order by u.name, o.name
      end
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCTEXT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETFUNCTEXT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETPROCLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

