set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSCIDOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETTBLLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
 set nocount on
 SELECT u.uid,
        o.id,
        (select max(colid) from syscolumns c where c.id = o.id),
        (select count(*) from syscolumns c where c.id = o.id),
        o.status,
        o.sysstat,
        o.xtype,
        o.category,
        u.name,
        o.name
   FROM sysusers u, sysobjects o
   WHERE u.name = @CidName
     AND  o.uid = u.uid
     AND o.name = @ObjName
     AND (OBJECTPROPERTY(o.id,'IsTable') = 1 or OBJECTPROPERTY(o.id,'IsView') = 1)
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSCIDOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
 set nocount on
 SELECT o.uid,
        o.id,
        (select max(colid) from syscolumns c where c.id = o.id),
        (select count(*) from syscolumns c where c.id = o.id),
        o.status,
        o.sysstat,
        o.xtype,
        o.category,
        user_name(@CidUid),
        o.name
   FROM sysobjects o
   WHERE o.uid = @CidUid
     AND o.name = @ObjName
     AND (OBJECTPROPERTY(o.id,'IsTable') = 1 or OBJECTPROPERTY(o.id,'IsView') = 1)
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPOBJECT
   @ObjNum  int
 AS
   set nocount on
/*--------------------------------------------------------------------*
 *  Table has no Text or Image columns                                *
 *--------------------------------------------------------------------*/
   if (OBJECTPROPERTY(@ObjNum,'TableHasTextImage') = 0)
     begin
        SELECT isnull(i.rows,0),
               isnull(objectproperty(o.id,'TableDeleteTriggerCount'),0),
               isnull(objectproperty(o.id,'TableInsertTriggerCount'),0),
               isnull(objectproperty(o.id,'TableUpdateTriggerCount'),0),
               isnull(i.OrigFillFactor,0),
               i.groupid,
               isnull(FILEGROUP_NAME(i.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(i.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end,
               0,
               ' ',
               'X'
         FROM sysobjects o, sysindexes i
         WHERE o.id = @ObjNum
           AND i.id = @ObjNum
           AND (i.indid = 0 or i.indid = 1)
     end
/*--------------------------------------------------------------------*
 *  Table has Text or Image columns get additional FileGroup          *
 *--------------------------------------------------------------------*/
   else
     if (SELECT count(*)
           FROM sysindexes
          WHERE id    = @ObjNum
            AND indid = 255) > 0
/*--------------------------------------------------------------------*
 *  Use version 8 approach                                            *
 *--------------------------------------------------------------------*/
     begin
        SELECT isnull(i.rows,0),
               isnull(objectproperty(o.id,'TableDeleteTriggerCount'),0),
               isnull(objectproperty(o.id,'TableInsertTriggerCount'),0),
               isnull(objectproperty(o.id,'TableUpdateTriggerCount'),0),
               isnull(i.OrigFillFactor,0),
               i.groupid,
               isnull(FILEGROUP_NAME(i.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(i.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end,
               t.groupid,
               isnull(FILEGROUP_NAME(t.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(t.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end
         FROM sysobjects o, sysindexes i, sysindexes t
         WHERE o.id = @ObjNum
           AND i.id = @ObjNum
           AND t.id = @ObjNum
           AND (i.indid = 0 or i.indid = 1)
           AND t.indid = 255
     end
   else
/*--------------------------------------------------------------------*
 *  Use version 9 approach                                            *
 *--------------------------------------------------------------------*/
     begin
        SELECT isnull(i.rows,0),
               isnull(objectproperty(o.id,'TableDeleteTriggerCount'),0),
               isnull(objectproperty(o.id,'TableInsertTriggerCount'),0),
               isnull(objectproperty(o.id,'TableUpdateTriggerCount'),0),
               isnull(i.OrigFillFactor,0),
               i.groupid,
               isnull(FILEGROUP_NAME(i.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(i.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end,
               u.data_space_id,
               isnull(FILEGROUP_NAME(u.data_space_id),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(U.data_space_id),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end
         FROM sysobjects o, sysindexes i, sys.partitions p, sys.allocation_units u
         WHERE o.id = @ObjNum
           AND i.id = @ObjNum
           AND p.object_id = i.id
           AND p.index_id = i.indid
           AND u.container_id = p.partition_id
           AND u.type = 2
           AND (i.indid = 0 or i.indid = 1)
     end
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPVIEW
   @ObjNum  int
 AS
   set nocount on
   select sum(datalength(c.text))
     from syscomments c
    where c.id = @ObjNum
      and c.texttype != 6
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETVIEW
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     char(255)       /* current package record         */

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return View Text                          *
 *--------------------------------------------------------------------*/
     create table #vuetxt(seqid  smallint primary key,
                          pkgtext char(255))

/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of View text                       *
 *--------------------------------------------------------------------*/
    declare txt_cursor cursor for
     select datalength(s.text), s.text
     from syscomments s
     where s.id = @ObjNum
       and s.texttype != 6
     order by s.colid
     for read only

/*--------------------------------------------------------------------*
 *  Extract 1st View Text record                                      *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     open txt_cursor
     fetch txt_cursor into @Sl, @Stext
/*--------------------------------------------------------------------*
 *  For each record in the set of View Text                           *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #vuetxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch txt_cursor into @Sl, @Stext
     end
     close txt_cursor
     deallocate txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #vuetxt
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM80V0100_CSSGETTBLLIST
       @ObjType1   smallint,
       @ObjType2   smallint,
       @ObjType3   smallint,
       @CidPattern sysname,
       @TblPattern sysname
 AS
declare  @objnum    int             /* Current Object Number          */
declare  @numkey    smallint        /* Number of keys in index        */
declare  @cid_name  sysname         /* Creator Name                   */
declare  @tbl_name  sysname         /* Table Name                     */
declare  @tbl_type  char(1)         /* Object Type  T, V              */
declare  @user      smallint        /* Table owner Id                 */
declare  @mode      smallint        /* Query Mode in effect           */
declare  @rows      int             /* Number table rows              */

   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Primary Key List                   *
 *--------------------------------------------------------------------*/
     create table #tbllist(CidName sysname,
                           TblName sysname,
                           TblType char(1),
                           RowCnt  int)

/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  bas-ed on whether the input patterns have LIKE wildcards.          *
 *  Mode values are:                                                  *
 *       0 - Explicit Creator name and Explicit Table name            *
 *       1 - Generic Creator name and Explicit Table name             *
 *       2 - Explicit Creator name and Generic Table name             *
 *       3 - Generic Creator name and Generic Table name              *
 *--------------------------------------------------------------------*/
     set @mode = 0               /* Assume Explicit CID/TBL names  */

/*--------------------------------------------------------------------*
 *  Check Creator Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@CidPattern) > 0) or
         (charindex('_',@CidPattern) > 0))
       set @mode = 1

/*--------------------------------------------------------------------*
 *  Check Table Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@TblPattern) > 0) or
         (charindex('_',@TblPattern) > 0))
       set @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Open the appropriate cursor and fetch 1st record                  *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
DECLARE tlst0 CURSOR FOR
     SELECT u.name, o.name,
            case
              when OBJECTPROPERTY(o.id,'IsView') = 1  then 'V'
              when OBJECTPROPERTY(o.id,'IsTable') = 1 then 'T'
              else 'X'
            end,
            isnull(i.rows,0)
       FROM sysusers u, sysobjects o, sysindexes i
      WHERE u.name = @CidPattern
        AND o.uid = u.uid
        AND o.name = @TblPattern
        AND (OBJECTPROPERTY(o.id,'IsSystemTable') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsUserTable') = @ObjType3 or
             OBJECTPROPERTY(o.id,'IsView') = @ObjType2)
        AND i.id =* o.id
        AND (i.indid = 0 or i.indid = 1)
      FOR READ ONLY
        OPEN tlst0
        FETCH tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 1
      begin
DECLARE tlst1 CURSOR FOR
     SELECT u.name, o.name,
            case
              when OBJECTPROPERTY(o.id,'IsView') = 1  then 'V'
              when OBJECTPROPERTY(o.id,'IsTable') = 1 then 'T'
              else 'X'
            end,
            isnull(i.rows,0)
       FROM sysusers u, sysobjects o, sysindexes i
      WHERE u.name like @CidPattern
        AND o.uid = u.uid
        AND o.name = @TblPattern
        AND (OBJECTPROPERTY(o.id,'IsSystemTable') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsUserTable') = @ObjType3 or
             OBJECTPROPERTY(o.id,'IsView') = @ObjType2)
        AND i.id =* o.id
        AND (i.indid = 0 or i.indid = 1)
      FOR READ ONLY
        OPEN tlst1
        FETCH tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 2
      begin
DECLARE tlst2 CURSOR FOR
     SELECT u.name, o.name,
            case
              when OBJECTPROPERTY(o.id,'IsView') = 1  then 'V'
              when OBJECTPROPERTY(o.id,'IsTable') = 1 then 'T'
              else 'X'
            end,
            isnull(i.rows,0)
       FROM sysusers u, sysobjects o, sysindexes i
      WHERE u.name = @CidPattern
        AND o.uid = u.uid
        AND o.name like @TblPattern ESCAPE ''!''
        AND (OBJECTPROPERTY(o.id,'IsSystemTable') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsUserTable') = @ObjType3 or
             OBJECTPROPERTY(o.id,'IsView') = @ObjType2)
        AND i.id =* o.id
        AND (i.indid = 0 or i.indid = 1)
      FOR READ ONLY
        OPEN tlst2
        FETCH tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 3
      begin
DECLARE tlst3 CURSOR FOR
     SELECT u.name, o.name,
            case
              when OBJECTPROPERTY(o.id,'IsView') = 1  then 'V'
              when OBJECTPROPERTY(o.id,'IsTable') = 1 then 'T'
              else 'X'
            end,
            isnull(i.rows,0)
       FROM sysusers u, sysobjects o, sysindexes i
      WHERE u.name like @CidPattern
        AND o.uid = u.uid
        AND o.name like @TblPattern
        AND (OBJECTPROPERTY(o.id,'IsSystemTable') = @ObjType1 or
             OBJECTPROPERTY(o.id,'IsUserTable') = @ObjType3 or
             OBJECTPROPERTY(o.id,'IsView') = @ObjType2)
        AND i.id =* o.id
        AND (i.indid = 0 or i.indid = 1)
      FOR READ ONLY
        OPEN tlst3
        FETCH tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

/*--------------------------------------------------------------------*
 *  Process the set of tables returned by the Query                   *
 *--------------------------------------------------------------------*/
    while (@@fetch_status = 0)
     begin
       insert into #tbllist values
              (@cid_name, @tbl_name, @tbl_type, @rows)

/*--------------------------------------------------------------------*
 *  Retrieve next record in result set                                *
 *--------------------------------------------------------------------*/
    if @mode = 0
        FETCH tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 1
        FETCH tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 2
        FETCH tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 3
        FETCH tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows

     end                               /* Loop thru result set        */

/*--------------------------------------------------------------------*
 *  Close the Query cursor                                            *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
        CLOSE tlst0
        deallocate tlst0
      end

    if @mode = 1
      begin
        CLOSE tlst1
        deallocate tlst1
      end

    if @mode = 2
      begin
        CLOSE tlst2
        deallocate tlst2
      end

    if @mode = 3
      begin
        CLOSE tlst3
        deallocate tlst3
      end

/*--------------------------------------------------------------------*
 *  Select the returned data, if any, for the Primary Keys            *
 *--------------------------------------------------------------------*/
     select CidName, TblName, TblType, RowCnt
        from #tbllist
        order by CidName, TblName
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSCIDOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSEXPVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM80V0100_CSSGETTBLLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

