set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETCIDLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETCIDLIST
       @CidPattern sysname
 AS
declare  @mode      smallint        /* Query Mode in effect           */

     set nocount on
/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  bas-ed on whether the input pattern has LIKE wildcards.            *
 *  Mode values are:                                                  *
 *       0 - Explicit Creator name                                    *
 *       1 - Generic Creator name                                     *
 *--------------------------------------------------------------------*/
     set @mode = 0                  /* Assume Explicit CID/TBL names  */

/*--------------------------------------------------------------------*
 *  Check Creator Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@CidPattern) > 0) or
         (charindex('_',@CidPattern) > 0))
       set @mode = 1

/*--------------------------------------------------------------------*
 *  Process the appropriate select and retrieve record                *
 *--------------------------------------------------------------------*/
    if @mode = 0
     SELECT DISTINCT u.name, u.schema_id
                FROM sys.schemas u, sysobjects o
               WHERE (OBJECTPROPERTY(o.id,'IsTable') = 1 or OBJECTPROPERTY(o.id,'IsView') = 1)
                 AND u.schema_id = o.uid
                 AND u.name = @CidPattern
            ORDER BY u.name

    if @mode = 1
     SELECT DISTINCT u.name, u.schema_id
                FROM sys.schemas u, sysobjects o
               WHERE (OBJECTPROPERTY(o.id,'IsTable') = 1 or OBJECTPROPERTY(o.id,'IsView') = 1)
                 AND u.schema_id = o.uid
                 AND u.name like @CidPattern
            ORDER BY u.name

go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETCIDLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

