set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSCIDOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETTBLLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEME
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEMELIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNCLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
 set nocount on
 SELECT o.schema_id,
        o.object_id,
        (select max(column_id) from sys.all_columns c where c.object_id = o.object_id),
        (select count(*) from sys.all_columns c where c.object_id = o.object_id),
        0,
        0,
        o.type,
        (CASE 
            WHEN OBJECTPROPERTY(o.object_id, 'TableHasCheckCnst') = 1
            THEN 128
            ELSE 0
         END),
        schema_name(o.schema_id),
        o.name,
        ps.name,
        isnull(ic.column_id,0) 
   FROM sys.all_objects o
         left outer join sys.indexes i
     ON o.object_id = i.object_id
         and (i.type = 0 or i.is_primary_key = 1)  
         left outer join sys.partition_schemes ps
     on ps.data_space_id = i.data_space_id
         left outer join sys.index_columns ic
     on i.object_id = ic.object_id
         and i.index_id = ic.index_id
         and ic.partition_ordinal > 0
  WHERE o.schema_id = schema_id(@CidName)
    AND o.name = @ObjName
    AND (OBJECTPROPERTY(o.object_id,'IsTable') = 1 or OBJECTPROPERTY(o.object_id,'IsView') = 1)
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSCIDOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
 set nocount on
 SELECT o.schema_id,
        o.object_id,
        (select max(column_id) from sys.all_columns c where c.object_id = o.object_id),
        (select count(*) from sys.all_columns c where c.object_id = o.object_id),
        0,
        0,
        o.type,
        (CASE 
            WHEN OBJECTPROPERTY(o.object_id, 'TableHasCheckCnst') = 1
            THEN 128
            ELSE 0
         END),
        schema_name(o.schema_id),
        o.name,
        ps.name,
        isnull(ic.column_id,0) 
   FROM sys.all_objects o
         left outer join sys.indexes i
     ON o.object_id = i.object_id
         and (i.type = 0 or i.is_primary_key = 1)  
         left outer join sys.partition_schemes ps
     on ps.data_space_id = i.data_space_id
         left outer join sys.index_columns ic
     on i.object_id = ic.object_id
         and i.index_id = ic.index_id
         and ic.partition_ordinal > 0
  WHERE o.schema_id = @CidUid
    AND o.name = @ObjName
     AND (OBJECTPROPERTY(o.object_id,'IsTable') = 1 or OBJECTPROPERTY(o.object_id,'IsView') = 1)
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPOBJECT
   @ObjNum  int
 AS
   set nocount on
/*--------------------------------------------------------------------*
 *  Table has no Text or Image columns                                *
 *--------------------------------------------------------------------*/
   if (OBJECTPROPERTY(@ObjNum,'TableHasTextImage') = 0)
     begin
        SELECT isnull(i.rows,0),
               isnull(objectproperty(o.object_id,'TableDeleteTriggerCount'),0),
               isnull(objectproperty(o.object_id,'TableInsertTriggerCount'),0),
               isnull(objectproperty(o.object_id,'TableUpdateTriggerCount'),0),
               isnull(i.OrigFillFactor,0),
               i.groupid,
               isnull(FILEGROUP_NAME(i.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(i.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end,
               0,
               ' ',
               'X'
         FROM sys.all_objects o, sysindexes i
         WHERE o.object_id = @ObjNum
           AND i.id = @ObjNum
           AND (i.indid = 0 or i.indid = 1)
     end
/*--------------------------------------------------------------------*
 *  Table has Text or Image columns get additional FileGroup          *
 *--------------------------------------------------------------------*/
   else
     begin
        SELECT isnull(i.rows,0),
               isnull(objectproperty(o.object_id,'TableDeleteTriggerCount'),0),
               isnull(objectproperty(o.object_id,'TableInsertTriggerCount'),0),
               isnull(objectproperty(o.object_id,'TableUpdateTriggerCount'),0),
               isnull(i.OrigFillFactor,0),
               i.groupid,
               isnull(FILEGROUP_NAME(i.groupid),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(i.groupid),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end,
               u.data_space_id,
               isnull(FILEGROUP_NAME(u.data_space_id),' '),
               case
                 when (isnull(FILEGROUPPROPERTY(FILEGROUP_NAME(u.data_space_id),'IsDefault'),0) <> 0)
                   then 'Y'
                   else 'N'
                 end
         FROM sys.all_objects o, sysindexes i, sys.partitions p, sys.allocation_units u
         WHERE o.object_id = @ObjNum
           AND i.id = @ObjNum
           AND p.object_id = i.id
           AND p.index_id = i.indid
           AND u.container_id = p.partition_id
           AND u.type = 2
           AND (i.indid = 0 or i.indid = 1)
     end
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPVIEW
   @ObjNum  int
 AS
   set nocount on
   select datalength(c.definition)
     from sys.all_sql_modules c
    where c.object_id = @ObjNum
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETVIEW
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(max)   /* current text record            */
declare  @Ctext     char(255)       /* current package record         */

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return View Text                          *
 *--------------------------------------------------------------------*/
     create table #vuetxt(seqid  smallint primary key,
                          pkgtext char(255))

/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of View text                       *
 *--------------------------------------------------------------------*/
    declare txt_cursor cursor for
     select datalength(s.definition), s.definition
     from sys.all_sql_modules s
     where s.object_id = @ObjNum
     for read only

/*--------------------------------------------------------------------*
 *  Extract View Text record                                          *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     open txt_cursor
     fetch txt_cursor into @Sl, @Stext
     set @index = 1
     set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
     while(@Sl > 0)
     begin
       if (@Sl < 255) set @Ml = @Sl
       set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
       set @seqid = @seqid + 1
       insert into #vuetxt values (@seqid,@Ctext)
       set @Sl = @Sl - @Ml
       set @index = @index + @Ml
     end
     close txt_cursor
     deallocate txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #vuetxt
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETTBLLIST
       @ObjType1   smallint,
       @ObjType2   smallint,
       @ObjType3   smallint,
       @CidPattern sysname,
       @TblPattern sysname
 AS
declare  @objnum    int             /* Current Object Number          */
declare  @numkey    smallint        /* Number of keys in index        */
declare  @cid_name  sysname         /* Creator Name                   */
declare  @tbl_name  sysname         /* Table Name                     */
declare  @tbl_type  char(1)         /* Object Type  T, V, S           */
declare  @user      smallint        /* Table owner Id                 */
declare  @mode      smallint        /* Query Mode in effect           */
declare  @rows      int             /* Number table rows              */
declare  @objst     char(2)         /* system table                   */
declare  @objut     char(2)         /* user table                     */
declare  @objv      char(2)         /* view                           */
declare  @objsyn    char(2)         /* synonym                        */

   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Primary Key List                   *
 *--------------------------------------------------------------------*/
     create table #tbllist(CidName sysname,
                           TblName sysname,
                           TblType char(1),
                           RowCnt  int)

/*--------------------------------------------------------------------*
 *  Set up what we're looking for:                                    *
 *--------------------------------------------------------------------*/
     if @ObjType1 = 1
       begin
       set @objst = 'S '
       set @objut = 'U '
       end
     if @ObjType2 = 1
       set @objv = 'V '
     if @ObjType3 = 1
       set @objsyn = 'SN'


/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  bas-ed on whether the input patterns have LIKE wildcards.          *
 *  Mode values are:                                                  *
 *       0 - Explicit Creator name and Explicit Table name            *
 *       1 - Generic Creator name and Explicit Table name             *
 *       2 - Explicit Creator name and Generic Table name             *
 *       3 - Generic Creator name and Generic Table name              *
 *--------------------------------------------------------------------*/
     set @mode = 0               /* Assume Explicit CID/TBL names  */

/*--------------------------------------------------------------------*
 *  Check Creator Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@CidPattern) > 0) or
         (charindex('_',@CidPattern) > 0))
       set @mode = 1

/*--------------------------------------------------------------------*
 *  Check Table Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@TblPattern) > 0) or
         (charindex('_',@TblPattern) > 0))
       set @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Open the appropriate cursor and fetch 1st record                  *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
DECLARE tlst0 CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = 'V ' then 'V'
              when o.type = 'U ' then 'T'
              when o.type = 'S ' then 'T'
              when o.type = 'SN'
               and bo.type = 'U '
                or bo.type = 'S '
                or bo.type = 'V ' then 'S'
              else 'X'
            end,
            isnull((SELECT MAX(i.rows)
                      FROM sysindexes i
                     WHERE i.id = o.object_id),0)
       FROM sys.schemas u, sysindexes i RIGHT JOIN sys.all_objects o
         ON i.id = o.object_id LEFT JOIN sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name 
      WHERE u.name = @CidPattern
        AND o.schema_id = u.schema_id
        AND o.name = @TblPattern
        AND o.type IN (@objst, @objut, @objv, @objsyn)
      FOR READ ONLY
        OPEN tlst0
        FETCH tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 1
      begin
DECLARE tlst1 CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = 'V ' then 'V'
              when o.type = 'U ' then 'T'
              when o.type = 'S ' then 'T'
              when o.type = 'SN'
               and bo.type = 'U '
                or bo.type = 'S '
                or bo.type = 'V ' then 'S'
              else 'X'
            end,
            isnull((SELECT MAX(i.rows)
                      FROM sysindexes i
                     WHERE i.id = o.object_id),0)
       FROM sys.schemas u, sysindexes i RIGHT JOIN sys.all_objects o
         ON i.id = o.object_id LEFT JOIN sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name  
      WHERE u.name like @CidPattern
        AND o.schema_id = u.schema_id
        AND o.name = @TblPattern
        AND o.type IN (@objst, @objut, @objv, @objsyn)
      FOR READ ONLY
        OPEN tlst1
        FETCH tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 2
      begin
DECLARE tlst2 CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = 'V ' then 'V'
              when o.type = 'U ' then 'T'
              when o.type = 'S ' then 'T'
              when o.type = 'SN'
               and bo.type = 'U '
                or bo.type = 'S '
                or bo.type = 'V ' then 'S'
              else 'X'
            end,
            isnull((SELECT MAX(i.rows)
                      FROM sysindexes i
                     WHERE i.id = o.object_id),0)
       FROM sys.schemas u, sysindexes i RIGHT JOIN sys.all_objects o
         ON i.id = o.object_id LEFT JOIN sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name 
      WHERE u.name = @CidPattern
        AND o.schema_id = u.schema_id
        AND o.name like @TblPattern ESCAPE ''!''
        AND o.type IN (@objst, @objut, @objv, @objsyn)
      FOR READ ONLY
        OPEN tlst2
        FETCH tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 3
      begin
DECLARE tlst3 CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = 'V ' then 'V'
              when o.type = 'U ' then 'T'
              when o.type = 'S ' then 'T'
              when o.type = 'SN'
               and bo.type = 'U '
                or bo.type = 'S '
                or bo.type = 'V ' then 'S'
              else 'X'
            end,
            isnull((SELECT MAX(i.rows)
                      FROM sysindexes i
                     WHERE i.id = o.object_id),0)
       FROM sys.schemas u, sysindexes i RIGHT JOIN sys.all_objects o
         ON i.id = o.object_id LEFT JOIN sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name 
      WHERE u.name like @CidPattern
        AND o.schema_id = u.schema_id
        AND o.name like @TblPattern
        AND o.type IN (@objst, @objut, @objv, @objsyn)
      FOR READ ONLY
        OPEN tlst3
        FETCH tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

/*--------------------------------------------------------------------*
 *  Process the set of tables returned by the Query                   *
 *--------------------------------------------------------------------*/
    while (@@fetch_status = 0)
     begin
       insert into #tbllist values
              (@cid_name, @tbl_name, @tbl_type, @rows)

/*--------------------------------------------------------------------*
 *  Retrieve next record in result set                                *
 *--------------------------------------------------------------------*/
    if @mode = 0
        FETCH tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 1
        FETCH tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 2
        FETCH tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 3
        FETCH tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows

     end                               /* Loop thru result set        */

/*--------------------------------------------------------------------*
 *  Close the Query cursor                                            *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
        CLOSE tlst0
        deallocate tlst0
      end

    if @mode = 1
      begin
        CLOSE tlst1
        deallocate tlst1
      end

    if @mode = 2
      begin
        CLOSE tlst2
        deallocate tlst2
      end

    if @mode = 3
      begin
        CLOSE tlst3
        deallocate tlst3
      end

/*--------------------------------------------------------------------*
 *  Select the returned data, if any, for the Primary Keys            *
 *--------------------------------------------------------------------*/
     select CidName, TblName, TblType, RowCnt
        from #tbllist
       where TblType <> 'X'
        order by CidName, TblName
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEME
       @Name     sysname
 AS
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

     select spf.name, ds.name, sps.data_space_id, 
            sps.function_id, fanout 
       from sys.partition_schemes AS sps
     	     INNER JOIN sys.partition_functions AS spf 
         ON sps.function_id = spf.function_id
             inner join sys.destination_data_spaces dds
         on dds.partition_scheme_id = sps.data_space_id
             inner join sys.data_spaces ds
         on dds.data_space_id = ds.data_space_id
      where sps.name = @Name
      ORDER BY dds.destination_id 
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEMELIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
      SELECT NULL,name
        FROM sys.partition_schemes
       WHERE name = @Name
       order by name
      end


    if @SelMode = 2
      begin
      SELECT NULL,name
        FROM sys.partition_schemes
       WHERE name like @Name
       order by name
      end
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNC
       @Name     sysname
 AS
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

     select pp.collation_name, 
            SQL_VARIANT_PROPERTY (rv.value, 'BaseType'),
            CAST (rv.value AS varchar(4000)),
            pf.function_id, pp.max_length, pp.system_type_id, 
            pp.precision, pp.scale, pf.boundary_value_on_right
       from sys.partition_functions pf
             inner join sys.partition_parameters pp
         on pf.function_id = pp.function_id
             inner join sys.partition_range_values as rv
         ON rv.function_id = pf.function_id
      where pf.name = @Name
      ORDER BY rv.boundary_id
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNCLIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
      SELECT NULL,name
        FROM sys.partition_functions
       WHERE name = @Name
       order by name
      end


    if @SelMode = 2
      begin
      SELECT NULL,name
        FROM sys.partition_functions
       WHERE name like @Name
       order by name
      end
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSCIDOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSEXPVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETTBLLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEME to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARSCHEMELIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETPARFUNCLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

