set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSFINDDATATYPE
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETDATATYPE
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETASSYNAMES
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETUDTLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSFINDDATATYPE
       @CidName   sysname,
       @UdtName   sysname
 AS
     SELECT t.name,
            t.xtype,
            t.length,
            isnull(t.prec,0),
            isnull(t.scale,0),
            t.allownulls,
            isnull(t.tdefault,0),
            isnull(t.domain,0),
            t.uid,
            u.name,
            t.usertype
       FROM systypes t, sys.schemas u
     where t.name = @UdtName
       and u.schema_id = t.uid
       and u.name = @CidName
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETDATATYPE
       @UdtId  int
 AS
     set nocount on
     SELECT t.name,
            t.xtype,
            t.length,
            isnull(t.prec,0),
            isnull(t.scale,0),
            t.allownulls,
            isnull(t.tdefault,0),
            isnull(t.domain,0),
            t.uid,
            u.name
       FROM systypes t, sys.schemas u
      WHERE t.usertype = @UdtId
        AND u.schema_id = t.uid
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETASSYNAMES
       @UdtId  int
 AS
     set nocount on
     SELECT name,
            assembly_class
       FROM sys.assembly_types 
      WHERE user_type_id = @UdtId
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM90V0100_CSSGETUDTLIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
      SELECT u.name,
             t.name
        FROM systypes t, sys.schemas u
       WHERE t.usertype > 100
         and u.name = @Owner
         and t.name = @Name
         and t.uid = u.schema_id
       order by u.name, t.name
      end

    if @SelMode = 1
      begin
      SELECT u.name,
             t.name
        FROM systypes t, sys.schemas u
       WHERE t.usertype > 100
         and u.name like @Owner
         and t.name = @Name
         and t.uid = u.schema_id
       order by u.name, t.name
      end

    if @SelMode = 2
      begin
      SELECT u.name,
             t.name
        FROM systypes t, sys.schemas u
       WHERE t.usertype > 100
         and u.name = @Owner
         and t.name like @Name
         and t.uid = u.schema_id
       order by u.name, t.name
      end

    if @SelMode = 3
      begin
      SELECT u.name,
             t.name
        FROM systypes t, sys.schemas u
       WHERE t.usertype > 100
         and u.name like @Owner
         and t.name like @Name
         and t.uid = u.schema_id
       order by u.name, t.name
      end
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSFINDDATATYPE to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETDATATYPE to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETASSYNAMES to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM90V0100_CSSGETUDTLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

