set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETCHECK
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSEXPCHECK
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETCHECK
       @ObjNum int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)  

set      @dbname = ORIGINAL_DB_NAME()

     set nocount on
SET @sql = N'  
     select  o.id,
             case
               when (isnull(OBJECTPROPERTY(o.id,''CnstIsColumn''),0) <> 0)
                 then o.info
                 else 0
               end,
             case
               when (isnull(OBJECTPROPERTY(o.id,''CnstIsNotRepl''),0) <> 0)
                 then ''Y''
                 else ''N''
               end,
             case
               when (isnull(OBJECTPROPERTY(o.id,''CnstIsDisabled''),0) <> 0)
                 then ''Y''
                 else ''N''
               end,
             o.name
     from ['+ @dbname+'].sys.sysobjects o
     where OBJECTPROPERTY(o.id,''IsCheckCnst'') = 1
       and o.parent_obj = '+CAST(@ObjNum AS nvarchar(10))+'
     order by o.id'
     EXEC sp_executesql @sql
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSEXPCHECK
       @ObjNum int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     varchar(255)    /* current package record         */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @txt_cursor CURSOR


set @dbname = ORIGINAL_DB_NAME()


     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Check Text                         *
 *--------------------------------------------------------------------*/
     create table #chktxt(seqid  smallint primary key,
                          pkgtext varchar(256))

/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of Check constraint text           *
 *--------------------------------------------------------------------*/
SET @sql = N' 
     set @txt_cursor = cursor for
     select datalength(s.definition), s.definition
     from ['+ @dbname+'].sys.check_constraints s
     where s.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
     for read only;
     OPEN @txt_cursor'
EXEC sp_executesql @sql,N'@txt_cursor cursor output', @txt_cursor output     

/*--------------------------------------------------------------------*
 *  Extract 1st check constraint text record                          *
 *--------------------------------------------------------------------*/
     set @seqid = 0
--     open @txt_cursor
     fetch @txt_cursor into @Sl, @Stext

/*--------------------------------------------------------------------*
 *  Remove all text up to the start of the check expression           *
 *--------------------------------------------------------------------*/
     set @index = charindex('(',@Stext)
     if (@index > 0) set @Stext = stuff(@Stext,1,@index-1,'')
     set @index = @index-1
     set @Sl = @Sl - @index
/*--------------------------------------------------------------------*
 *  Read all records in Text set                                      *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #chktxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch @txt_cursor into @Sl, @Stext
     end
     close @txt_cursor
     deallocate @txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #chktxt
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETCHECK to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSEXPCHECK to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

