set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINDEX
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETFTINDEX
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSINDEXLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOUNTS
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOLLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSSPATIALINDEX
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETDCINDEX
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINDEX
       @ObjNum int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(max)  

set @dbname = ORIGINAL_DB_NAME() 

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end
--SET @sql = N' 
       EXEC('select si.name,
               isnull(ds.name,'' ''),
               ps.name,
               isnull(ic.column_id,0),
               si.data_space_id,
               si.index_id,
               case
                 when (isnull(si.type,0) = 3)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(si.ignore_dup_key,0) <> 0)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(i.status,0) & 4 = 4)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(si.is_primary_key,0) <> 0)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(si.is_unique_constraint,0) <> 0)
                 then ''U''
                 when (isnull(si.is_unique,0) <> 0)
                 then ''R''
                 else ''D''
               end,       
               case
                 when (isnull(IndexProperty(si.object_id,si.name,N''IsClustered''),0) <> 0)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(IndexProperty(si.object_id,si.name,N''IsPadIndex''),0) <> 0)
                 then ''Y''
                 else ''N''
               end,
               case
                 when (isnull(ds.is_default,0) <> 0)
                   then ''Y''
                   else ''N''
               end,
               case
                 when (isnull(IndexProperty(si.object_id,si.name,N''IsRowLockDisallowed''),0) <> 0)
                 then ''N''
                 else ''Y''
               end,
               case
                 when (isnull(IndexProperty(si.object_id,si.name,N''IsPageLockDisallowed''),0) <> 0) 
                 then ''N''
                 else ''Y''
               end,
               isnull(IndexProperty(si.object_id,si.name,N''IndexFillFactor''),0),
               0,
               (select count(x.object_id)
                  from ['+ @dbname+'].sys.index_columns x
                 where si.index_id = x.index_id 
                   and x.object_id = si.object_id
                   and x.is_included_column = 0),
               isnull(
               (select c1.name
                  from ['+ @dbname+'].sys.columns c1
                         inner join ['+ @dbname+'].sys.index_columns nic1
                    on c1.object_id = nic1.object_id
                   and c1.column_id = nic1.column_id
                 where nic1.index_column_id = 1
                   and nic1.is_included_column = 0
                   and nic1.index_id = si.index_id
                   and nic1.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic1.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic1
                 where dic1.index_column_id = 1
                   and dic1.is_included_column = 0
                   and dic1.index_id = si.index_id
                   and dic1.object_id = '+@ObjNum+'),'' ''),
               case
                 when (isnull(si.type,0) = 3)
                 then isnull(
                      (select prix.name
                         from ['+ @dbname+'].sys.xml_indexes prix
                        where prix.object_id = '+@ObjNum+'
                          and prix.index_id = xi.using_xml_index_id),'' '')
                 else isnull(
                      (select c2.name
                         from ['+ @dbname+'].sys.columns c2
                                inner join ['+ @dbname+'].sys.index_columns nic2
                           on c2.object_id = nic2.object_id
                          and c2.column_id = nic2.column_id
                        where nic2.index_column_id = 2
                          and nic2.is_included_column = 0
                          and nic2.index_id = si.index_id
                          and nic2.object_id = '+@ObjNum+'),'' '')
               end,
               case
                 when (isnull(si.type,0) = 3)
                 then isnull(xi.secondary_type,'' '')
                 else isnull(
                      (select 
                         case 
                           when isnull(dic2.is_descending_key,0) <> 0 then ''Y''
                         end  
                         from ['+ @dbname+'].sys.index_columns dic2
                        where dic2.index_column_id = 2
                          and dic2.is_included_column = 0
                          and dic2.index_id = si.index_id
                          and dic2.object_id = '+@ObjNum+'),'' '')
               end, 
               isnull(
               (select c3.name
                  from sys.columns c3
                         inner join ['+ @dbname+'].sys.index_columns nic3
                    on c3.object_id = nic3.object_id
                   and c3.column_id = nic3.column_id
                 where nic3.index_column_id = 3
                   and nic3.is_included_column = 0
                   and nic3.index_id = si.index_id
                   and nic3.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic3.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic3
                 where dic3.index_column_id = 3
                   and dic3.is_included_column = 0
                   and dic3.index_id = si.index_id
                   and dic3.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c4.name
                  from ['+ @dbname+'].sys.columns c4
                         inner join ['+ @dbname+'].sys.index_columns nic4
                    on c4.object_id = nic4.object_id
                   and c4.column_id = nic4.column_id
                 where nic4.index_column_id = 4
                   and nic4.is_included_column = 0
                   and nic4.index_id = si.index_id
                   and nic4.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic4.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic4
                 where dic4.index_column_id = 4
                   and dic4.is_included_column = 0
                   and dic4.index_id = si.index_id
                   and dic4.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c5.name
                  from ['+ @dbname+'].sys.columns c5
                         inner join ['+ @dbname+'].sys.index_columns nic5
                    on c5.object_id = nic5.object_id
                   and c5.column_id = nic5.column_id
                 where nic5.index_column_id = 5
                   and nic5.is_included_column = 0
                   and nic5.index_id = si.index_id
                   and nic5.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic5.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic5
                 where dic5.index_column_id = 5
                   and dic5.is_included_column = 0
                   and dic5.index_id = si.index_id
                   and dic5.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c6.name
                  from ['+ @dbname+'].sys.columns c6
                         inner join sys.index_columns nic6
                    on c6.object_id = nic6.object_id
                   and c6.column_id = nic6.column_id
                 where nic6.index_column_id = 6
                   and nic6.is_included_column = 0
                   and nic6.index_id = si.index_id
                   and nic6.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic6.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic6
                 where dic6.index_column_id = 6
                   and dic6.is_included_column = 0
                   and dic6.index_id = si.index_id
                   and dic6.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c7.name
                  from ['+ @dbname+'].sys.columns c7
                         inner join ['+ @dbname+'].sys.index_columns nic7
                    on c7.object_id = nic7.object_id
                   and c7.column_id = nic7.column_id
                 where nic7.index_column_id = 7
                   and nic7.is_included_column = 0
                   and nic7.index_id = si.index_id
                   and nic7.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic7.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic7
                 where dic7.index_column_id = 7
                   and dic7.is_included_column = 0
                   and dic7.index_id = si.index_id
                   and dic7.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c8.name
                  from ['+ @dbname+'].sys.columns c8
                         inner join ['+ @dbname+'].sys.index_columns nic8
                    on c8.object_id = nic8.object_id
                   and c8.column_id = nic8.column_id
                 where nic8.index_column_id = 8
                   and nic8.is_included_column = 0
                   and nic8.index_id = si.index_id
                   and nic8.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic8.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic8
                 where dic8.index_column_id = 8
                   and dic8.is_included_column = 0
                   and dic8.index_id = si.index_id
                   and dic8.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c9.name
                  from ['+ @dbname+'].sys.columns c9
                         inner join ['+ @dbname+'].sys.index_columns nic9
                    on c9.object_id = nic9.object_id
                   and c9.column_id = nic9.column_id
                 where nic9.index_column_id = 9
                   and nic9.is_included_column = 0
                   and nic9.index_id = si.index_id
                   and nic9.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic9.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic9
                 where dic9.index_column_id = 9
                   and dic9.is_included_column = 0
                   and dic9.index_id = si.index_id
                   and dic9.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c10.name
                  from ['+ @dbname+'].sys.columns c10
                         inner join ['+ @dbname+'].sys.index_columns nic10
                    on c10.object_id = nic10.object_id
                   and c10.column_id = nic10.column_id
                 where nic10.index_column_id = 10
                   and nic10.is_included_column = 0
                   and nic10.index_id = si.index_id
                   and nic10.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic10.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic10
                 where dic10.index_column_id = 10
                   and dic10.is_included_column = 0
                   and dic10.index_id = si.index_id
                   and dic10.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c11.name
                  from ['+ @dbname+'].sys.columns c11
                         inner join ['+ @dbname+'].sys.index_columns nic11
                    on c11.object_id = nic11.object_id
                   and c11.column_id = nic11.column_id
                 where nic11.index_column_id = 11
                   and nic11.is_included_column = 0
                   and nic11.index_id = si.index_id
                   and nic11.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic11.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic11
                 where dic11.index_column_id = 11
                   and dic11.is_included_column = 0
                   and dic11.index_id = si.index_id
                   and dic11.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c12.name
                  from ['+ @dbname+'].sys.columns c12
                         inner join ['+ @dbname+'].sys.index_columns nic12
                    on c12.object_id = nic12.object_id
                   and c12.column_id = nic12.column_id
                 where nic12.index_column_id = 12
                   and nic12.is_included_column = 0
                   and nic12.index_id = si.index_id
                   and nic12.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic12.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic12
                 where dic12.index_column_id = 12
                   and dic12.is_included_column = 0
                   and dic12.index_id = si.index_id
                   and dic12.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c13.name
                  from ['+ @dbname+'].sys.columns c13
                         inner join ['+ @dbname+'].sys.index_columns nic13
                    on c13.object_id = nic13.object_id
                   and c13.column_id = nic13.column_id
                 where nic13.index_column_id = 13
                   and nic13.is_included_column = 0
                   and nic13.index_id = si.index_id
                   and nic13.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic13.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic13
                 where dic13.index_column_id = 13
                   and dic13.is_included_column = 0
                   and dic13.index_id = si.index_id
                   and dic13.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c14.name
                  from ['+ @dbname+'].sys.columns c14
                         inner join ['+ @dbname+'].sys.index_columns nic14
                    on c14.object_id = nic14.object_id
                   and c14.column_id = nic14.column_id
                 where nic14.index_column_id = 14
                   and nic14.is_included_column = 0
                   and nic14.index_id = si.index_id
                   and nic14.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic14.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic14
                 where dic14.index_column_id = 14
                   and dic14.is_included_column = 0
                   and dic14.index_id = si.index_id
                   and dic14.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c15.name
                  from sys.columns c15
                         inner join ['+ @dbname+'].sys.index_columns nic15
                    on c15.object_id = nic15.object_id
                   and c15.column_id = nic15.column_id
                 where nic15.index_column_id = 15
                   and nic15.is_included_column = 0
                   and nic15.index_id = si.index_id
                   and nic15.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic15.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic15
                 where dic15.index_column_id = 15
                   and dic15.is_included_column = 0
                   and dic15.index_id = si.index_id
                   and dic15.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select c16.name
                  from ['+ @dbname+'].sys.columns c16
                         inner join ['+ @dbname+'].sys.index_columns nic16
                    on c16.object_id = nic16.object_id
                   and c16.column_id = nic16.column_id
                 where nic16.index_column_id = 16
                   and nic16.is_included_column = 0
                   and nic16.index_id = si.index_id
                   and nic16.object_id = '+@ObjNum+'),'' ''),
               isnull(
               (select 
                  case 
                    when isnull(dic16.is_descending_key,0) <> 0 then ''Y''
                  end  
                  from ['+ @dbname+'].sys.index_columns dic16
                 where dic16.index_column_id = 16
                   and dic16.is_included_column = 0
                   and dic16.index_id = si.index_id
                   and dic16.object_id = '+@ObjNum+'),'' ''),
                (select max(data_compression) from ['+ @dbname+'].sys.partitions p1
				where p1.object_id = si.object_id
				and p1.index_id = si.index_id
				and data_compression > 0),						 
				isnull(si.has_filter,0),
				isnull(si.filter_definition, '' '')
          from ['+ @dbname+'].sys.indexes si
                left outer join ['+ @dbname+'].sys.data_spaces ds
            on si.data_space_id = ds.data_space_id 
                left outer join ['+ @dbname+'].sys.sysindexes i 
            on si.object_id = i.id
           and si.name = i.name
                left outer join ['+ @dbname+'].sys.partition_schemes ps
            on ps.data_space_id = si.data_space_id
                left outer join ['+ @dbname+'].sys.index_columns ic
            on si.object_id = ic.object_id
           and si.index_id = ic.index_id
           and ic.partition_ordinal > 0
                left outer join ['+ @dbname+'].sys.xml_indexes xi
            on si.object_id = xi.object_id
           and si.index_id = xi.index_id 
           where si.object_id = '+@ObjNum+'
           and si.index_id > 0
           and si.type != 4
           and INDEXPROPERTY(si.object_id,si.name,''IsStatistics'') <> 1
           and INDEXPROPERTY(si.object_id,si.name,''IsAutoStatistics'') <> 1
           and INDEXPROPERTY(si.object_id,si.name,''IsHypothetical'') <> 1')
--EXEC sp_executesql @sql           
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETFTINDEX
       @ObjNum int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(max)  

set @dbname = ORIGINAL_DB_NAME() 
 
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end


SET @sql = N'
     select (select count(*) 
               from ['+ @dbname+'].sys.fulltext_index_columns
              where object_id = '+CAST(@ObjNum AS nvarchar(10))+'),
            i.name, cat.name, c.name, tc.name, il.name,
            fti.change_tracking_state  
       from ['+ @dbname+'].sys.fulltext_indexes fti
              inner join ['+ @dbname+'].sys.indexes i
         on i.object_id = fti.object_id
        and i.index_id  = fti.unique_index_id    
              inner join ['+ @dbname+'].sys.fulltext_catalogs cat
         on fti.fulltext_catalog_id = cat.fulltext_catalog_id
              inner join ['+ @dbname+'].sys.fulltext_index_columns ic
         on i.object_id = ic.object_id
              inner join ['+ @dbname+'].sys.fulltext_languages il
         on ic.language_id = il.lcid
              inner join ['+ @dbname+'].sys.columns c
         on i.object_id = c.object_id
        and c.column_id = ic.column_id
              left outer join ['+ @dbname+'].sys.columns tc
         on c.object_id = tc.object_id
        and isnull(ic.type_column_id,0) = tc.column_id
      where i.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
      order by c.column_id'
EXEC sp_executesql @sql      
go
  

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSINDEXLIST
       @ExclType smallint,
       @InclType smallint
 AS
declare  @tid       int             /* Table object id                */
declare  @status    int             /* Index status flags             */
declare  @cid       smallint        /* Table owner Id                 */
declare  @idxid     smallint        /* Index identifier               */
declare  @keycnt    smallint        /* Number keys in index           */
declare  @mode      smallint        /* Table exclusion mode           */
declare  @obj_name  nvarchar(258)   /* User.Table Name                */
declare  @idxname   sysname         /* Index name                     */
declare  @Unq       char(1)         /* Index Type U, D, P             */
declare  @Use       char(1)         /* Output record                  */

declare  @is_unique       bit             
declare  @is_primary_key  bit             
declare  @ignore_dup_key  bit
declare  @dbname          sysname
DECLARE  @sql             nvarchar(4000)
declare  @lst_cursor0     CURSOR
declare  @lst_cursor1     CURSOR
declare  @lst_cursor2     CURSOR
declare  @lst_cursor3     CURSOR

set @dbname = ORIGINAL_DB_NAME()             

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Index Key data.                    *
 *--------------------------------------------------------------------*/
     create table #idxlist(cidname  sysname,
                           tblname  sysname,
                           idxname  sysname,
                           unqidx   char(1),
                           keycnt   smallint,
                           cname1   sysname,
                           cname1s  char(1),
                           cname2   sysname null,
                           cname2s  char(1) null,
                           cname3   sysname null,
                           cname3s  char(1) null,
                           cname4   sysname null,
                           cname4s  char(1) null,
                           cname5   sysname null,
                           cname5s  char(1) null,
                           cname6   sysname null,
                           cname6s  char(1) null,
                           cname7   sysname null,
                           cname7s  char(1) null,
                           cname8   sysname null,
                           cname8s  char(1) null,
                           cname9   sysname null,
                           cname9s  char(1) null,
                           cname10  sysname null,
                           cname10s char(1) null,
                           cname11  sysname null,
                           cname11s char(1) null,
                           cname12  sysname null,
                           cname12s char(1) null,
                           cname13  sysname null,
                           cname13s char(1) null,
                           cname14  sysname null,
                           cname14s char(1) null,
                           cname15  sysname null,
                           cname15s char(1) null,
                           cname16  sysname null,
                           cname16s char(1) null)

/*--------------------------------------------------------------------*
 *  Determine the Table exclusion mode                                *
 *--------------------------------------------------------------------*/
    set @mode = 0
    if (@ExclType & 4 = 4) set @mode = 1          /* System Tables */
    if (@ExclType & 2 = 2) set @mode = @mode + 2  /* PK Tables     */

/*--------------------------------------------------------------------*
 *  Declare,Open the appropriate cursor and fetch 1st record          *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of sysindexes                         *
 *  Includes all indexes                                              *
 *--------------------------------------------------------------------*/
SET @sql = N' 
    set @lst_cursor0 = cursor for
        select i.name,
               i.index_id,
               i.is_unique,
               i.is_primary_key,
               i.ignore_dup_key,
               (select count(x.object_id)
                  from ['+ @dbname+'].sys.index_columns x
                 where i.index_id = x.index_id and x.object_id = i.object_id),
               i.object_id,
               o.schema_id
          from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o
          where OBJECTPROPERTY(o.object_id,''IsTable'') = 1
            and OBJECTPROPERTY(o.object_id,''TableHasIndex'') = 1
            and o.object_id = i.object_id
            and i.index_id > 0
            and i.index_id < 255
            and INDEXPROPERTY(o.object_id,i.name,''IsStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsAutoStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsHypothetical'') <> 1
          for read only;
          OPEN @lst_cursor0'
EXEC sp_executesql @sql,N'@lst_cursor0 cursor output', @lst_cursor0 output
--        OPEN lst_cursor0
        fetch @lst_cursor0 into @idxname,
                               @idxid,
                               @is_unique,
                               @is_primary_key,
                               @ignore_dup_key,
                               @keycnt,
                               @tid,
                               @cid
      end

    if @mode = 1
      begin
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of sysindexes                         *
 *  Excludes indexes for System Tables                                *
 *--------------------------------------------------------------------*/
SET @sql = N' 
    set @lst_cursor1 = cursor for
        select i.name,
               i.index_id,
               i.is_unique,
               i.is_primary_key,
               i.ignore_dup_key,
               (select count(x.object_id)
                  from ['+ @dbname+'].sys.index_columns x
                 where i.index_id = x.index_id and x.object_id = i.object_id),
               i.object_id,
               o.schema_id
          from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o
          where OBJECTPROPERTY(o.object_id,''IsTable'') = 1
            and OBJECTPROPERTY(o.object_id,''TableHasIndex'') = 1
            and OBJECTPROPERTY(o.object_id,''IsSystemTable'') = 0
            and o.object_id = i.object_id
            and i.index_id > 0
            and i.index_id < 255
            and INDEXPROPERTY(o.object_id,i.name,''IsStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsAutoStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsHypothetical'') <> 1
          for read only;
          OPEN @lst_cursor1'
EXEC sp_executesql @sql,N'@lst_cursor1 cursor output', @lst_cursor1 output
--        OPEN lst_cursor1
        fetch @lst_cursor1 into @idxname,
                               @idxid,
                               @is_unique,
                               @is_primary_key,
                               @ignore_dup_key,
                               @keycnt,
                               @tid,
                               @cid
      end

    if @mode = 2
      begin
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of sysindexes                         *
 *  Excludes indexes for Tables with Primary Keys                     *
 *--------------------------------------------------------------------*/
SET @sql = N' 
    set @lst_cursor2 = cursor for
        select i.name,
               i.index_id,
               i.is_unique,
               i.is_primary_key,
               i.ignore_dup_key,
               (select count(x.object_id)
                  from ['+ @dbname+'].sys.index_columns x
                 where i.index_id = x.index_id and x.object_id = i.object_id),
               i.object_id,
               o.schema_id
          from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o
          where OBJECTPROPERTY(o.object_id,''IsTable'') = 1
            and OBJECTPROPERTY(o.object_id,''TableHasIndex'') = 1
            and OBJECTPROPERTY(o.object_id,''TableHasPrimaryKey'') = 0
            and o.object_id = i.object_id
            and i.index_id > 0
            and i.index_id < 255
            and INDEXPROPERTY(o.object_id,i.name,''IsStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsAutoStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsHypothetical'') <> 1
          for read only;
          OPEN @lst_cursor2'
EXEC sp_executesql @sql,N'@lst_cursor2 cursor output', @lst_cursor2 output
--        OPEN lst_cursor2
        fetch @lst_cursor2 into @idxname,
                               @idxid,
                               @is_unique,
                               @is_primary_key,
                               @ignore_dup_key,
                               @keycnt,
                               @tid,
                               @cid
      end

    if @mode = 3
      begin
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of sysindexes                         *
 *  Excludes indexes for System Tables and Tables with Primary Keys   *
 *--------------------------------------------------------------------*/
SET @sql = N' 
    set @lst_cursor3 = cursor for
        select i.name,
               i.index_id,
               i.is_unique,
               i.is_primary_key,
               i.ignore_dup_key,
               (select count(x.object_id)
                  from ['+ @dbname+'].sys.index_columns x
                 where i.index_id = x.index_id and x.object_id = i.object_id),
               i.object_id,
               o.schema_id
          from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o
          where OBJECTPROPERTY(o.object_id,''IsTable'') = 1
            and OBJECTPROPERTY(o.object_id,''IsSystemTable'') = 0
            and OBJECTPROPERTY(o.object_id,''TableHasIndex'') = 1
            and OBJECTPROPERTY(o.object_id,''TableHasPrimaryKey'') = 0
            and o.object_id = i.object_id
            and i.index_id > 0
            and i.index_id < 255
            and INDEXPROPERTY(o.object_id,i.name,''IsStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsAutoStatistics'') <> 1
            and INDEXPROPERTY(o.object_id,i.name,''IsHypothetical'') <> 1
          for read only;
          OPEN @lst_cursor3'
EXEC sp_executesql @sql,N'@lst_cursor3 cursor output', @lst_cursor3 output
--        OPEN lst_cursor3
        fetch @lst_cursor3 into @idxname,
                               @idxid,
                               @is_unique,
                               @is_primary_key,
                               @ignore_dup_key,
                               @keycnt,
                               @tid,
                               @cid
      end

/*--------------------------------------------------------------------*
 *  Process the rows returned and populate entries in                 *
 *  #idxlist temporary table                                          *
 *--------------------------------------------------------------------*/
    while (@@fetch_status = 0)
    begin
      
      /* set @Unq = 'D'               Assume Duplicates allowed        #ramuk */
      /* if (@status & 2 = 2) set @Unq = 'U'      Unique or PK         */
      /* if (@status & 2048 = 2048) set @Unq = 'P'       Primary Key   */
      
      set @Unq = 'X' /* Initialize something not condsidered in the below 3 if conditions */
      
      if (@ignore_dup_key = 1)   set @Unq = 'D'  /* IGNORE_DUP_KEY is ON. added check #ramuk */
      if (@is_unique = 1)        set @Unq = 'U'  /* added check #ramuk */
      if (@is_primary_key = 1)   set @Unq = 'P'  /* added check #ramuk */
      

/*--------------------------------------------------------------------*
 *  Determine if index type to be included                            *
 *--------------------------------------------------------------------*/
     set @Use = 'N'              /* Assume excluded                */
     if (@InclType & 1 = 1 and @Unq = 'P') set @Use = 'Y'
     if (@InclType & 2 = 2 and @Unq = 'U') set @Use = 'Y'
     if (@InclType & 4 = 4 and @Unq = 'D') set @Use = 'Y'

/*--------------------------------------------------------------------*
 *  Add the index record to the Temporary table                       *
 *--------------------------------------------------------------------*/
     if (@Use = 'Y')
       begin
         set @obj_name = schema_name(@cid) + '.' + object_name(@tid)
         insert into #idxlist values
               (schema_name(@cid),
                object_name(@tid),
                @idxname,
                @Unq,
                @keycnt,
                isnull(index_col(@obj_name,@idxid,1),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,1,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,2),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,2,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,3),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,3,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,4),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,4,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,5),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,5,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,6),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,6,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,7),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,7,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,8),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,8,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,9),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,9,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,10),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,10,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,11),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,11,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,12),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,12,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,13),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,13,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,14),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,14,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,15),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,15,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end,
                isnull(index_col(@obj_name,@idxid,16),' '),
                case
                   when INDEXKEY_PROPERTY(@tid,@idxid,16,'IsDescending') <> 1
                     then ' '
                     else 'Y'
                end)
       end
/*--------------------------------------------------------------------*
 *  Fetch the next record using the proper cursor                     *
 *--------------------------------------------------------------------*/
      if @mode = 0
          fetch @lst_cursor0 into @idxname,
                                 @idxid,
                                 @is_unique,
                                 @is_primary_key,
                                 @ignore_dup_key,
                                 @keycnt,
                                 @tid,
                                 @cid

      if @mode = 1
          fetch @lst_cursor1 into @idxname,
                                 @idxid,
                                 @is_unique,
                                 @is_primary_key,
                                 @ignore_dup_key,
                                 @keycnt,
                                 @tid,
                                 @cid

      if @mode = 2
          fetch @lst_cursor2 into @idxname,
                                 @idxid,
                                 @is_unique,
                                 @is_primary_key,
                                 @ignore_dup_key,
                                 @keycnt,
                                 @tid,
                                 @cid

      if @mode = 3
          fetch @lst_cursor3 into @idxname,
                                 @idxid,
                                 @is_unique,
                                 @is_primary_key,
                                 @ignore_dup_key,
                                 @keycnt,
                                 @tid,
                                 @cid
    end

/*--------------------------------------------------------------------*
 *  Close the Query cursor                                            *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
        CLOSE @lst_cursor0
        deallocate @lst_cursor0
     end

    if @mode = 1
      begin
        CLOSE @lst_cursor1
        deallocate @lst_cursor1
     end

    if @mode = 2
      begin
        CLOSE @lst_cursor2
        deallocate @lst_cursor2
     end

    if @mode = 3
      begin
        CLOSE @lst_cursor3
        deallocate @lst_cursor3
     end

/*--------------------------------------------------------------------*
 *  Select the returned data, if any, for the Index List              *
 *--------------------------------------------------------------------*/
     select cidname,tblname,idxname,
            unqidx,keycnt,
            cname1,cname1s,cname2,cname2s,cname3,cname3s,cname4,cname4s,
            cname5,cname5s,cname6,cname6s,cname7,cname7s,cname8,cname8s,
            cname9,cname9s,cname10,cname10s,cname11,cname11s,cname12,cname12s,
            cname13,cname13s,cname14,cname14s,cname15,cname15s,cname16,cname16s
        from #idxlist
        order by cidname,tblname,idxname
     return(0)
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOUNTS
       @Var1     int,
       @Var2     int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
  
set @dbname = ORIGINAL_DB_NAME()
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

SET @sql = N'
     select count(*), sum(len(c.name))  
       from ['+ @dbname+'].sys.columns c
              inner join ['+ @dbname+'].sys.index_columns ic
         on c.object_id = ic.object_id
        and c.column_id = ic.column_id
      where ic.object_id = '+CAST(@Var1 AS nvarchar(10))+'
        and ic.index_id = '+CAST(@Var2 AS nvarchar(10))+'
        and ic.is_included_column <> 0'
EXEC sp_executesql @sql        
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOLLIST
       @Var1     int,
       @Var2     int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
  
set @dbname = ORIGINAL_DB_NAME() 

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

SET @sql = N'
     select c.name  
       from ['+ @dbname+'].sys.columns c
              inner join ['+ @dbname+'].sys.index_columns ic
         on c.object_id = ic.object_id
        and c.column_id = ic.column_id
      where ic.object_id = '+CAST(@Var1 AS nvarchar(10))+'
        and ic.index_id = '+CAST(@Var2 AS nvarchar(10))+'
        and ic.is_included_column <> 0
      order by ic.index_column_id'
EXEC sp_executesql @sql      
go

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Spatial Index Parameter values          *
 *--------------------------------------------------------------------*/
 CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSSPATIALINDEX
       @ObjNum int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
  
set @dbname = ORIGINAL_DB_NAME() 

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

SET @sql = N'     
   select (select count(s1.object_id)
            from ['+ @dbname+'].sys.spatial_indexes s1
            where s1.object_id = o.object_id
            and s1.object_id =  '+CAST(@ObjNum AS nvarchar(10))+'),				
            i.OBJECT_ID,
            i.name,
            i.index_id,
            c.name,
			t.tessellation_scheme,	
			level_1_grid_desc,
			level_2_grid_desc,
			level_3_grid_desc,
			level_4_grid_desc,
			bounding_box_xmin, 
			bounding_box_ymin,
			bounding_box_xmax, 
			bounding_box_ymax,
			level_1_grid,
			level_2_grid,
			level_3_grid,
			level_4_grid,
			cells_per_object,
			case
                 when (isnull(IndexProperty(s.object_id,s.name,N''IsPadIndex''),0) <> 0)
                 then ''Y''
                 else ''N''
            end,
			isnull(IndexProperty(s.object_id,s.name,N''IndexFillFactor''),0),
			case
                 when (isnull(s.ignore_dup_key,0) <> 0)
                 then ''Y''
                 else ''N''
            end,
			case
                 when (isnull(IndexProperty(s.object_id,s.name,N''IsRowLockDisallowed''),0) <> 0)
                 then ''N''
                 else ''Y''
            end,
            case
                 when (isnull(IndexProperty(s.object_id,s.name,N''IsPageLockDisallowed''),0) <> 0) 
                 then ''N''
                 else ''Y''
            end
			from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o,
			['+ @dbname+'].sys.spatial_index_tessellations t, 
			['+ @dbname+'].sys.spatial_indexes s,['+ @dbname+'].sys.all_columns c,
			['+ @dbname+'].sys.index_columns ic
			where o.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
			and i.object_id = o.object_id
			and i.object_id = t.object_id
			and i.object_id = s.object_id
			and c.object_id = s.object_id
			and c.object_id = ic.object_id
			and ic.object_id = i.object_id
			and i.index_id = t.index_id
			and i.index_id = s.index_id
			and ic.index_id = s.index_id
		    and c.column_id = ic.column_id
			and i.type = 4'
EXEC sp_executesql @sql			
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM10V0100_CSSGETDCINDEX
        @ObjNum int,
        @ObjName   sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
  
set @dbname = ORIGINAL_DB_NAME()

 set nocount on
SET @sql = N'  
 SELECT isnull(p.data_compression,0),
        isnull(p.data_compression_desc, '' ''),
        MIN(p.partition_number),
        MAX(p.partition_number),
        count(p.partition_number)
   FROM ['+ @dbname+'].sys.indexes si    
     left outer join ['+ @dbname+'].sys.partitions p
     ON si.object_id = p.object_id
     and si.index_id = p.index_id      
  where si.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
           and si.name = '''+@ObjName+'''
           and si.index_id > 0
           and INDEXPROPERTY(si.object_id,si.name,''IsStatistics'') <> 1
           and INDEXPROPERTY(si.object_id,si.name,''IsAutoStatistics'') <> 1
           and INDEXPROPERTY(si.object_id,si.name,''IsHypothetical'') <> 1
           and p.data_compression > 0
   GROUP BY p.data_compression, p.data_compression_desc
   ORDER BY MIN(p.partition_number)'
 EXEC sp_executesql @sql
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINDEX to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETFTINDEX to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSINDEXLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOUNTS to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETINCCOLLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSSPATIALINDEX to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM10V0100_CSSGETDCINDEX to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

