set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSFINDDATATYPE
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETDATATYPE
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETASSYNAMES
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETUDTLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSFINDDATATYPE
       @CidName   sysname,
       @UdtName   sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set @dbname = ORIGINAL_DB_NAME()

SET @sql = N'
     SELECT t.name,
            t.xtype,
            t.length,
            isnull(t.prec,0),
            isnull(t.scale,0),
            t.allownulls,
            isnull(t.tdefault,0),
            isnull(t.domain,0),
            t.uid,
            u.name,
            t.usertype
       FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
     where t.name = '''+@UdtName+'''
       and u.schema_id = t.uid
       and u.name = '''+@CidName+''
EXEC sp_executesql @sql
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETDATATYPE
       @UdtId  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
SET @sql = N'
     SELECT t.name,
            t.xtype,
            t.length,
            isnull(t.prec,0),
            isnull(t.scale,0),
            t.allownulls,
            isnull(t.tdefault,0),
            isnull(t.domain,0),
            t.uid,
            u.name
       FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
      WHERE t.usertype = '+CAST(@UdtId AS nvarchar(10))+'
        AND u.schema_id = t.uid'
EXEC sp_executesql @sql
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETASSYNAMES
       @UdtId  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()
     set nocount on

SET @sql = N'
     SELECT name,
            assembly_class
       FROM ['+ @dbname+'].sys.assembly_types
      WHERE user_type_id = '+CAST(@UdtId AS nvarchar(10))
EXEC sp_executesql @sql
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM16V0100_CSSGETUDTLIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
SET @sql = N'
      SELECT u.name,
             t.name
        FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
       WHERE t.usertype > 100
         and u.name = '''+@Owner+'''
         and t.name = '''+@Name+'''
         and t.uid = u.schema_id
       order by u.name, t.name'
       EXEC sp_executesql @sql
      end

    if @SelMode = 1
      begin
SET @sql = N'
      SELECT u.name,
             t.name
        FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+']sys.schemas u
       WHERE t.usertype > 100
         and u.name like '''+@Owner+'''
         and t.name = '''+@Name+'''
         and t.uid = u.schema_id
       order by u.name, t.name'
       EXEC sp_executesql @sql
      end

    if @SelMode = 2
      begin
SET @sql = N'
      SELECT u.name,
             t.name
        FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
       WHERE t.usertype > 100
         and u.name = '''+@Owner+'''
         and t.name like '''+@Name+'''
         and t.uid = u.schema_id
       order by u.name, t.name'
       EXEC sp_executesql @sql
      end

    if @SelMode = 3
      begin
SET @sql = N'
      SELECT u.name,
             t.name
        FROM ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
       WHERE t.usertype > 100
         and u.name like '''+@Owner+'''
         and t.name like '''+@Name+'''
         and t.uid = u.schema_id
       order by u.name, t.name'
       EXEC sp_executesql @sql
      end
go


grant execute on ~ALTSPQUALIFIER..PSTM16V0100_CSSFINDDATATYPE to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM16V0100_CSSGETDATATYPE to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM16V0100_CSSGETASSYNAMES to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM16V0100_CSSGETUDTLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

