set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCIDLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCIDLIST
        @CidPattern sysname
  AS
 declare  @mode      smallint        /* Query Mode in effect           */
 declare  @dbname   sysname
 DECLARE  @sql      nvarchar(4000)

      set @dbname = ORIGINAL_DB_NAME()
      set nocount on
 /*--------------------------------------------------------------------*
  *  Compute the Query select to use for this scan                     *
  *  bas-ed on whether the input pattern has LIKE wildcards.            *
  *  Mode values are:                                                  *
  *       0 - Explicit Creator name                                    *
  *       1 - Generic Creator name                                     *
  *--------------------------------------------------------------------*/
      set @mode = 0                  /* Assume Explicit CID/TBL names  */

 /*--------------------------------------------------------------------*
  *  Check Creator Name for LIKE wildcard characters                   *
  *--------------------------------------------------------------------*/
      if ((charindex('%',@CidPattern) > 0) or
          (charindex('_',@CidPattern) > 0))
        set @mode = 1

 /*--------------------------------------------------------------------*
  *  Process the appropriate select and retrieve record                *
  *--------------------------------------------------------------------*/
     if @mode = 0
      set @sql = N'
      SELECT DISTINCT u.name, u.schema_id
                 FROM ['+ @dbname+'].sys.schemas u,['+ @dbname+'].sys.all_objects o
                WHERE (OBJECTPROPERTY(o.object_id,''IsTable'') = 1 or OBJECTPROPERTY(o.object_id,''IsView'') = 1)
                  AND u.schema_id = o.schema_id
                  AND u.name like @ParCidPattern ORDER BY u.name'
	  EXEC sp_executesql @sql, N'@ParCidPattern sysname', @ParCidPattern = @CidPattern

     if @mode = 1
      set @sql = N'
      SELECT DISTINCT u.name, u.schema_id
                 FROM ['+ @dbname+'].sys.schemas u,['+ @dbname+'].sys.all_objects o
                WHERE (OBJECTPROPERTY(o.object_id,''IsTable'') = 1 or OBJECTPROPERTY(o.object_id,''IsView'') = 1)
                  AND u.schema_id = o.schema_id
                  AND u.name like @ParCidPattern ORDER BY u.name'
	  EXEC sp_executesql @sql, N'@ParCidPattern sysname', @ParCidPattern = @CidPattern
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCIDLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

