set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSCHECKHAMESPACE
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSCHECKHAMESPACE
       @CreatorName       sysname,
       @ObjectName        sysname,
       @QualifierName     sysname,
       @QualifierCreator  sysname,
       @ObjType           int
AS
BEGIN
   declare  @objectType    char(2)
   declare  @constraintId  int
   declare  @objId         int
   declare  @constrStatus  int
   declare  @trigId        int
   declare  @trigIns       int
   declare  @trigUpd       int
   declare  @trigDel       int
   declare  @dbname        sysname
   DECLARE  @sql           nvarchar(4000)

   set      @dbname = ORIGINAL_DB_NAME()


   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

if((@ObjType = 1) or  /*table*/
   (@ObjType = 2) or  /*view*/
   (@ObjType = 4) or  /*rule*/
   (@ObjType = 5) or  /*default*/
   (@ObjType =14) or  /*synonym*/
   (@ObjType =15) or  /*function*/
   (@ObjType =16))    /*procedure*/
  begin
SET @sql = N'
       select o.type, ''?'', ''?''
       from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
      where (o.schema_id = u.schema_id)
        and (u.name = @ParCreatorName)
        and (o.name = @ParObjectName)'

        EXEC sp_executesql @sql, 
				N'@ParCreatorName sysname, @ParObjectName sysname', 
				@ParCreatorName = @CreatorName, @ParObjectName = @ObjectName
  end
else if(@ObjType =12) /*trigger*/
  begin
SET @sql = N'
     select @objectType = o.type, @objId = o.parent_object_id, @trigId = o.object_id
       from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
      where (o.schema_id = u.schema_id)
        and (u.name = @ParQualifierCreator)
        and (o.name = @ParQualifierName)'

     EXEC sp_executesql
                 @query = @sql,
                 @params = N'@objectType char(2) OUTPUT,@objId int OUTPUT,@trigId int OUTPUT,
							 @ParQualifierCreator sysname, @ParQualifierName sysname',
                 @objectType=@objectType OUTPUT,@objId=@objId OUTPUT,@trigId=@trigId OUTPUT,
				 @ParQualifierCreator = @QualifierCreator, @ParQualifierName = @QualifierName

     if((@@rowcount > 0) and (@objectType in('TR', 'TA')))
       begin
        select @trigIns = ObjectProperty(@trigId, 'ExecIsInsertTrigger')
        select @trigUpd = ObjectProperty(@trigId, 'ExecIsUpdateTrigger')
        select @trigDel = ObjectProperty(@trigId, 'ExecIsDeleteTrigger')

SET @sql = N'
        select (''T'' +
               case
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=0)and('+CAST(@trigUpd AS VARCHAR(10))+'=0)and('+CAST(@trigDel AS VARCHAR(10))+'=0) then ''0''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=0)and('+CAST(@trigUpd AS VARCHAR(10))+'=0)and('+CAST(@trigDel AS VARCHAR(10))+'=1) then ''1''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=0)and('+CAST(@trigUpd AS VARCHAR(10))+'=1)and('+CAST(@trigDel AS VARCHAR(10))+'=0) then ''2''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=0)and('+CAST(@trigUpd AS VARCHAR(10))+'=1)and('+CAST(@trigDel AS VARCHAR(10))+'=1) then ''3''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=1)and('+CAST(@trigUpd AS VARCHAR(10))+'=0)and('+CAST(@trigDel AS VARCHAR(10))+'=0) then ''4''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=1)and('+CAST(@trigUpd AS VARCHAR(10))+'=0)and('+CAST(@trigDel AS VARCHAR(10))+'=1) then ''5''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=1)and('+CAST(@trigUpd AS VARCHAR(10))+'=1)and('+CAST(@trigDel AS VARCHAR(10))+'=0) then ''6''
                   when ('+CAST(@trigIns AS VARCHAR(10))+'=1)and('+CAST(@trigUpd AS VARCHAR(10))+'=1)and('+CAST(@trigDel AS VARCHAR(10))+'=1) then ''7''
               end),
               o.name, u.name
          from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
         where (o.schema_id = u.schema_id)
           and (o.object_id = '+CAST(@objId AS nvarchar(10))+')'
         EXEC sp_executesql @sql
       end
     else if(@@rowcount > 0)
        select @objectType, '?', '?'
     else
        select '?', '?', '?'
        where  0=1 /*empty set*/
  end
else if(
   (@ObjType = 7) or  /*check*/
   (@ObjType = 9) or  /*PrimKey*/
   (@ObjType =10) or  /*relKey*/
   (@ObjType =11))    /*unique*/
  begin
SET @sql = N'
     select @objectType = o.type,
            @constraintId = isnull(c.constid,0),
            @constrStatus = (isnull(c.status,0) &2)
       from ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.all_objects o
       LEFT JOIN ['+ @dbname+'].sys.sysconstraints c
         on o.object_id = c.constid
      where (o.schema_id = u.schema_id)
        and (u.name = @ParCreatorName)
        and (o.name = @ParQualifierName)'

     EXEC sp_executesql
                 @query = @sql,
                 @params = N'@objectType char(2) OUTPUT,@constraintId int OUTPUT,@constrStatus int OUTPUT,
				 			 @ParCreatorName sysname, @ParQualifierName sysname',
                 @objectType=@objectType OUTPUT,@constraintId=@constraintId OUTPUT,@constrStatus=@constrStatus OUTPUT,
				 @ParCreatorName = @CreatorName, @ParQualifierName = @QualifierName

     if(@@rowcount > 0)
         begin
             if(@constraintId <> 0)
               begin
                   if((@constrStatus = 2)and(@objectType = 'K'))
                     select @objectType = 'Q '
                SET @sql = N'
                   select '''+@objectType+''', tob.name, tu.name
                     from ['+ @dbname+'].sys.sysconstraints c, ['+ @dbname+'].sys.all_objects tob, ['+ @dbname+'].sys.schemas tu
                    where ('+CAST(@constraintId AS VARCHAR(10))+' = c.constid)
                      and (c.id = tob.object_id)
                      and (tob.schema_id = tu.schema_id)'
                 EXEC sp_executesql @sql
               end
             else
               select @objectType, '?', '?'
         end
      else
         select '?', '?', '?'
         where 1=2 /* return empty set */
  end
else if(@ObjType = 8) /*index*/
  begin
     if substring(@QualifierName, 1, 1) = '<'
        begin
        SET @sql = N'
           select
             case
               when isnull(i.object_id,0)>0
               then ''I ''
             end
             from ['+ @dbname+'].sys.tables t
                   inner join ['+ @dbname+'].sys.fulltext_indexes i
               on i.object_id = t.object_id
            where t.name = substring(@ParQualifierName, 2, len(@ParQualifierName)-2)
              and t.schema_id = schema_ID(@ParCreatorName)'
         EXEC sp_executesql @sql, N'@ParQualifierName sysname, @ParCreatorName sysname',
						@ParQualifierName = @QualifierName, @ParCreatorName = @CreatorName
        end
     else
        begin
        SET @sql = N'
           select ''I '', @ParObjectName, @ParCreatorName
             from ['+ @dbname+'].sys.indexes i, ['+ @dbname+'].sys.all_objects o
            where i.object_id = o.object_id
              and o.schema_id = schema_ID(@ParCreatorName)
              and o.name = @ParObjectName
              and i.name = @ParQualifierName'
         EXEC sp_executesql @sql, N'@ParCreatorName sysname, @ParObjectName sysname, @ParQualifierName sysname',
					@ParCreatorName = @CreatorName, @ParObjectName = @ObjectName, @ParQualifierName = @QualifierName
        end
  end
else if(@ObjType = 6)  /*datatype*/
  begin
SET @sql = N'
    select ''Y '', ''?'', ''?''
    from ['+ @dbname+'].sys.systypes
    where name = @ParObjectName
      and uid = schema_ID(@ParCreatorName)'
EXEC sp_executesql @sql, N'@ParCreatorName sysname, @ParObjectName sysname',
					@ParCreatorName = @CreatorName, @ParObjectName = @ObjectName
  end
else if(@ObjType = 29) /*assembly*/
  begin
SET @sql = N'
    select ''= '',''?'',''?''
    from ['+ @dbname+'].sys.assemblies
    where name = @ParObjectName'
EXEC sp_executesql @sql, N'@ParObjectName sysname', @ParObjectName = @ObjectName
  end
else if(@ObjType = 30) /*partition scheme*/
  begin
SET @sql = N'
    select ''= '',''?'',''?''
    from ['+ @dbname+'].sys.partition_schemes
    where name = @ParObjectName'
EXEC sp_executesql @sql, N'@ParObjectName sysname', @ParObjectName = @ObjectName
  end
else if(@ObjType = 31) /*partition function*/
  begin
SET @sql = N'
    select ''= '',''?'',''?''
    from ['+ @dbname+'].sys.partition_functions
    where name = @ParObjectName'
EXEC sp_executesql @sql, N'@ParObjectName sysname', @ParObjectName = @ObjectName
  end
else
  begin
    select '?', '?', '?'
  end

END
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSCHECKHAMESPACE to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

