set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDEPENDS
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDEPENDS
       @CidUid    smallint,
       @CidName   sysname
 AS
DECLARE @DepUid    smallint         /* Uid to search for              */
DECLARE @ReqUid    smallint         /* Required Object Uid            */
DECLARE @RefUid    smallint         /* Reference Object Uid           */
DECLARE @ReqType   smallint         /* Required Object Type           */
DECLARE @RefType   smallint         /* Reference Object type          */
DECLARE @ReqCName  sysname          /* Required Object Creator Name   */
DECLARE @ReqOName  sysname          /* Required Object Name           */
DECLARE @RefCName  sysname          /* Reference Object Creator Name  */
DECLARE @RefOName  sysname          /* Reference Object Name          */
DECLARE @DepRQ     tinyint          /* Dependency is REQUIRES         */
DECLARE @DepSA     tinyint          /* Dependency selall attribute    */
DECLARE @DepUA     tinyint          /* Dependency resultobj attribute */
DECLARE @DepRA     tinyint          /* Dependency readobj attribute   */
DECLARE @Resolve   tinyint          /* Process input Uid name         */
declare @dbname   sysname
DECLARE @sql      nvarchar(4000)
declare @dlst     CURSOR
set     @dbname = ORIGINAL_DB_NAME()

/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     set nocount on
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  If Internal UID not provided extract it now                       *
 *--------------------------------------------------------------------*/
     set @DepUid = @CidUid
     if (@DepUid = 0) set @DepUid = schema_id(@CidName)

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Dependency List                    *
 *--------------------------------------------------------------------*/
     create table #deplist(ReqUid   smallint,
                           ReqCName sysname,
                           ReqOName sysname,
                           ReqType  smallint,
                           RefUid   smallint,
                           RefCName sysname,
                           RefOName sysname,
                           RefType  smallint,
                           DepType  char(1))

/*--------------------------------------------------------------------*
 *  Declare the search cursor                                         *
 *--------------------------------------------------------------------*/
 SET @sql = N'
 set @dlst = CURSOR FOR
 select p.schema_id,
 schema_name(p.schema_id),
 p.name,
 case
 when p.type = ''V''  then 1
 when p.type = ''U''  then 2
 when p.type = ''P''  then 3
 when p.type = ''PC'' then 3
 when p.type = ''RF'' then 3
 when p.type = ''X''  then 3
 when p.type = ''TA'' then 4
 when p.type = ''TR'' then 4
 when p.type = ''AF'' then 5
 when p.type = ''FN'' then 5
 when p.type = ''FS'' then 5
 when p.type = ''FT'' then 5
 when p.type = ''IF'' then 5
 when p.type = ''TF'' then 5
 when p.type = ''SN'' then 6
 else 99
   end,
   d.schema_id,
   schema_name(d.schema_id),
   d.name,
   case
 when d.type = ''V''  then 1
 when d.type = ''U''  then 2
 when d.type = ''P''  then 3
 when d.type = ''PC'' then 3
 when d.type = ''RF'' then 3
 when d.type = ''X''  then 3
 when d.type = ''TA'' then 4
 when d.type = ''TR'' then 4
 when d.type = ''AF'' then 5
 when d.type = ''FN'' then 5
 when d.type = ''FS'' then 5
 when d.type = ''FT'' then 5
 when d.type = ''IF'' then 5
 when d.type = ''TF'' then 5
 when d.type = ''SN'' then 6
 else 99
   end,
   convert(tinyint,f.is_select_all),
   convert(tinyint,f.is_updated),
   convert(tinyint,f.is_selected),
   convert(tinyint,0)
         from ['+ @dbname+'].sys.all_objects p, ['+ @dbname+'].sys.all_objects d, ['+ @dbname+'].sys.sql_dependencies f
        where f.object_id <> f.referenced_major_id
          and d.object_id = f.object_id
          and p.object_id = f.referenced_major_id
          and (p.schema_id = '+CAST(@DepUid AS NVARCHAR(10))+' or d.schema_id = '+CAST(@DepUid AS NVARCHAR(10))+')
          and p.name != ''sysconstraints''
          and objectproperty(p.object_id,''IsCheckCnst'') = 0
          and objectproperty(p.object_id,''IsSystemTable'') = 0
          and objectproperty(d.object_id,''IsCheckCnst'') = 0
          and objectproperty(d.object_id,''IsSystemTable'') = 0
          and objectproperty(d.object_id,''IsEncrypted'') = 0
       UNION
       select p.schema_id,
   schema_name(p.schema_id),
   p.name,
   case
 when p.type = ''V''  then 1
 when p.type = ''U''  then 2
 when p.type = ''P''  then 3
 when p.type = ''PC'' then 3
 when p.type = ''RF'' then 3
 when p.type = ''X''  then 3
 when p.type = ''TA'' then 4
 when p.type = ''TR'' then 4
 when p.type = ''AF'' then 5
 when p.type = ''FN'' then 5
 when p.type = ''FS'' then 5
 when p.type = ''FT'' then 5
 when p.type = ''IF'' then 5
 when p.type = ''TF'' then 5
 when p.type = ''SN'' then 6
 else 99
   end,
   d.schema_id,
   schema_name(d.schema_id),
   d.name,
   4,
   convert(tinyint,0),
   convert(tinyint,0),
   convert(tinyint,0),
   convert(tinyint,1)
         from ['+ @dbname+'].sys.all_objects p, ['+ @dbname+'].sys.all_objects d
        where d.type in(''TA'',''TR'')
          and (p.schema_id = '+CAST(@DepUid AS NVARCHAR(10))+' or d.schema_id = '+CAST(@DepUid AS NVARCHAR(10))+')
          and p.object_id = d.parent_object_id
          and objectproperty(d.object_id,''IsEncrypted'') = 0
       UNION
       select p.schema_id,
   schema_name(p.schema_id),
   p.name,
   case
 when p.type = ''V''  then 1
 when p.type = ''U''  then 2
 when p.type = ''P''  then 3
 when p.type = ''PC'' then 3
 when p.type = ''RF'' then 3
 when p.type = ''X''  then 3
 when p.type = ''TA'' then 4
 when p.type = ''TR'' then 4
 when p.type = ''AF'' then 5
 when p.type = ''FN'' then 5
 when p.type = ''FS'' then 5
 when p.type = ''FT'' then 5
 when p.type = ''IF'' then 5
 when p.type = ''TF'' then 5
 else 99
   end,
   d.schema_id,
   schema_name(d.schema_id),
   d.name,
   6,
   convert(tinyint,0),
   convert(tinyint,0),
   convert(tinyint,0),
   convert(tinyint,1)
         from ['+ @dbname+'].sys.all_objects p, ['+ @dbname+'].sys.all_objects d, ['+ @dbname+'].sys.synonyms s
        where parsename(s.base_object_name,2) = @ParCidName
          and d.object_id = s.object_id
          and p.name = parsename(s.base_object_name,1)
          and p.schema_id = '+CAST(@DepUid AS NVARCHAR(10))+'
       order by 1,3
    FOR READ ONLY;
    OPEN @dlst'
EXEC sp_executesql @sql,N'@dlst cursor output, @ParCidName sysname', @dlst output, @ParCidName = @CidName

/*--------------------------------------------------------------------*
 *  Scan The System Dependencies for a result set                     *
 *--------------------------------------------------------------------*/
    FETCH @dlst INTO @ReqUid, @ReqCName, @ReqOName, @ReqType,
                    @RefUid, @RefCName, @RefOName, @RefType,
                    @DepSA,  @DepUA,    @DepRA,    @DepRQ
    set @Resolve = 1            /* Need to resolve input Uid       */

/*--------------------------------------------------------------------*
 *  Process the set of dependencies returned by the Query             *
 *--------------------------------------------------------------------*/
    while (@@fetch_status = 0)
     begin

/*--------------------------------------------------------------------*
 *  Mark the 1st record to identify which Uid is the Input Uid        *
 *--------------------------------------------------------------------*/
      if (@Resolve = 1)
       begin
        if (@ReqUid = @DepUid) set @ReqType = @ReqType + 256
        else set @RefType = @RefType + 256
        set @Resolve = 0
       end
/*--------------------------------------------------------------------*
 *  Add the record(s) to the set                                      *
 *--------------------------------------------------------------------*/
      if (@DepRQ = 0 AND @DepSA = 0 AND @DepUA = 0 AND @DepRA = 0)
         insert into #deplist values
           (@ReqUid,
            @ReqCName,
            @ReqOName,
            @ReqType,
            @RefUid,
            @RefCName,
            @RefOName,
            @RefType,
            'N')
      else
       begin
        if (@DepRQ = 1)
           insert into #deplist values
             (@ReqUid,
              @ReqCName,
              @ReqOName,
              @ReqType,
              @RefUid,
              @RefCName,
              @RefOName,
              @RefType,
              'R')
        if (@DepUA = 1)
           insert into #deplist values
             (@ReqUid,
              @ReqCName,
              @ReqOName,
              @ReqType,
              @RefUid,
              @RefCName,
              @RefOName,
              @RefType,
              'M')
        if (@DepSA = 1 or @DepRA = 1)
           insert into #deplist values
             (@ReqUid,
              @ReqCName,
              @ReqOName,
              @ReqType,
              @RefUid,
              @RefCName,
              @RefOName,
              @RefType,
              'S')
       end

/*--------------------------------------------------------------------*
 *  Get the next result set record                                    *
 *--------------------------------------------------------------------*/
      FETCH @dlst INTO @ReqUid, @ReqCName, @ReqOName, @ReqType,
                      @RefUid, @RefCName, @RefOName, @RefType,
                      @DepSA,  @DepUA,    @DepRA,    @DepRQ
     end

/*--------------------------------------------------------------------*
 *  Close the cursor                                                  *
 *--------------------------------------------------------------------*/
    close @dlst
    deallocate @dlst

/*--------------------------------------------------------------------*
 *  Return the Dependency Result Set to our caller                    *
 *--------------------------------------------------------------------*/
    select ReqUid, ReqCName, ReqOName, ReqType,
           RefUid, RefCName, RefOName, RefType,
           DepType
      from #deplist
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDEPENDS to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

