set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCTEXT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCOPTS
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCPARMS
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCTEXT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCOPTS
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCPARMS
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSEMBLY
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYDATA
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROC
       @Owner sysname,
       @Name  sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on

SET @sql = N'
     select o.object_id,
            o.schema_id,
            (select datalength(c.definition)
               from ['+ @dbname+'].sys.sql_modules c
              where c.object_id = o.object_id),
             u.name,
             o.name
       from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
      where OBJECTPROPERTY(o.object_id,''IsProcedure'') = 1
        and o.name = @ParName 
        and u.schema_id = o.schema_id
        and u.name = @ParOwner'
EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', 
						 @ParOwner = @Owner, @ParName = @Name 
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCTEXT
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     varchar(255)    /* current package record         */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @txt_cursor CURSOR

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end
/*--------------------------------------------------------------------*
 *  Temporary Table used to return Procedure Text                     *
 *--------------------------------------------------------------------*/
     create table #prctxt(seqid  smallint primary key,
                          pkgtext varchar(255))
/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of Procedure Text                  *
 *--------------------------------------------------------------------*/
SET @sql = N'
    set @txt_cursor = cursor for
     select datalength(s.definition), s.definition
     from ['+ @dbname+'].sys.sql_modules s
     where s.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
     for read only;
     OPEN @txt_cursor'
EXEC sp_executesql @sql,N'@txt_cursor cursor output', @txt_cursor output

/*       and s.texttype != 6
     order by s.colid */
/*--------------------------------------------------------------------*
 *  Extract 1st Procedure Text record                                 *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     fetch @txt_cursor into @Sl, @Stext
/*--------------------------------------------------------------------*
 *  For each record in the set of Procedure Text                      *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 256 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #prctxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch @txt_cursor into @Sl, @Stext
     end
     close @txt_cursor
     deallocate @txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #prctxt
go


/*--------------------------------------------------------------------*
 *  Return CLR Procedure options                                      *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCOPTS
   @ObjNum  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set @dbname = ORIGINAL_DB_NAME()

     set nocount on
SET @sql = N'
     select (select count(*)
               from ['+ @dbname+'].sys.parameters
              where object_id = '+CAST(@ObjNum AS nvarchar(10))+'),
            a.name, m.assembly_class, m.assembly_method,
            case isnull(m.execute_as_principal_id,0)
                 when  0 then NULL
                 when -2 then NULL
                 else u.name
             end
      from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.assemblies a,
      ['+ @dbname+'].sys.assembly_modules m left join ['+ @dbname+'].sys.schemas u
       on m.execute_as_principal_id = u.schema_id
    where m.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
      and a.assembly_id = m.assembly_id
      and o.object_id = m.object_id'
EXEC sp_executesql @sql
go

/*--------------------------------------------------------------------*
 *  Return CLR Procedure parameters                                   *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCPARMS
       @ObjNum int
 AS
declare  @parmout   int             /* non-zero = output parm         */
declare  @parmnum   int             /* parameter sequence number      */
declare  @length    int             /* length                         */
declare  @scale     int             /* scale                          */
declare  @utype     int             /* user type code                 */
declare  @stype     int             /* system type code               */
declare  @name      sysname         /* Parameter name                 */
declare  @owner     sysname         /* type owner                     */
declare  @typename  sysname         /* type name                      */
declare  @dbname    sysname
DECLARE  @sql       nvarchar(4000)
declare  @parm_cursor CURSOR

set @dbname = ORIGINAL_DB_NAME()


     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for life of this SP              *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Parameter data                     *
 *--------------------------------------------------------------------*/
     create table #parms(parmout    int,
                         parmnum    int,
                         length     int,
                         scale      int,
                         utype      int,
                         stype      int,
                         parmname   sysname,
                         owner      sysname,
                         typename   sysname)
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of parameters                         *
 *--------------------------------------------------------------------*/
 SET @sql = N'
    set @parm_cursor = cursor for
    select p.is_output, p.parameter_id, p.max_length, p.scale,
           t.xusertype, t.xtype, p.name, u.name, t.name
      from ['+ @dbname+'].sys.parameters p, ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
     where p.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
       and p.user_type_id = t.xusertype
       and t.uid = u.schema_id
     for read only;
     OPEN @parm_cursor'
EXEC sp_executesql @sql,N'@parm_cursor cursor output', @parm_cursor output

/*--------------------------------------------------------------------*
 *  Process Parameter data                                               *
 *--------------------------------------------------------------------*/
    fetch @parm_cursor into @parmout,
                           @parmnum,
                           @length,
                           @scale,
                           @utype,
                           @stype,
                           @name,
                           @owner,
                           @typename
    while (@@fetch_status = 0)
    begin
      insert into #parms values
                          (@parmout,
                           @parmnum,
                           @length,
                           @scale,
                           @utype,
                           @stype,
                           @name,
                           @owner,
                           @typename
                           )
      fetch @parm_cursor into @parmout,
                             @parmnum,
                             @length,
                             @scale,
                             @utype,
                             @stype,
                             @name,
                             @owner,
                             @typename
    end
    close @parm_cursor
    deallocate @parm_cursor
/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
    select parmout,
           parmnum,
           case when length < 0 then 0 else length end,
           scale,
           utype,
           stype,
           parmname,
           owner,
           typename
      from #parms
     order by parmnum asc
go

/*--------------------------------------------------------------------*
 *  Return Function Info                                              *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNC
       @Owner sysname,
       @Name  sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
SET @sql = N'
     select o.object_id,
            o.schema_id,
            isnull((select datalength(c.definition)
                      from ['+ @dbname+'].sys.sql_modules c
                     where c.object_id = o.object_id),0),
             u.name,
             o.name
       from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
      where o.type in(''AF'', ''FN'', ''FS'', ''FT'', ''IF'', ''TF'')
        and o.name = @ParName 
        and u.schema_id = o.schema_id
        and u.name = @ParOwner'
EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', @ParOwner = @Owner, @ParName = @Name

go


/*--------------------------------------------------------------------*
 *  Return text of a Function                                         *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCTEXT
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(4000)  /* current text record            */
declare  @Ctext     varchar(255)    /* current package record         */
declare  @dbname    sysname
DECLARE  @sql       nvarchar(4000)
declare  @txt_cursor CURSOR

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end
/*--------------------------------------------------------------------*
 *  Temporary Table used to return Function Text                      *
 *--------------------------------------------------------------------*/
     create table #funtxt(seqid  smallint primary key,
                          pkgtext varchar(255))
/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of Function text                   *
 *--------------------------------------------------------------------*/
SET @sql = N'
    set @txt_cursor = cursor for
     select datalength(s.definition), s.definition
     from ['+ @dbname+'].sys.sql_modules s
     where s.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
     for read only;
     OPEN @txt_cursor'
EXEC sp_executesql @sql,N'@txt_cursor cursor output', @txt_cursor output

/*       and s.texttype != 6
     order by s.colid  check this #ramuk */
/*--------------------------------------------------------------------*
 *  Extract 1st Function Text record                                  *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     fetch @txt_cursor into @Sl, @Stext
/*--------------------------------------------------------------------*
 *  For each record in the set of Function Text                       *
 *--------------------------------------------------------------------*/
     while (@@fetch_status = 0)
     begin
       set @index = 1
       set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
       while(@Sl > 0)
       begin
         if (@Sl < 255) set @Ml = @Sl
         set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
         set @seqid = @seqid + 1
         insert into #funtxt values (@seqid,@Ctext)
         set @Sl = @Sl - @Ml
         set @index = @index + @Ml
       end
       fetch @txt_cursor into @Sl, @Stext
     end
     close @txt_cursor
     deallocate @txt_cursor
/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #funtxt
go


/*--------------------------------------------------------------------*
 *  Return CLR Function options                                       *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCOPTS
   @ObjNum  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
SET @sql = N'
     select (select count(*)
               from ['+ @dbname+'].sys.parameters
              where object_id = '+CAST(@ObjNum AS nvarchar(10))+'),
            (select count(*)
               from ['+ @dbname+'].sys.columns
              where object_id = '+CAST(@ObjNum AS nvarchar(10))+'),
            a.name, m.assembly_class, m.assembly_method,
            case isnull(m.execute_as_principal_id,0)
                 when  0 then NULL
                 when -2 then NULL
                 else u.name
             end,
            m.null_on_null_input,
            case isnull(o.type,0) when ''AF'' then 1 else 0 end,
            isnull(f.order_column_id,0),
            isnull(f.is_descending,0),
            isnull(c.name,'' '')
     from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.assemblies a,
     ['+ @dbname+'].sys.assembly_modules m left join ['+ @dbname+'].sys.schemas u
       on m.execute_as_principal_id = u.schema_id
       left join ['+ @dbname+'].sys.function_order_columns f
       on m.object_id = f.object_id
       left join ['+ @dbname+'].sys.all_columns c
       on m.object_id = c.object_id
       and f.order_column_id = c.column_id
    where m.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
      and a.assembly_id = m.assembly_id
      and o.object_id = m.object_id'
EXEC sp_executesql @sql
go

/*--------------------------------------------------------------------*
 *  Return CLR Function parameters                                    *
 *--------------------------------------------------------------------*/
CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCPARMS
       @ObjNum int
 AS
declare  @parmout   int             /* non-zero = output parm         */
declare  @parmnum   int             /* parameter sequence number      */
declare  @length    int             /* length                         */
declare  @scale     int             /* scale                          */
declare  @utype     int             /* user type code                 */
declare  @stype     int             /* system type code               */
declare  @name      sysname         /* Parameter name                 */
declare  @owner     sysname         /* type owner                     */
declare  @typename  sysname         /* type name                      */
declare  @collname  sysname         /* collation name                 */
declare  @ordcolid  int             /* order Column id                */
declare  @isdesc    bit            /*  is descending                  */
declare  @colname  sysname         /* order column name               */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @parm_cursor  CURSOR

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for life of this SP              *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Parameter data                     *
 *--------------------------------------------------------------------*/
     create table #parms(parmout    int,
                         parmnum    int,
                         length     int,
                         scale      int,
                         utype      int,
                         stype      int,
                         parmname   sysname,
                         owner      sysname,
                         typename   sysname,
                         collname   sysname NULL,
                         ordcolid   int NULL,
                         isdesc     bit NULL,
                         colname    sysname NULL)
/*--------------------------------------------------------------------*
 *  Declare the cursor for scan of parameters                         *
 *--------------------------------------------------------------------*/
SET @sql = N'
    set @parm_cursor = cursor for
    select p.is_output, p.parameter_id, p.max_length, p.scale,
           t.xusertype, t.xtype, p.name, u.name, t.name, NULL,
           isnull(f.order_column_id,0),
           isnull(f.is_descending,0),
           isnull(c.name,'' '')
       from ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.parameters p
       left join ['+ @dbname+'].sys.function_order_columns f
       on p.object_id = f.object_id
       left join ['+ @dbname+'].sys.all_columns c
       on c.object_id = p.object_id
       and f.order_column_id = c.column_id
       where p.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
       and p.user_type_id = t.xusertype
       and t.uid = u.schema_id
    UNION
    select 1, c.column_id, c.max_length, c.scale, t.xusertype,
           t.xtype, c.name, u.name, t.name, c.collation_name,
           NULL, NULL, NULL
      from ['+ @dbname+'].sys.columns c, ['+ @dbname+'].sys.systypes t, ['+ @dbname+'].sys.schemas u
     where c.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
       and c.user_type_id = t.xusertype
       and t.uid = u.schema_id
     for read only;
     OPEN @parm_cursor'
EXEC sp_executesql @sql,N'@parm_cursor cursor output', @parm_cursor output
/*--------------------------------------------------------------------*
 *  Process Parameter data                                               *
 *--------------------------------------------------------------------*/
    fetch @parm_cursor into @parmout,
                           @parmnum,
                           @length,
                           @scale,
                           @utype,
                           @stype,
                           @name,
                           @owner,
                           @typename,
                           @collname,
                           @ordcolid,
                           @isdesc,
                           @colname
    while (@@fetch_status = 0)
    begin
      insert into #parms values
                          (@parmout,
                           @parmnum,
                           @length,
                           @scale,
                           @utype,
                           @stype,
                           @name,
                           @owner,
                           @typename,
                           @collname,
                           @ordcolid,
                           @isdesc,
                           @colname
                           )
      fetch @parm_cursor into @parmout,
                             @parmnum,
                             @length,
                             @scale,
                             @utype,
                             @stype,
                             @name,
                             @owner,
                             @typename,
                             @collname,
                             @ordcolid,
                             @isdesc,
                             @colname
    end
    close @parm_cursor
    deallocate @parm_cursor
/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
    select parmout,
           parmnum,
           case when length < 0 then 0 else length end,
           scale,
           utype,
           stype,
           parmname,
           owner,
           typename,
           collname,
           ordcolid,
           isdesc,
           colname
      from #parms
     order by parmout desc, parmnum asc
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCLIST
       @ObjType1 smallint,
       @ObjType2 smallint,
       @Owner sysname,
       @Name  sysname
 AS
declare  @mode      smallint        /* Query Mode in effect           */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  bas-ed on whether the input patterns have LIKE wildcards.          *
 *  Mode values are:                                                  *
 *       0 - Explicit Owner name and Explicit Procedure name          *
 *       1 - Generic Owner name and Explicit Procedure name           *
 *       2 - Explicit Owner name and Generic Procedure name           *
 *       3 - Generic Owner name and Generic Procedure name            *
 *--------------------------------------------------------------------*/
     select @mode = 0               /* Assume Explicit Own/Prc names  */

/*--------------------------------------------------------------------*
 *  Check Owner Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@Owner) > 0) or (charindex('_',@Owner) > 0))
       select @mode = 1

/*--------------------------------------------------------------------*
 *  Check Procedure Name for LIKE wildcard characters                 *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@Name) > 0) or (charindex('_',@Name) > 0))
       select @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
      SET @sql = N'
      select
            case
              when o.type = ''P'' then 1
              when o.type = ''PC'' then 1
              when o.type = ''RF'' then 1
              when o.type = ''X'' then 1
              when o.type = ''AF'' then 2
              when o.type = ''FN'' then 2
              when o.type = ''FS'' then 2
              when o.type = ''FT'' then 2
              when o.type = ''IF'' then 2
              when o.type = ''TF'' then 2
            end,
             o.name, u.name
        from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
       where('+CAST(@ObjType1  AS nvarchar(10))+'= 1 and o.type in(''P'',''PC'',''RF'',''X'') or
             '+CAST(@ObjType2  AS nvarchar(10))+'= 1 and o.type in (''AF'',''FN'',''FS'',''FT'',''IF'',''TF''))
         and o.name = @ParName 
         and u.name = @ParOwner 
         and o.schema_id = u.schema_id
       order by u.name, o.name'
      EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', @ParOwner = @Owner, @ParName = @Name
      end

    if @mode = 1
      begin
      SET @sql = N'
      select
            case
              when o.type = ''P'' then 1
              when o.type = ''PC'' then 1
              when o.type = ''RF'' then 1
              when o.type = ''X'' then 1
              when o.type = ''AF'' then 2
              when o.type = ''FN'' then 2
              when o.type = ''FS'' then 2
              when o.type = ''FT'' then 2
              when o.type = ''IF'' then 2
              when o.type = ''TF'' then 2
            end,
             o.name, u.name
        from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
       where('+CAST(@ObjType1  AS nvarchar(10))+' = 1 and o.type in(''P'',''PC'',''RF'',''X'') or
             '+CAST(@ObjType2  AS nvarchar(10))+' = 1 and o.type in (''AF'',''FN'',''FS'',''FT'',''IF'',''TF''))
         and o.name like @ParName 
         and u.name = @ParOwner 
         and o.schema_id = u.schema_id
       order by u.name, o.name'
      EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', @ParOwner = @Owner, @ParName = @Name
      end

    if @mode = 2
      begin
      SET @sql = N'
      select
            case
              when o.type = ''P'' then 1
              when o.type = ''PC'' then 1
              when o.type = ''RF'' then 1
              when o.type = ''X'' then 1
              when o.type = ''AF'' then 2
              when o.type = ''FN'' then 2
              when o.type = ''FS'' then 2
              when o.type = ''FT'' then 2
              when o.type = ''IF'' then 2
              when o.type = ''TF'' then 2
            end,
             o.name, u.name
        from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
       where('+CAST(@ObjType1  AS nvarchar(10))+' = 1 and o.type in(''P'',''PC'',''RF'',''X'') or
             '+CAST(@ObjType2  AS nvarchar(10))+' = 1 and o.type in (''AF'',''FN'',''FS'',''FT'',''IF'',''TF''))
         and o.name like @ParName 
         and u.name = @ParOwner 
         and o.schema_id = u.schema_id
       order by u.name, o.name'
      EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', @ParOwner = @Owner, @ParName = @Name
      end

    if @mode = 3
      begin
      SET @sql = N'
      select
            case
              when o.type = ''P'' then 1
              when o.type = ''PC'' then 1
              when o.type = ''RF'' then 1
              when o.type = ''X'' then 1
              when o.type = ''AF'' then 2
              when o.type = ''FN'' then 2
              when o.type = ''FS'' then 2
              when o.type = ''FT'' then 2
              when o.type = ''IF'' then 2
              when o.type = ''TF'' then 2
            end,
             o.name, u.name
        from ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.schemas u
       where('+CAST(@ObjType1  AS nvarchar(10))+' = 1 and o.type in(''P'',''PC'',''RF'',''X'') or
             '+CAST(@ObjType2  AS nvarchar(10))+' = 1 and o.type in (''AF'',''FN'',''FS'',''FT'',''IF'',''TF''))
         and o.name like @ParName 
         and u.name like @ParOwner 
         and o.schema_id = u.schema_id
       order by u.name, o.name'
      EXEC sp_executesql @sql, N'@ParOwner sysname, @ParName sysname', @ParOwner = @Owner, @ParName = @Name
      end
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSEMBLY
       @Name  sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()
     set nocount on
SET @sql = N'
     select datalength(f.content),
            a.assembly_id,
            schema_name(a.principal_id),
            f.name,
            a.permission_set
       from ['+ @dbname+'].sys.assemblies a
             inner join ['+ @dbname+'].sys.assembly_files f
         on a.assembly_id = f.assembly_id
      where a.name = @ParName'
EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYDATA
       @AsyId    int
 AS
declare  @seqid     int             /* sequence identifier            */
declare  @totlen    bigint          /* total content length           */
declare  @start     bigint          /* index in data buffer           */
declare  @len       smallint        /* current output length          */
declare  @data      varbinary(255)  /* current substring              */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Get the full length                                               *
 *--------------------------------------------------------------------*/
     select @totlen = len(content)
       from sys.assembly_files
      where assembly_id = @AsyId

/*--------------------------------------------------------------------*
 *  Create a temp table of segments                                   *
 *--------------------------------------------------------------------*/
     create table #asydata(seqid   int primary key,
                           dataseg varbinary(255))


     set @seqid = 0
     set @start = 1
     set @len   = 255

     while(@totlen > 0)
       begin
         if (@totlen < 255) set @len = @totlen
   SET @sql = N'
         select @data = substring(content,'+CAST(@start AS nvarchar(10))+','+CAST(@len AS nvarchar(10))+')
           from ['+ @dbname+'].sys.assembly_files
          where assembly_id = '+CAST(@AsyId AS nvarchar(10))

     EXEC sp_executesql @query = @sql,
                        @params = N'@data varbinary(255) OUTPUT',
                        @data=@data OUTPUT

         set @seqid = @seqid + 1
         insert
           into #asydata
         values (@seqid,@data)
         set @totlen = @totlen - @len
         set @start  = @start + @len
       end

/*--------------------------------------------------------------------*
 *  Return the segments                                               *
 *--------------------------------------------------------------------*/
     select dataseg
       from #asydata
      order by seqid
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYLIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
    SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.assemblies
       WHERE name = @ParName 
       order by name'
    EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end


    if @SelMode = 2
      begin
    SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.assemblies
       WHERE name like @ParName 
       order by name'
    EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end
go


grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCTEXT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCTEXT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCOPTS to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETFUNCPARMS to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPROCLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSEMBLY to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYDATA to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETASSYLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

