set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLINK
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCONDETAIL
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLIST
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLINK
       @CidUid    smallint,
       @CidName   sysname
 AS
DECLARE @CidNum   smallint
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set      @dbname = ORIGINAL_DB_NAME()

     set nocount on
     set @CidNum = @CidUid

     if (@CidUid = -1)
       set @CidNum = schema_id(@CidName)

SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name,
            rd.schema_id,
            rp.schema_id,
            r.object_id,
            case
              when (f.is_not_for_replication <> 0)
                then ''Y''
                else ''N''
              end,
            case
              when (f.is_disabled <> 0)
                then ''N''
                else ''Y''
              end,
            f.delete_referential_action,
            f.update_referential_action
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r,
            ['+ @dbname+'].sys.foreign_keys f
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        and f.object_id = o.object_id
        and f.schema_id = o.schema_id
        AND (rd.schema_id = '+CAST(@CidNum AS nvarchar(10))+' or rp.schema_id = '+CAST(@CidNum AS nvarchar(10))+')'
    EXEC sp_executesql @sql
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCONDETAIL
       @ConId     int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set @dbname = ORIGINAL_DB_NAME()

 set nocount on
SET @sql = N'
 SELECT r.keycnt,
        r.fkey1,r.fkey2,r.fkey3,r.fkey4,
        r.fkey5,r.fkey6,r.fkey7,r.fkey8,
        r.fkey9,r.fkey10,r.fkey11,r.fkey12,
        r.fkey13,r.fkey14,r.fkey15,r.fkey16,
        r.rkey1,r.rkey2,r.rkey3,r.rkey4,
        r.rkey5,r.rkey6,r.rkey7,r.rkey8,
        r.rkey9,r.rkey10,r.rkey11,r.rkey12,
        r.rkey13,r.rkey14,r.rkey15,r.rkey16
   FROM ['+ @dbname+'].sys.sysreferences r
   WHERE r.constid = '+CAST(@ConId AS nvarchar(10))
   EXEC sp_executesql @sql
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLIST
       @CidPattern sysname,
       @TblPattern sysname,
       @RelPattern sysname
 AS
declare  @mode      smallint        /* Query Mode in effect           */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set      @dbname = ORIGINAL_DB_NAME()

 set nocount on
/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan bas-ed on            *
 *  whether the input patterns have LIKE wildcards.                   *
 *  Mode values are:                                                  *
 *       0 - All input patterns are explicit                          *
 *       1 - Generic Creator name                                     *
 *       2 - Generic Table name                                       *
 *       3 - Generic Creator and Table names                          *
 *       4 - Generic Relationship name                                *
 *       5 - Generic Creator and Relationship names                   *
 *       6 - Generic Table and Relationship names                     *
 *       7 - All input patterns are generic                           *
 *--------------------------------------------------------------------*/
     set @mode = 0               /* Assume Explicit names          */

/*--------------------------------------------------------------------*
 *  Check Creator Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@CidPattern) > 0) or
         (charindex('_',@CidPattern) > 0))
       set @mode = 1

/*--------------------------------------------------------------------*
 *  Check Table Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@TblPattern) > 0) or
         (charindex('_',@TblPattern) > 0))
       set @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Check RelName Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@RelPattern) > 0) or
         (charindex('_',@RelPattern) > 0))
       set @mode = @mode + 4

/*--------------------------------------------------------------------*
 *  Execute the proper select statement bas-ed on Query Mode           *
 *--------------------------------------------------------------------*/
    if @mode = 0
     SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name = @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) = @ParCidPattern 
        AND rd.name = @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
      EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 1
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name = @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) like @ParCidPattern 
        AND rd.name = @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
      EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 2
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name = @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) = @ParCidPattern 
        AND rd.name like @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
      EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 3
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name like @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) = @ParCidPattern 
        AND rd.name like @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
    EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 4
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name like @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) = @ParCidPattern 
        AND rd.name = @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
     EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 5
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name like @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) like @ParCidPattern 
        AND rd.name = @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
     EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 6
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name like @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) = @ParCidPattern 
        AND rd.name like @ParTblPattern ESCAPE ''!''
      ORDER BY o.schema_id, rd.name,o.name'
     EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

    if @mode = 7
    SET @sql = N'
     SELECT schema_name(rd.schema_id),
            rd.name,
            o.name,
            schema_name(rp.schema_id),
            rp.name
       FROM ['+ @dbname+'].sys.all_objects o,
            ['+ @dbname+'].sys.all_objects rd,
            ['+ @dbname+'].sys.all_objects rp,
            ['+ @dbname+'].sys.foreign_keys r
      WHERE OBJECTPROPERTY(o.object_id,''IsForeignKey'') = 1
        AND o.name like @ParRelPattern 
        AND r.object_id = o.object_id
        and rd.object_id = r.parent_object_id
        and rp.object_id = r.referenced_object_id
        AND schema_name(rd.schema_id) like @ParCidPattern 
        AND rd.name like @ParTblPattern 
      ORDER BY o.schema_id, rd.name,o.name'
      EXEC sp_executesql @sql, N'@ParRelPattern sysname, @ParCidPattern sysname, @ParTblPattern sysname',
							@ParRelPattern = @RelPattern, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLINK to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETCONDETAIL to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETRELLIST to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

