set quoted_identifier off
go

set implicit_transactions off
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSCIDOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPOBJECT
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPTBLENC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETVIEW
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETTBLLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEME
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEMELIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNC
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNCLIST
go

DROP PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDATACOMP
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
 declare  @dbname   sysname
 DECLARE  @sql      nvarchar(4000)
 set nocount on

 set @dbname = ORIGINAL_DB_NAME()
 SET @sql = N'
 SELECT o.schema_id,
        o.object_id,
        (select max(column_id) from ['+ @dbname+'].sys.all_columns c where c.object_id = o.object_id),
        (select count(*) from ['+ @dbname+'].sys.all_columns c where c.object_id = o.object_id),
        0,
        0,
        o.type,
        (CASE
            WHEN OBJECTPROPERTY(o.object_id, ''TableHasCheckCnst'') = 1
            THEN 128
            ELSE 0
         END),
        schema_name(o.schema_id),
        o.name,
        ps.name,
        isnull(ic.column_id,0),
        (select count(data_compression) from ['+ @dbname+'].sys.partitions p1
        where p1.object_id = o.object_id
        and data_compression > 0)
   FROM ['+ @dbname+'].sys.all_objects o
         left outer join ['+ @dbname+'].sys.indexes i
     ON o.object_id = i.object_id
         and (i.type = 0 or i.is_primary_key = 1)
         left outer join ['+ @dbname+'].sys.partition_schemes ps
     on ps.data_space_id = i.data_space_id
         left outer join ['+ @dbname+'].sys.index_columns ic
     on i.object_id = ic.object_id
         and i.index_id = ic.index_id
         and ic.partition_ordinal > 0
  WHERE o.schema_id = schema_id(@ParCidName)
    AND o.name = @ParObjName 
    AND (OBJECTPROPERTY(o.object_id,''IsTable'') = 1 or OBJECTPROPERTY(o.object_id,''IsView'') = 1)'
    EXEC sp_executesql @sql, N'@ParCidName sysname, @ParObjName sysname', @ParCidName = @CidName, @ParObjName = @ObjName
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSCIDOBJECT
       @CidUid    smallint,
       @CidName   sysname,
       @ObjName   sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
 set @dbname = ORIGINAL_DB_NAME()
 set nocount on
SET @sql = N'
 SELECT o.schema_id,
        o.object_id,
        (select max(column_id) from ['+ @dbname+'].sys.all_columns c where c.object_id = o.object_id),
        (select count(*) from ['+ @dbname+'].sys.all_columns c where c.object_id = o.object_id),
        0,
        0,
        o.type,
        (CASE
            WHEN OBJECTPROPERTY(o.object_id, ''TableHasCheckCnst'') = 1
            THEN 128
            ELSE 0
         END),
        schema_name(o.schema_id),
        o.name,
        ps.name,
        isnull(ic.column_id,0),
        (select count(data_compression) from ['+ @dbname+'].sys.partitions p1
        where p1.object_id = o.object_id
        and data_compression > 0)
   FROM ['+ @dbname+'].sys.all_objects o
         left outer join ['+ @dbname+'].sys.indexes i
     ON o.object_id = i.object_id
         and (i.type = 0 or i.is_primary_key = 1)
         left outer join ['+ @dbname+'].sys.partition_schemes ps
     on ps.data_space_id = i.data_space_id
         left outer join ['+ @dbname+'].sys.index_columns ic
     on i.object_id = ic.object_id
         and i.index_id = ic.index_id
         and ic.partition_ordinal > 0
  WHERE o.schema_id = '+CAST(@CidUid AS nvarchar(10))+'
    AND o.name = @ParObjName 
     AND (OBJECTPROPERTY(o.object_id,''IsTable'') = 1 or OBJECTPROPERTY(o.object_id,''IsView'') = 1)'

   EXEC sp_executesql @sql, N'@ParObjName sysname', @ParObjName = @ObjName
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPOBJECT
   @ObjNum  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @cnt      int

set @dbname = ORIGINAL_DB_NAME()
   set nocount on
/*--------------------------------------------------------------------*
 *  Table has no Text or Image columns                                *
 *--------------------------------------------------------------------*/
SET @sql = N'
 select @cnt=count(object_id) from ['+ @dbname+'].sys.all_columns where
 object_id ='+CAST(@ObjNum AS nvarchar(10))+ ' and (system_type_id = 34 or system_type_id = 35)'

 EXEC sp_executesql
      @query = @sql,
      @params = N'@cnt INT OUTPUT',
      @cnt=@cnt OUTPUT

   if ( @cnt = 0)
     begin
     SET @sql = N'
        SELECT isnull((SELECT MAX(i.rows)
                      FROM ['+ @dbname+'].sys.partitions i
                     WHERE i.object_id = '+CAST(@ObjNum AS nvarchar(10))+'),0),
               isnull(objectproperty(o.object_id,''TableDeleteTriggerCount''),0),
               isnull(objectproperty(o.object_id,''TableInsertTriggerCount''),0),
               isnull(objectproperty(o.object_id,''TableUpdateTriggerCount''),0),
               isnull(i.fill_factor,0),
               i.data_space_id,
               isnull((select name from ['+ @dbname+'].sys.filegroups
               where data_space_id = i.data_space_id),'' ''),
               case
                 when (isnull(FILEGROUPPROPERTY((select name from ['+ @dbname+'].sys.filegroups
               where data_space_id = i.data_space_id),''IsDefault''),0) <> 0)
                   then ''Y''
                   else ''N''
                 end,
               0,
               '' '',
               ''X''
         FROM ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.indexes i
         WHERE o.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
           AND i.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
           AND (i.index_id = 0 or i.index_id = 1)'

         EXEC sp_executesql @sql
     end
/*--------------------------------------------------------------------*
 *  Table has Text or Image columns get additional FileGroup          *
 *--------------------------------------------------------------------*/
   else
     begin
     SET @sql = N'
         SELECT isnull((SELECT MAX(i.rows)
                       FROM ['+ @dbname+'].sys.partitions i
                      WHERE i.object_id = '+CAST(@ObjNum AS nvarchar(10))+'),0),
                isnull(objectproperty(o.object_id,''TableDeleteTriggerCount''),0),
                isnull(objectproperty(o.object_id,''TableInsertTriggerCount''),0),
                isnull(objectproperty(o.object_id,''TableUpdateTriggerCount''),0),
                isnull(i.fill_factor,0),
                i.data_space_id,
                isnull((select name from ['+ @dbname+'].sys.filegroups
                where data_space_id = i.data_space_id),'' ''),
                case
                  when (isnull(FILEGROUPPROPERTY((select name from ['+ @dbname+'].sys.filegroups
                where data_space_id = i.data_space_id),''IsDefault''),0) <> 0)
                    then ''Y''
                    else ''N''
                  end,
                u.data_space_id,
                isnull((select name from ['+ @dbname+'].sys.filegroups
                where data_space_id = u.data_space_id),'' ''),
                case
                  when (isnull(FILEGROUPPROPERTY((select name from ['+ @dbname+'].sys.filegroups
                where data_space_id = u.data_space_id),''IsDefault''),0) <> 0)
                    then ''Y''
                    else ''N''
                  end
          FROM ['+ @dbname+'].sys.all_objects o, ['+ @dbname+'].sys.indexes i,
          ['+ @dbname+'].sys.partitions p, ['+ @dbname+'].sys.allocation_units u
          WHERE o.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
            AND i.object_id = '+CAST(@ObjNum AS nvarchar(10))+'
            AND p.object_id = i.object_id
            AND p.index_id = i.index_id
            AND u.container_id = p.partition_id
            AND u.type = 2
            AND (i.index_id = 0 or i.index_id = 1)'

            EXEC sp_executesql @sql
     end
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPVIEW
   @ObjNum  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set @dbname = ORIGINAL_DB_NAME()

   set nocount on
SET @sql = N'
   select datalength(c.definition)
     from ['+ @dbname+'].sys.all_sql_modules c
    where c.object_id = '+CAST(@ObjNum AS nvarchar(10))
EXEC sp_executesql @sql
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPTBLENC
   @ObjNum  int
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @cntenc   int
declare  @pkdid    int
declare  @hasprd   int

set @dbname = ORIGINAL_DB_NAME()
   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for life of this SP              *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Table Encryption Attributes        *
 *--------------------------------------------------------------------*/
     create table #tblenc(cntenc     int,
                          mustcip    int)


   set @pkdid = 0
   set @hasprd = 0
/*--------------------------------------------------------------------*
 *  Get Table encrypted columns                                       *
 *--------------------------------------------------------------------*/
SET @sql = N'
 select @cntenc=count(*) from ['+ @dbname+'].sys.columns where
 object_id ='+CAST(@ObjNum AS nvarchar(10))+ ' and encryption_type IS NOT NULL'

 EXEC sp_executesql
      @query = @sql,
      @params = N'@cntenc INT OUTPUT',
      @cntenc=@cntenc OUTPUT

 if (@cntenc > 0)
    begin
    SET @sql = N'
     select @pkdid=index_id from ['+ @dbname+'].sys.indexes where
     object_id ='+CAST(@ObjNum AS nvarchar(10))+ ' and is_primary_key = 1'

    EXEC sp_executesql
         @query = @sql,
         @params = N'@pkdid INT OUTPUT',
         @pkdid =@pkdid OUTPUT

    if (@pkdid > 0)
       begin
        SET @sql = N'
         select @hasprd=count(*) from ['+ @dbname+ '].sys.index_columns AS ic
                INNER JOIN ['+ @dbname+ '].sys.columns AS c
                ON ic.object_id = c.object_id
               and ic.column_id = c.column_id
               and c.encryption_type IS NOT NULL
        where ic.object_id = '+CAST(@ObjNum as nvarchar(10))+ '
         and ic.index_id = '+CAST(@pkdid AS nvarchar(10))

        EXEC sp_executesql
             @query = @sql,
             @params = N'@hasprd INT OUTPUT',
             @hasprd =@hasprd OUTPUT
       end
    end

/*--------------------------------------------------------------------*
 *  Set the results                                                   *
 *--------------------------------------------------------------------*/
  insert into #tblenc values (@cntenc, @hasprd)
/*--------------------------------------------------------------------*
 *  Select the returned data, if any, for the Encryption Attributes   *
 *--------------------------------------------------------------------*/
  select cntenc, mustcip
    from #tblenc
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETVIEW
   @ObjNum  int
 AS
declare  @seqid     smallint        /* sequence identifier            */
declare  @index     int             /* index of NL in text            */
declare  @Ml        int             /* current output length          */
declare  @Sl        int             /* current text length            */
declare  @Stext     nvarchar(max)   /* current text record            */
declare  @Ctext     char(255)       /* current package record         */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @txt_cursor  CURSOR

set @dbname = ORIGINAL_DB_NAME()


     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return View Text                          *
 *--------------------------------------------------------------------*/
     create table #vuetxt(seqid  smallint primary key,
                          pkgtext char(255))

/*--------------------------------------------------------------------*
 *  Declare the cursor for extract of View text                       *
 *--------------------------------------------------------------------*/
  set @sql = N'
    set @txt_cursor = cursor for
     select datalength(s.definition), s.definition
     from ['+ @dbname+'].sys.all_sql_modules s
     where s.object_id = '+CAST(@ObjNum AS nvarchar(10))+ '
     for read only;
     open @txt_cursor'

   EXEC sp_executesql @sql,N'@txt_cursor cursor output', @txt_cursor output

/*--------------------------------------------------------------------*
 *  Extract View Text record                                          *
 *--------------------------------------------------------------------*/
     set @seqid = 0
     fetch @txt_cursor into @Sl, @Stext
     set @index = 1
     set @Ml = 255
/*--------------------------------------------------------------------*
 *  Build output text packages of 255 or less bytes each.             *
 *--------------------------------------------------------------------*/
     while(@Sl > 0)
     begin
       if (@Sl < 255) set @Ml = @Sl
       set @Ctext = substring(@Stext,@index,@Ml)
/*--------------------------------------------------------------------*
 *  Write the output record                                           *
 *--------------------------------------------------------------------*/
       set @seqid = @seqid + 1
       insert into #vuetxt values (@seqid,@Ctext)
       set @Sl = @Sl - @Ml
       set @index = @index + @Ml
     end
     close @txt_cursor
     deallocate @txt_cursor

/*--------------------------------------------------------------------*
 *  Select the returned data                                          *
 *--------------------------------------------------------------------*/
      select seqid,pkgtext from #vuetxt
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETTBLLIST
       @ObjType1   smallint,
       @ObjType2   smallint,
       @ObjType3   smallint,
       @CidPattern sysname,
       @TblPattern sysname
 AS
declare  @objnum    int             /* Current Object Number          */
declare  @numkey    smallint        /* Number of keys in index        */
declare  @cid_name  sysname         /* Creator Name                   */
declare  @tbl_name  sysname         /* Table Name                     */
declare  @tbl_type  char(1)         /* Object Type  T, V, S           */
declare  @user      smallint        /* Table owner Id                 */
declare  @mode      smallint        /* Query Mode in effect           */
declare  @rows      bigint          /* Number table rows              */
declare  @objst     char(2)         /* system table                   */
declare  @objut     char(2)         /* user table                     */
declare  @objv      char(2)         /* view                           */
declare  @objsyn    char(2)         /* synonym                        */
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
declare  @tlst0    CURSOR
declare  @tlst1    CURSOR
declare  @tlst2    CURSOR
declare  @tlst3    CURSOR

set @dbname = ORIGINAL_DB_NAME()

   set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Temporary Table used to return Primary Key List                   *
 *--------------------------------------------------------------------*/
     create table #tbllist(CidName sysname,
                           TblName sysname,
                           TblType char(1),
                           RowCnt  bigint)

/*--------------------------------------------------------------------*
 *  Set up what we're looking for:                                    *
 *--------------------------------------------------------------------*/
     if @ObjType1 = 1
       begin
       set @objst = 'S '
       set @objut = 'U '
       end
     if @ObjType2 = 1
       set @objv = 'V '
     if @ObjType3 = 1
       set @objsyn = 'SN'


/*--------------------------------------------------------------------*
 *  Compute the Query select to use for this scan                     *
 *  based on whether the input patterns have LIKE wildcards.          *
 *  Mode values are:                                                  *
 *       0 - Explicit Creator name and Explicit Table name            *
 *       1 - Generic Creator name and Explicit Table name             *
 *       2 - Explicit Creator name and Generic Table name             *
 *       3 - Generic Creator name and Generic Table name              *
 *--------------------------------------------------------------------*/
     set @mode = 0               /* Assume Explicit CID/TBL names  */

/*--------------------------------------------------------------------*
 *  Check Creator Name for LIKE wildcard characters                   *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@CidPattern) > 0) or
         (charindex('_',@CidPattern) > 0))
       set @mode = 1

/*--------------------------------------------------------------------*
 *  Check Table Name for LIKE wildcard characters                     *
 *--------------------------------------------------------------------*/
     if ((charindex('%',@TblPattern) > 0) or
         (charindex('_',@TblPattern) > 0))
       set @mode = @mode + 2

/*--------------------------------------------------------------------*
 *  Open the appropriate cursor and fetch 1st record                  *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
set @sql = N'
SET @tlst0 = CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = ''V '' then ''V''
              when o.type = ''U '' then ''T''
              when o.type = ''S '' then ''T''
              when o.type = ''SN''
               and bo.type = ''U ''
                or bo.type = ''S ''
                or bo.type = ''V '' then ''S''
              else ''X''
            end,
            isnull((SELECT MAX(i.rows)
                      FROM ['+ @dbname+'].sys.partitions i
                     WHERE i.object_id = o.object_id),0)
       FROM ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.indexes i RIGHT JOIN ['+ @dbname+'].sys.all_objects o
         ON i.object_id = o.object_id LEFT JOIN ['+ @dbname+'].sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN ['+ @dbname+'].sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name
      WHERE u.name = @ParCidPattern 
        AND o.schema_id = u.schema_id
        AND o.name = @ParTblPattern 
        AND o.type IN ('''+isnull(@objst,'')+''', '''+isnull(@objut,'')+''', '''+isnull(@objv,'')+''', '''+isnull(@objsyn,'')+''')
      FOR READ ONLY;
      OPEN @tlst0'

       EXEC sp_executesql @sql,N'@tlst0 cursor output, @ParCidPattern sysname, @ParTblPattern sysname', 
	   @tlst0 output, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern
       FETCH @tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 1
      begin
set @sql = N'
SET @tlst1 = CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = ''V '' then ''V''
              when o.type =''U '' then ''T''
              when o.type = ''S '' then ''T''
              when o.type = ''SN''
               and bo.type = ''U ''
                or bo.type = ''S ''
                or bo.type = ''V '' then ''S''
              else ''X''
            end,
            isnull((SELECT MAX(i.rows)
                      FROM ['+ @dbname+'].sys.partitions i
                     WHERE i.object_id = o.object_id),0)
       FROM ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.indexes i RIGHT JOIN ['+ @dbname+'].sys.all_objects o
         ON i.object_id = o.object_id LEFT JOIN ['+ @dbname+'].sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN ['+ @dbname+'].sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name
      WHERE u.name like @ParCidPattern 
        AND o.schema_id = u.schema_id
        AND o.name = @ParTblPattern 
        AND o.type IN ('''+isnull(@objst,'')+''', '''+isnull(@objut,'')+''', '''+isnull(@objv,'')+''', '''+isnull(@objsyn,'')+''')
      FOR READ ONLY;
      OPEN @tlst1'

      EXEC sp_executesql @sql,N'@tlst1 cursor output, @ParCidPattern sysname, @ParTblPattern sysname', 
		@tlst1 output, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

        FETCH @tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 2
      begin
set @sql = N'
SET @tlst2 = CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = ''V '' then ''V''
              when o.type = ''U '' then ''T''
              when o.type = ''S '' then ''T''
              when o.type = ''SN''
               and bo.type = ''U ''
                or bo.type = ''S ''
                or bo.type = ''V '' then ''S''
              else ''X''
            end,
            isnull((SELECT MAX(i.rows)
                      FROM ['+ @dbname+'].sys.partitions i
                     WHERE i.object_id = o.object_id),0)
       FROM ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.indexes i RIGHT JOIN ['+ @dbname+'].sys.all_objects o
         ON i.object_id = o.object_id LEFT JOIN ['+ @dbname+'].sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN ['+ @dbname+'].sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name
      WHERE u.name = @ParCidPattern 
        AND o.schema_id = u.schema_id
        AND o.name like @ParTblPattern ESCAPE ''!''
        AND o.type IN ('''+isnull(@objst,'')+''', '''+isnull(@objut,'')+''', '''+isnull(@objv,'')+''', '''+isnull(@objsyn,'')+''')
      FOR READ ONLY;
      OPEN @tlst2'

        EXEC sp_executesql @sql,N'@tlst2 cursor output, @ParCidPattern sysname, @ParTblPattern sysname', 
		@tlst2 output, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

        FETCH @tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

    if @mode = 3
      begin
SET @sql = N'
SET @tlst3 = CURSOR FOR
     SELECT DISTINCT u.name, o.name,
            case
              when o.type = ''V '' then ''V''
              when o.type = ''U '' then ''T''
              when o.type = ''S '' then ''T''
              when o.type = ''SN''
               and bo.type = ''U ''
                or bo.type = ''S ''
                or bo.type = ''V '' then ''S''
              else ''X''
            end,
            isnull((SELECT MAX(i.rows)
                      FROM ['+ @dbname+'].sys.partitions i
                     WHERE i.object_id = o.object_id),0)
       FROM ['+ @dbname+'].sys.schemas u, ['+ @dbname+'].sys.indexes i RIGHT JOIN ['+ @dbname+'].sys.all_objects o
         ON i.object_id = o.object_id LEFT JOIN ['+ @dbname+'].sys.synonyms s
         on o.object_id = s.object_id LEFT JOIN ['+ @dbname+'].sys.all_objects bo
         on schema_id(parsename(s.base_object_name, 2)) = bo.schema_id
        and parsename(s.base_object_name, 1) = bo.name
      WHERE u.name like @ParCidPattern 
        AND o.schema_id = u.schema_id
        AND o.name like @ParTblPattern 
        AND o.type IN ('''+isnull(@objst,'')+''', '''+isnull(@objut,'')+''', '''+isnull(@objv,'')+''', '''+isnull(@objsyn,'')+''')
      FOR READ ONLY;
      OPEN @tlst3'

  EXEC sp_executesql @sql,N'@tlst3 cursor output, @ParCidPattern sysname, @ParTblPattern sysname', 
		@tlst3 output, @ParCidPattern = @CidPattern, @ParTblPattern = @TblPattern

        FETCH @tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows
      end

/*--------------------------------------------------------------------*
 *  Process the set of tables returned by the Query                   *
 *--------------------------------------------------------------------*/
    while (@@fetch_status = 0)
     begin
       insert into #tbllist values
              (@cid_name, @tbl_name, @tbl_type, @rows)

/*--------------------------------------------------------------------*
 *  Retrieve next record in result set                                *
 *--------------------------------------------------------------------*/
    if @mode = 0
        FETCH @tlst0 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 1
        FETCH @tlst1 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 2
        FETCH @tlst2 INTO @cid_name, @tbl_name, @tbl_type, @rows

    if @mode = 3
        FETCH @tlst3 INTO @cid_name, @tbl_name, @tbl_type, @rows

     end                               /* Loop thru result set        */

/*--------------------------------------------------------------------*
 *  Close the Query cursor                                            *
 *--------------------------------------------------------------------*/
    if @mode = 0
      begin
        CLOSE @tlst0
        deallocate @tlst0
      end

    if @mode = 1
      begin
        CLOSE @tlst1
        deallocate @tlst1
      end

    if @mode = 2
      begin
        CLOSE @tlst2
        deallocate @tlst2
      end

    if @mode = 3
      begin
        CLOSE @tlst3
        deallocate @tlst3
      end

/*--------------------------------------------------------------------*
 *  Select the returned data, if any, for the Primary Keys            *
 *--------------------------------------------------------------------*/
     select CidName, TblName, TblType, RowCnt
        from #tbllist
       where TblType <> 'X'
        order by CidName, TblName
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEME
       @Name     sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

SET @sql = N'
     select spf.name, ds.name, sps.data_space_id,
            sps.function_id, fanout
       from ['+ @dbname+'].sys.partition_schemes AS sps
           INNER JOIN ['+ @dbname+'].sys.partition_functions AS spf
         ON sps.function_id = spf.function_id
             inner join ['+ @dbname+'].sys.destination_data_spaces dds
         on dds.partition_scheme_id = sps.data_space_id
             inner join ['+ @dbname+'].sys.data_spaces ds
         on dds.data_space_id = ds.data_space_id
      where sps.name = @ParName 
      ORDER BY dds.destination_id'
 EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name

go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEMELIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set      @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.partition_schemes
       WHERE name = @ParName 
       order by name'
       EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end


    if @SelMode = 2
      begin
SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.partition_schemes
       WHERE name like @ParName 
       order by name'
       EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNC
       @Name     sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)

set      @dbname = ORIGINAL_DB_NAME()

     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

SET @sql = N'
     select pp.collation_name,
            SQL_VARIANT_PROPERTY (rv.value, ''BaseType''),
            CAST (rv.value AS varchar(4000)),
            pf.function_id, pp.max_length, pp.system_type_id,
            pp.precision, pp.scale, pf.boundary_value_on_right
       from ['+ @dbname+'].sys.partition_functions pf
             inner join ['+ @dbname+'].sys.partition_parameters pp
         on pf.function_id = pp.function_id
             inner join ['+ @dbname+'].sys.partition_range_values as rv
         ON rv.function_id = pf.function_id
      where pf.name = @ParName  
      ORDER BY rv.boundary_id'
EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
go

CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNCLIST
       @Owner    sysname,
       @Name     sysname,
       @SelMode  tinyint
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set      @dbname = ORIGINAL_DB_NAME()
     set nocount on
/*--------------------------------------------------------------------*
 *  Suspend Chained Transaction Mode for duration of this SP          *
 *--------------------------------------------------------------------*/
     if @@trancount = 0
     begin
       set implicit_transactions off
       set transaction isolation level READ COMMITTED
     end

/*--------------------------------------------------------------------*
 *  Execute the appropriate Select for the mode                       *
 *--------------------------------------------------------------------*/
    if @SelMode = 0
      begin
SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.partition_functions
       WHERE name = @ParName 
       order by name'
       EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end


    if @SelMode = 2
      begin
SET @sql = N'
      SELECT NULL,name
        FROM ['+ @dbname+'].sys.partition_functions
       WHERE name like @ParName 
       order by name'
       EXEC sp_executesql @sql, N'@ParName sysname', @ParName = @Name
      end
go


CREATE PROCEDURE ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDATACOMP
       @CidName   sysname,
       @ObjName   sysname
 AS
declare  @dbname   sysname
DECLARE  @sql      nvarchar(4000)
set      @dbname = ORIGINAL_DB_NAME()

 set nocount on
SET @sql = N'
 SELECT isnull(p.data_compression,0),
        isnull(p.data_compression_desc, '' ''),
        MIN(p.partition_number),
        MAX(p.partition_number),
        count(p.partition_number)
   FROM ['+ @dbname+'].sys.all_objects o
         left outer join ['+ @dbname+'].sys.indexes i
     ON o.object_id = i.object_id
         and (i.type = 0 or i.is_primary_key = 1)
     left outer join ['+ @dbname+'].sys.partitions p
     ON o.object_id = p.object_id
  WHERE o.schema_id = schema_id(@ParCidName)
    AND o.name = @ParObjName 
    AND (OBJECTPROPERTY(o.object_id,''IsTable'') = 1 or OBJECTPROPERTY(o.object_id,''IsView'') = 1)
    AND p.data_compression > 0
   GROUP BY p.data_compression, p.data_compression_desc
   ORDER BY MIN(p.partition_number)'
EXEC sp_executesql @sql, N'@ParCidName sysname, @ParObjName sysname', @ParCidName = @CidName, @ParObjName = @ObjName
go


grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSCIDOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPOBJECT to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPTBLENC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSEXPVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETVIEW to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETTBLLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEME to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARSCHEMELIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNC to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETPARFUNCLIST to ~ALTGRANTAUTHID
go

grant execute on ~ALTSPQUALIFIER..PSTM17V0100_CSSGETDATACOMP to ~ALTGRANTAUTHID
go

set implicit_transactions on
go

set quoted_identifier on
go

