/*--------------------------------------------------------------------*
 *  Oracle8 package used by Catalog Services to access Creator Id     *
 *  data from the Data Dictionary                                     *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO8IV0103_CSSCID AS

/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in               *
 *  this package                                                      *
 *--------------------------------------------------------------------*/
   TYPE t_creatorname   IS TABLE OF SYS.USER$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_creatornum    IS TABLE OF SYS.USER$.USER#%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Creator Names when pattern is an        *
 *  explicit value.                                                   *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCIDLIST0
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    CreatorNum           OUT t_creatornum);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Creator Names when pattern is a         *
 *  generic value.                                                    *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCIDLIST1
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    CreatorNum           OUT t_creatornum);

 END PSTO8IV0103_CSSCID;
/

grant execute on ~ALTSPQUALIFIER..PSTO8IV0103_CSSCID to ~ALTGRANTAUTHID
/

