/*--------------------------------------------------------------------*
 *  Oracle8 package used by Catalog Services to access Check          *
 *  data from the Data Dictionary                                     *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO8IV0104_CSSCHECK AS

/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in               *
 *  this package                                                      *
 *--------------------------------------------------------------------*/
   TYPE t_conname IS TABLE OF SYS.CON$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_conid      IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_colid      IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_enabled    IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_textlen    IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_deferflag  IS TABLE OF CHAR(1)
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Basic Check data from CON$,CDEF$,CCOL$  *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCHECK
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    ConName              OUT t_conname,
    ConId                OUT t_conid,
    ColId                OUT t_colid,
    Enabled              OUT t_enabled,
    TextLen              OUT t_textlen,
    Deferable            OUT t_deferflag,
    DeferInit            OUT t_deferflag,
    Validated            OUT t_deferflag);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Check text from CDEF$                   *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSEXPCHECK
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    OffsetNumIn           IN INTEGER,
    ColumnNumIn           IN INTEGER, /* not used */
    CheckText            OUT VARCHAR2);

 END PSTO8IV0104_CSSCHECK;
/

grant execute on ~ALTSPQUALIFIER..PSTO8IV0104_CSSCHECK to ~ALTGRANTAUTHID
/

