/*--------------------------------------------------------------------*
 * Oracle8i package used by Catalog Services to execute Oracle Unique *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO8IV0103_CSSEXECUTE AS

/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in               *
 *  this package                                                      *
 *--------------------------------------------------------------------*/
   TYPE t_creatorname   IS TABLE OF SYS.USER$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_dbmsint       IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_objectname    IS TABLE OF SYS.OBJ$.NAME%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire dependencies for a Schema name.         *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETDEPENDS
   (RowsToGet             IN INTEGER,
    CreatorNum            IN INTEGER,
    CreatorName           IN VARCHAR2,
    ReqCNum              OUT t_dbmsint,
    RefCNum              OUT t_dbmsint,
    ReqOType             OUT t_dbmsint,
    RefOType             OUT t_dbmsint,
    DepMode              OUT t_dbmsint,
    ReqCName             OUT t_creatorname,
    ReqOName             OUT t_objectname,
    RefCName             OUT t_creatorname,
    RefOName             OUT t_objectname);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire synonyms for a Schema name.             *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNS
   (RowsToGet             IN INTEGER,
    CreatorNum            IN INTEGER,
    CreatorName           IN VARCHAR2,
    ReqCNum              OUT t_dbmsint,
    RefCNum              OUT t_dbmsint,
    ReqOType             OUT t_dbmsint,
    RefOType             OUT t_dbmsint,
    DepMode              OUT t_dbmsint,
    ReqCName             OUT t_creatorname,
    ReqOName             OUT t_objectname,
    RefCName             OUT t_creatorname,
    RefOName             OUT t_objectname);

 END PSTO8IV0103_CSSEXECUTE;
/
grant execute on ~ALTSPQUALIFIER..PSTO8IV0103_CSSEXECUTE to ~ALTGRANTAUTHID
/

