/*--------------------------------------------------------------------*
 *  Oracle8 package used by Catalog Services to access objects        *
 *  that relate to Space Management from the Data Dictionary          *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO8IV0103_CSSSPCMGT AS

/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in               *
 *  this package                                                      *
 *--------------------------------------------------------------------*/
   TYPE t_spcnametype   IS TABLE OF SYS.TS$.NAME%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Tablespace Data from TS$                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETTBLSPC
   (RowsToGet             IN INTEGER,
    SpcNameIn             IN VARCHAR2,
    SpcObjId             OUT INTEGER);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when both names are explicit values                               *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSPCLIST
   (RowsToGet             IN INTEGER,
    SpcName              OUT t_spcnametype);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Database Signature Token                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSIGNATURE
   (RowsToGet             IN INTEGER,
    SignToken            OUT VARCHAR2);

 END PSTO8IV0103_CSSSPCMGT;
/

grant execute on ~ALTSPQUALIFIER..PSTO8IV0103_CSSSPCMGT to ~ALTGRANTAUTHID
/

