/*--------------------------------------------------------------------*
 *  Oracle9i package used by Catalog Services Synonyms                *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO92V0100_CSSSYNONYM AS
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this Package  *
 *--------------------------------------------------------------------*/
   TYPE t_ownername     IS TABLE OF SYS.USER$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_objectname       IS TABLE OF SYS.OBJ$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_integer       IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_char          IS TABLE OF CHAR(1)
         INDEX BY BINARY_INTEGER;
   TYPE t_proctext      IS TABLE OF VARCHAR2(254)
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to get Extended Data for a specific Procedure      *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNDATA
   (RowsToGet             IN INTEGER,
    CidName               IN VARCHAR2,
    SynName               IN VARCHAR2,
    ObjectNum            OUT INTEGER,
    CidNum               OUT INTEGER,
    RefNum               OUT INTEGER,
    RefType              OUT INTEGER,
    OPublic              OUT CHAR,
    Owner                OUT VARCHAR2,
    SynmName             OUT VARCHAR2,
    RefOwner             OUT VARCHAR2,
    RefName              OUT VARCHAR2,
    RefLink              OUT VARCHAR2);

/*--------------------------------------------------------------------*
 *  Procedure used to get Synonym List for explicit CID and Procs     *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNLIST0
   (RowsToGet             IN INTEGER,
    CidPattern            IN VARCHAR2,
    SynPattern            IN VARCHAR2,
    OPublic              OUT t_char,
    ORemote              OUT t_char,
    CidName              OUT t_ownername,
    SynName              OUT t_objectname,
    RefOwner             OUT t_ownername,
    RefName              OUT t_objectname);

/*--------------------------------------------------------------------*
 *  Get Procedure List for wildcard CID and explicit Synonym Name     *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNLIST1
   (RowsToGet             IN INTEGER,
    CidPattern            IN VARCHAR2,
    SynPattern            IN VARCHAR2,
    OPublic              OUT t_char,
    ORemote              OUT t_char,
    CidName              OUT t_ownername,
    SynName              OUT t_objectname,
    RefOwner             OUT t_ownername,
    RefName              OUT t_objectname);

/*--------------------------------------------------------------------*
 *  Get Procedure List for explicit CID and wildcard Synonym name     *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNLIST2
   (RowsToGet             IN INTEGER,
    CidPattern            IN VARCHAR2,
    SynPattern            IN VARCHAR2,
    OPublic              OUT t_char,
    ORemote              OUT t_char,
    CidName              OUT t_ownername,
    SynName              OUT t_objectname,
    RefOwner             OUT t_ownername,
    RefName              OUT t_objectname);

/*--------------------------------------------------------------------*
 *  Get Procedure List for wildcard CID and Synonym names             *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNLIST3
   (RowsToGet             IN INTEGER,
    CidPattern            IN VARCHAR2,
    SynPattern            IN VARCHAR2,
    OPublic              OUT t_char,
    ORemote              OUT t_char,
    CidName              OUT t_ownername,
    SynName              OUT t_objectname,
    RefOwner             OUT t_ownername,
    RefName              OUT t_objectname);
 END PSTO92V0100_CSSSYNONYM;
/

grant execute on ~ALTSPQUALIFIER..PSTO92V0100_CSSSYNONYM to ~ALTGRANTAUTHID
/

