/*--------------------------------------------------------------------*
 *  Oracle9i package Catalog Services Primary Keys                    *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO01V0100_CSSPKDEF AS
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this Package  *
 *--------------------------------------------------------------------*/
   TYPE t_colnametype   IS TABLE OF SYS.COL$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_keypostype        IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_pknametype    IS TABLE OF SYS.CON$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_pkobjtype   IS TABLE OF SYS.CDEF$.CON#%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_pkidxobjtype IS TABLE OF SYS.CDEF$.ENABLED%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_creatorname   IS TABLE OF SYS.USER$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_tablename     IS TABLE OF SYS.OBJ$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_deferflag  IS TABLE OF CHAR(1)
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Primary Key Data from COL$ and CCOL$    *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETPKDEF
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    PkDName              OUT t_pknametype,
    PkDObjId             OUT t_pkobjtype,
    PkDIdxObjId          OUT t_pkidxobjtype,
    ColName              OUT t_colnametype,
    KeyPos               OUT t_keypostype,
    Deferable            OUT t_deferflag,
    DeferInit            OUT t_deferflag,
    Validated            OUT t_deferflag);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when both names are explicit values                               *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETPKDLIST0
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    TblPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    TableName            OUT t_tablename);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when Creator is a LIKE value and Table is explicit                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETPKDLIST1
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    TblPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    TableName            OUT t_tablename);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when Creator is explicit and Table is a LIKE value                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETPKDLIST2
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    TblPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    TableName            OUT t_tablename);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when both names are LIKE values                                   *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETPKDLIST3
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    TblPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    TableName            OUT t_tablename);
 END PSTO01V0100_CSSPKDEF;
/

grant execute on ~ALTSPQUALIFIER..PSTO01V0100_CSSPKDEF to ~ALTGRANTAUTHID
/

