/*--------------------------------------------------------------------*
 *  Oracle9i package Catalog Services execute Oracle Services         *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO11V0100_CSSEXECUTE AS

/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in               *
 *  this package                                                      *
 *--------------------------------------------------------------------*/
   TYPE t_creatorname   IS TABLE OF SYS.USER$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_dbmsint       IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_objectname    IS TABLE OF SYS.OBJ$.NAME%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire dependencies for a Schema name.         *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETDEPENDS
   (RowsToGet             IN INTEGER,
    CreatorNum            IN INTEGER,
    CreatorName           IN VARCHAR2,
    ReqCNum              OUT t_dbmsint,
    RefCNum              OUT t_dbmsint,
    ReqOType             OUT t_dbmsint,
    RefOType             OUT t_dbmsint,
    DepMode              OUT t_dbmsint,
    ReqCName             OUT t_creatorname,
    ReqOName             OUT t_objectname,
    RefCName             OUT t_creatorname,
    RefOName             OUT t_objectname);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire synonyms for a Schema name.             *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSYNS
   (RowsToGet             IN INTEGER,
    CreatorNum            IN INTEGER,
    CreatorName           IN VARCHAR2,
    ReqCNum              OUT t_dbmsint,
    RefCNum              OUT t_dbmsint,
    ReqOType             OUT t_dbmsint,
    RefOType             OUT t_dbmsint,
    DepMode              OUT t_dbmsint,
    ReqCName             OUT t_creatorname,
    ReqOName             OUT t_objectname,
    RefCName             OUT t_creatorname,
    RefOName             OUT t_objectname);
    
/*--------------------------------------------------------------------*
 *  Procedure used to acquire system partition counts                 *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCOUNTS
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    ColNum               OUT INTEGER,
    SegCol               OUT INTEGER);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire system partition names                  *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETNAME
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    SpcName              OUT t_objectname);

 END PSTO11V0100_CSSEXECUTE;
/
grant execute on ~ALTSPQUALIFIER..PSTO11V0100_CSSEXECUTE to ~ALTGRANTAUTHID
/

