/*--------------------------------------------------------------------*
 *  Oracle112 package used by Catalog Services for Encryption         *
 *--------------------------------------------------------------------*/
 CREATE OR REPLACE PACKAGE BODY ~ALTSPQUALIFIER..PSTO1IV0100_CSSENCRYPT AS

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Encryption algorithm                    *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETENCALG
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    Encalg               OUT INTEGER) is

 BEGIN

     SELECT case de.ENCRYPTION_ALG when '3 Key Triple DES 168 bits key' then 1
                                   when 'AES 128 bits key' then 2
                                   when 'AES 192 bits key' then 3
                                   when 'AES 256 bits key' then 4
                                   else 0
            end
       INTO Encalg
       FROM ALL_OBJECTS ao, dba_encrypted_columns de
      WHERE ao.OBJECT_ID = ObjectNumIn
        AND de.OWNER = ao.OWNER
        and de.TABLE_NAME = ao.OBJECT_NAME;

 END PSTV0100_CSSGETENCALG;
END PSTO1IV0100_CSSENCRYPT;



