 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO12V0100_CSSCID AS
/*
    Oracle12C package used by Catalog Services for Creator Names.

    Licensed Materials - Property of IBM

    "Restricted Materials of IBM"

    5724-U38, 5724-U39, 5724-U48

     Copyright IBM Corp. 2017 All Rights Reserved

     Copyright 2017 UNICOM Systems, Inc. - All Rights Reserved

    US Government Users Restricted Rights - Use, duplication or
    disclosure restricted by GSA ADP Schedule Contract with
    IBM Corp.
*/
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this package  *
 *--------------------------------------------------------------------*/
   TYPE t_creatorname   IS TABLE OF SYS.DBA_USERS.USERNAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_creatornum    IS TABLE OF SYS.DBA_USERS.USER_ID%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Creator Names when pattern is an        *
 *  explicit value.                                                   *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCIDLIST0
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    CreatorNum           OUT t_creatornum);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Creator Names when pattern is a         *
 *  generic value.                                                    *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCIDLIST1
   (RowsToGet             IN INTEGER,
    CidPatternIn          IN VARCHAR2,
    CreatorName          OUT t_creatorname,
    CreatorNum           OUT t_creatornum);
 END PSTO12V0100_CSSCID;
/

grant execute on ~ALTSPQUALIFIER..PSTO12V0100_CSSCID to ~ALTGRANTAUTHID
/

