 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO12V0100_CSSCHECK AS
/*
    Oracle12C package used by Catalog Services for Check Constraints

    Licensed Materials - Property of IBM

    "Restricted Materials of IBM"

    5724-U38, 5724-U39, 5724-U48

     Copyright IBM Corp. 2017 All Rights Reserved

     Copyright 2017 UNICOM Systems, Inc. - All Rights Reserved

    US Government Users Restricted Rights - Use, duplication or
    disclosure restricted by GSA ADP Schedule Contract with
    IBM Corp.
*/
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this Package  *
 *--------------------------------------------------------------------*/
   TYPE t_cnm     IS TABLE OF SYS.CON$.NAME%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_int        IS TABLE OF INTEGER
         INDEX BY BINARY_INTEGER;
   TYPE t_chr        IS TABLE OF CHAR(1)
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Basic Check data from CON$,CDEF$,CCOL$  *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETCHECK
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    ConName              OUT t_cnm,
    ConId                OUT t_int,
    ColId                OUT t_int,
    Enabled              OUT t_int,
    TextLen              OUT t_int,
    Deferable            OUT t_chr,
    DeferInit            OUT t_chr,
    Validated            OUT t_chr);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Check text from CDEF$                   *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSEXPCHECK
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    OffsetNumIn           IN INTEGER,
    ColumnNumIn           IN INTEGER, /* not used */
    CheckText            OUT VARCHAR2);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Supplemntal Log Groups                  *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSUPPL
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    ConName              OUT t_cnm,
    ConId                OUT t_int,
    ColId                OUT t_int,
    DeferInit            OUT t_chr);
 END PSTO12V0100_CSSCHECK;
/

grant execute on ~ALTSPQUALIFIER..PSTO12V0100_CSSCHECK to ~ALTGRANTAUTHID
/

