 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO12V0100_CSSCHECKNAMESPACE AS
/*
    Oracle12C package used by Catalog Services for Check Name space

    Licensed Materials - Property of IBM

    "Restricted Materials of IBM"

    5724-U38, 5724-U39, 5724-U48

     Copyright IBM Corp. 2017 All Rights Reserved

     Copyright 2017 UNICOM Systems, Inc. - All Rights Reserved

    US Government Users Restricted Rights - Use, duplication or
    disclosure restricted by GSA ADP Schedule Contract with
    IBM Corp.
*/
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this Package  *
 *--------------------------------------------------------------------*/
   TYPE t_line     IS TABLE OF SYS.ERROR$.LINE%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_position IS TABLE OF SYS.ERROR$.POSITION#%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_seqno    IS TABLE OF SYS.ERROR$.SEQUENCE#%TYPE
         INDEX BY BINARY_INTEGER;
   TYPE t_text     IS TABLE OF SYS.ERROR$.TEXT%TYPE
         INDEX BY BINARY_INTEGER;

 PROCEDURE PSTV0100_CSSCHECKNAMESPACE
   (RowsToGet           IN INTEGER,
    CreatorName         IN VARCHAR2,
    ObjectName          IN VARCHAR2,
    QualifierName       IN VARCHAR2,
    QualifierCreator    IN VARCHAR2,
    ObjType             IN INTEGER,
    FoundObjType       OUT INTEGER,
    ConflictCreator    OUT VARCHAR2,
    ConflictName       OUT VARCHAR2
   );

 PROCEDURE PSTV0100_CSSGETERRMSG
   (RowsToGet           IN INTEGER,
    CreatorName         IN VARCHAR2,
    ObjectName          IN VARCHAR2,
    ObjType             IN INTEGER,
    LineNo             OUT t_line,
    Position           OUT t_position,
    SeqNo              OUT t_seqno,
    ErrMsg             OUT t_text
   );
 END PSTO12V0100_CSSCHECKNAMESPACE;
/

grant execute on ~ALTSPQUALIFIER..PSTO12V0100_CSSCHECKNAMESPACE to ~ALTGRANTAUTHID
/

