 CREATE OR REPLACE PACKAGE BODY ~ALTSPQUALIFIER..PSTO12V0100_CSSENCRYPT AS
/*
    Oracle12C package used by Catalog Services for Encryption

    Licensed Materials - Property of IBM

    "Restricted Materials of IBM"

    5724-U38, 5724-U39, 5724-U48

     Copyright IBM Corp. 2017 All Rights Reserved

     Copyright 2017 UNICOM Systems, Inc. - All Rights Reserved

    US Government Users Restricted Rights - Use, duplication or
    disclosure restricted by GSA ADP Schedule Contract with
    IBM Corp.
*/

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Encryption algorithm                    *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETENCALG
   (RowsToGet             IN INTEGER,
    ObjectNumIn           IN INTEGER,
    Encalg               OUT INTEGER) is

 BEGIN

     SELECT case de.ENCRYPTION_ALG when '3 Key Triple DES 168 bits key' then 1
                                   when 'AES 128 bits key' then 2
                                   when 'AES 192 bits key' then 3
                                   when 'AES 256 bits key' then 4
                                   else 0
            end
       INTO Encalg
       FROM ALL_OBJECTS ao, dba_encrypted_columns de
      WHERE ao.OBJECT_ID = ObjectNumIn
        AND de.OWNER = ao.OWNER
        and de.TABLE_NAME = ao.OBJECT_NAME
        FETCH FIRST 1 ROWS ONLY;

 END PSTV0100_CSSGETENCALG;
END PSTO12V0100_CSSENCRYPT;



