 CREATE OR REPLACE PACKAGE ~ALTSPQUALIFIER..PSTO12V0100_CSSSPCMGT AS
/*
    Oracle12C package used by Catalog Services for Space Management

    Licensed Materials - Property of IBM

    "Restricted Materials of IBM"

    5724-U38, 5724-U39, 5724-U48

     Copyright IBM Corp. 2017 All Rights Reserved

     Copyright 2017 UNICOM Systems, Inc. - All Rights Reserved

    US Government Users Restricted Rights - Use, duplication or
    disclosure restricted by GSA ADP Schedule Contract with
    IBM Corp.
*/
/*--------------------------------------------------------------------*
 *  Declare the PL/SQL Tables used by the Procedures in this Package  *
 *--------------------------------------------------------------------*/
   TYPE t_spcnametype   IS TABLE OF SYS.TS$.NAME%TYPE
         INDEX BY BINARY_INTEGER;

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Tablespace Data from TS$                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETTBLSPC
   (RowsToGet             IN INTEGER,
    SpcNameIn             IN VARCHAR2,
    SpcObjId             OUT INTEGER);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire PK List from Creator/Table patterns     *
 *  when both names are explicit values                               *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSPCLIST
   (RowsToGet             IN INTEGER,
    SpcName              OUT t_spcnametype);

/*--------------------------------------------------------------------*
 *  Procedure used to acquire Database Signature Token                *
 *--------------------------------------------------------------------*/
 PROCEDURE PSTV0100_CSSGETSIGNATURE
   (RowsToGet             IN INTEGER,
    SignToken            OUT VARCHAR2);
 END PSTO12V0100_CSSSPCMGT;
/

grant execute on ~ALTSPQUALIFIER..PSTO12V0100_CSSSPCMGT to ~ALTGRANTAUTHID
/

