#!/bin/sh
#
#   Licensed Materials - Property of IBM
#
#   "Restricted Materials of IBM"
#
#   5724-U38, 5724-U39, 5724-U48
#
#   © Copyright IBM Corp. 2008, 2021 All Rights Reserved
#
#   © Copyright 2021 UNICOM® Systems, Inc. - All Rights Reserved
#
#   US Government Users Restricted Rights - Use, duplication or
#   disclosure restricted by GSA ADP Schedule Contract with
#   IBM Corp.
#

if [ ! -d /tmp/softech ]; then
      mkdir /tmp/softech
fi

if [ -f /tmp/softech/icu_err_flag ]; then
      rm /tmp/softech/icu_err_flag 
fi

if [ -z $1 -o ! -d $1 ]; then
    echo Destination directory $1 does not exist
    touch /tmp/softech/icu_err_flag 
    exit 1
fi

OPSYS=`uname -s`

cd $1

case $OPSYS in
   AIX)
      tar -xf ICUIBM.tar
      if [ $? -ne 0 ]; then
          touch /tmp/softech/icu_err_flag 
          exit 1
      fi
      rm ICUIBM.tar
      ;;
   Linux)
      if [ `uname -m` = x86_64 ]; then
	    tar -xf ICULIN64.tar 
	    if [ $? -ne 0 ]; then
           touch /tmp/softech/icu_err_flag 
           exit 1
        fi
	    rm ICULIN64.tar 
	  else
        tar -xf ICULIN.tar
        if [ $? -ne 0 ]; then
           touch /tmp/softech/icu_err_flag 
           exit 1
        fi
        rm ICULIN.tar
      fi
      ;;
   *)
      echo Unknown OS
      touch /tmp/softech/icu_err_flag 
      exit 1
    ;;
esac

exit 0
