<?xml version="1.0" encoding="ISO-8859-1"?>
<xsl:stylesheet version="1.0"
	xmlns:xsl="http://www.w3.org/1999/XSL/Transform" xmlns:optim="http://www.ibm.com/optim/audit/v11.3.0.0"
	xmlns:optimreport="http://www.ibm.com/optim/report/v11.3.0.0"
	xmlns:optimcommon="http://www.ibm.com/optim/common/v11.3.0.0" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance">

	<xsl:import href="CommonTemplates.xsl"/>
	<xsl:output method="html" indent="yes" version="4.0"
		doctype-public="-//W3C//DTD HTML 4.01//EN" doctype-system="http://www.w3.org/TR/html4/strict.dtd" />
	
	<!-- BEGIN Overrides Section -->
	<xsl:template match="optimreport:overrides">
		<xsl:call-template name="anchorSetup">
			<xsl:with-param name="name">overrides</xsl:with-param>
		</xsl:call-template>
		
		<!-- Overrides Banner -->
		<xsl:call-template name="titleBar">
			<xsl:with-param name="name">Overrides</xsl:with-param>
			<xsl:with-param name="containerId">overrides_container</xsl:with-param>
			<xsl:with-param name="containerClass">overrides_container_class</xsl:with-param>
			<xsl:with-param name="anchor">overrides</xsl:with-param>
			<xsl:with-param name="closeByDefault">false</xsl:with-param>
		</xsl:call-template>
		
		<!-- Overrides Contents -->
		<div class="section_container overrides_container_class" id="overrides_container" inAllAction="true">
			<table>	
				<!-- Column titles for the Overrides Table -->
				<tr istitle="yes">
					<th class="category_title">
						<center><xsl:text>Sequence</xsl:text></center>
					</th>
					<td class="category_title">
						<center><xsl:text>Keyword</xsl:text></center>
					</td>
					<td class="category_title">
						<center><xsl:text>Value</xsl:text></center>
					</td>
				</tr>
				<!-- Overrides Table Data -->
				<xsl:for-each select="optimreport:override">
					<tr>
						<th style="text-align:center">
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="@sequence"/>
							</xsl:call-template>
						</th>
						<td style="text-align:left">
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="@keyword"/>
							</xsl:call-template>
						</td>
						<td style="text-align:left">
							<xsl:call-template name="stringCheck">
								<xsl:with-param name="value" select="@value"/>
							</xsl:call-template>
						</td>
					</tr>
				</xsl:for-each>
			</table>
		</div>
	</xsl:template>
	<!-- END Overrides Section -->
	
</xsl:stylesheet>

