#!/bin/sh

if [ ! -d /tmp/softech ]; then
      mkdir /tmp/softech
fi

if [ -f /tmp/softech/xerces_err_flag ]; then
      rm /tmp/softech/xerces_err_flag 
fi

if [ -z $1 -o ! -d $1 ]; then
    echo Destination directory $1 does not exist
    touch /tmp/softech/xerces_err_flag
    exit 1
fi

OPSYS=`uname -s`

cd $1

case $OPSYS in 
   AIX)
      tar -xf xercaix.tar
      if [ $? -ne 0 ]; then
          touch /tmp/softech/xerces_err_flag
          exit 1
      fi
      rm xercaix.tar
      ;;
   HP-UX)
    if [ `uname -m` = ia64 ]; then
      tar -xof xerchpux_ia.tar   ### tar -xf works for Linux platforms. But on Itanium it works with only tar -xof ###
      if [ $? -ne 0 ]; then
	 touch /tmp/softech/xerces_err_flag
	    exit 1
	    fi
	    rm xerchpux_ia.tar
     
    else
      tar -xf xerchpux.tar
      if [ $? -ne 0 ]; then
          touch /tmp/softech/xerces_err_flag
          exit 1
      fi
      rm xerchpux.tar
    fi   
     ;;
   Linux)
      if [ `uname -m` = x86_64 ]; then
	    tar -xf xerclin64.tar 
	    if [ $? -ne 0 ]; then
           touch /tmp/softech/xerces_err_flag
           exit 1
        fi
        rm xerclin64.tar
	  else
        tar -xf xerclin.tar
        if [ $? -ne 0 ]; then
           touch /tmp/softech/xerces_err_flag
           exit 1
        fi
        rm xerclin.tar
      fi
      ;;
   SunOS)
      tar -xf xercsun.tar
      if [ $? -ne 0 ]; then
          touch /tmp/softech/xerces_err_flag
          exit 1
      fi
      rm xercsun.tar
      ;;
   *)
      echo Unknown OS
      touch /tmp/softech/xerces_err_flag
      exit 1
    ;;
esac

exit 0
